2005-10-01  Daniel Burrows  <dburrows@debian.org>

	* NEWS:

	  Add some missing entries and bug numbers.

	* Makefile.am:

	  Distribute the other READMEs.

	* NEWS:

	  Mention the build script migration.

	* configure.ac, src/aptitude.h:

	  Deal with the fact that the old gettext/autoools generated a
	  test for locale.h and setlocale but the new one doesn't.  I
	  could stop using the test, but instead I decided to just test
	  explicitly for them and define the appropriate variables if
	  they're found.

	* src/aptitude.h:

	  Instead of using #define to empty setlocale, inline it.  This
	  still fails to compile, but the error is a lot more obvious.

	* ***:

	  Rebuilt all of the autotools and gettext junk from scratch using
	  automake-1.9.  In theory this will make VPATH builds work
	  (xgettext was failing); however, I'm going to wait and see.  It
	  does mean that I am no longer using old crufty versions of the
	  tools, though.

	* Makefile.am:

	  On the other hand, the non-generated manual files really *are*
	  in $(srcdir).

	* doc/en/Makefile.am, doc/fi/Makefile.am, doc/fr/Makefile.am:

	  Also pick up README from '.', not $(srcdir).

	* doc/cs/Makefile.am, doc/de/Makefile.am, doc/en/Makefile.am, doc/fi/Makefile.am, doc/fr/Makefile.am:

	  Whoops, there is no $(builddir) -- it's just '.' in rules.

	* doc/cs/Makefile.am, doc/de/Makefile.am, doc/en/Makefile.am, doc/fi/Makefile.am, doc/fr/Makefile.am:

	  Consistently put the output directories in $(builddir), not
	  $(srcdir).

	* src/mine/Makefile.am:

	  Use $(wildcard) instead of listing all the help texts
	  explicitly.

	* Makefile.am:

	  Use $(wildcard) for some wildcarded filenames so that VPATH
	  builds work.

	* doc/fi/Makefile.am, doc/fr/Makefile.am:

	  Fix up some more documentation Makefiles that I missed
	  previously.

	* doc/cs/Makefile.am, doc/de/Makefile.am, doc/en/Makefile.am, doc/fi/Makefile.am, doc/fr/Makefile.am:

	  Fix the documentation Makefiles to refer symbolically to the
	  souce directory using $(srcdir) instead of directly via '..' and
	  '.'.

	* NEWS:

	  Add a comment about whitespace in patterns, change the quote.

	* Makefile.am:

	  Put intl before the other subdirectories, so builds with an
	  included libintl work.

2005-09-30  Daniel Burrows  <dburrows@debian.org>

	* src/download_screen.h:

	  Fix the #include of config.h. (done previously but I forgot to
	  save!  ah the irony)

	* configure.ac:

	  Bump the version to 0.3.4.

	* src/mine/Makefile.am:

	  Explicitly list all of the minesweeper help files -- apparently
	  automake's "make dist" target doesn't expand wildcards.

	* src/mine/Makefile.am:

	  Add top_builddir to Minesweeper's include path as well.

	* src/generic/util/Makefile.am:

	  Add slotarg.h to the list of sources for libgeneric-util.

	* src/aptitude.h, src/main.cc, src/pkg_ver_item.h, src/ui.cc, src/vscreen/curses++.h, src/vscreen/vscreen_widget.cc:

	  Change a bunch of includes of config.h to use <>, and protect
	  the ones that weren't with #ifdef HAVE_CONFIG_H.

	* src/generic/util/Makefile.am:

	  Add bool_accumulate.h to the list of generic sources.

	* src/vscreen/Makefile.am:

	  Add ref_ptr.h to the list of vscreen sources.

	* src/generic/problemresolver/Makefile.am:

	  Forgot to add resolver_undo.h to EXTRA_DIST so that it gets
	  distributed; do so.

	* src/Makefile.am, src/cmdline/Makefile.am, src/generic/apt/Makefile.am, src/generic/problemresolver/Makefile.am, src/generic/util/Makefile.am, src/vscreen/Makefile.am, src/vscreen/config/Makefile.am, tests/Makefile.am:

	  Include $(top_builddir) so we can get config.h in VPATH builds
	  (e.g., in 'make distcheck').

	* doc/en/aptitude.xml:

	  Correct a strange turn of phrase.

	* src/vscreen/Makefile.am:

	  Remove references to some .h files that got moved down to
	  generic/.

	* src/vscreen/vscreen_widget.cc:

	  Allow destroy() to be called multiple times but ignore it after
	  the first call.  This allows download widgets to destroy
	  themselves immediately upon being cancelled, even though the
	  download process will also issue a destroy command on its own.

	* src/ui.cc, src/ui_download_manager.cc, src/ui_download_manager.h:

	  Fix more compile problems.

	* src/download_list.cc, src/download_list.h:

	  Fix compilation errors.

	* src/download_list.cc:

	  Actually use abortslot when a download is cancelled.

	* src/ui.cc, src/ui.h, src/ui_download_manager.cc, src/ui_download_manager.h:

	  Expose the widget that's handling the download status, so it can
	  be explicitly kept alive as long as the download lasts
	  (regardless of its destruction).

	* src/download_list.cc:

	  Always destroy a download list when destroy() is called, even
	  though "cancel" is a side-effect.

	* src/ui.cc:

	  Don't let mini-buffer downloads overload the Q key.

	* NEWS:

	  Update the NEWS file for 0.3.4 (may get additional updates).

	* po/POTFILES.in:

	  Update the list of files.

	* src/ui.cc:

	  Editorial change to the no-cache-modification-during-a-download
	  message.

	* src/solution_item.cc:

	  Reinstate the advance-after-action behavior of solution items.

	* doc/en/images/Makefile.am:

	  Update the list of distributed images.

	* doc/en/aptitude.xml:

	  More fully document the resolver (the prose is a little stilted
	  in some places but it'll do for a first draft).

	* src/generic/problemresolver/model.tex:

	  Add a disclaimer regarding the stupidity-removal algorithm.

	* src/apt_options.cc:

	  Add an option item for suppress-read-only-warning.

	* src/ui.cc:

	  Make prompt_yesno_popup not always default to 'yes'.
	  (I confused the scrollbar parameter with the default parameter
	  -- arguably this is a sign that vs_dialog_yesno's interface is
	  way too hariy).

	* src/vscreen/vs_multiplex.cc:

	  Bind weak references instead of strong references.

	* src/cmdline/cmdline_update.cc:

	  Fix a silly compile problem.

	* doc/en/aptitude.xml:

	  Fix the documentation as regards the default resolver scores.

	* doc/en/aptitude.xml:

	  Document several undocumented configuration options.

	* doc/en/aptitude.xml:

	  Typo fix.

	* src/cmdline/cmdline_update.cc, src/generic/apt/download_update_manager.cc, src/ui.cc:

	  Add some missing connections to the download managers' hooks.

	* src/cmdline/cmdline_changelog.cc:

	  Kill off some memory leaks.

	* src/changelog_parse.cc:

	  Instead of using the description parser to generate formatted
	  changelogs, just parse them by hand; the bulletting conventions
	  are not, unfortunately, as well-defined as for descriptions.

	* src/menu_text_layout.cc, src/menu_text_layout.h:

	  Make the search keystrokes active in the menu_text_layout
	  widget.

	* src/view_changelog.cc:

	  Use a menu_text_layout instead of a vs_text_layout to display
	  the changelog, and hook it up to the menu signals.

	* src/menu_text_layout.cc, src/menu_text_layout.h:

	  Write a vs_text_layout variant customized to hook the menu's
	  search command up to itself.

	* src/vscreen/vs_text_layout.cc, src/vscreen/vs_text_layout.h:

	  Write basic code for searching in a vs_text_layout.

2005-09-29  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml, src/Makefile.am, src/changelog_parse.cc, src/changelog_parse.h, src/defaults.cc, src/generic/util/temp.h, src/view_changelog.cc:

	  Add support for parsing changelogs and doing something useful
	  with the information therein.  In particular, changelogs are now
	  wrapped like descriptions (and get bullet parsing for free), and
	  newer versions of the package are highlighted.  (Closes: #290692)

	* src/generic/util/temp.h:

	  Allow clients to extract the parent directory of temporary
	  objects.

	* src/cmdline/cmdline_do_action.cc:

	  Fix a nasty bug: when constructing the download manager in
	  do_action, I was actually (and accidentally) constructing a
	  manager on the heap, implicitly casting it to bool (hence always
	  getting 'true') and then passing that as download_only to the
	  true manager.  Obviously this is not quite what was desired.

	* src/ui.cc, src/ui_download_manager.cc, src/ui_download_manager.h, src/view_changelog.cc:

	  Require code that creates a ui_download_manager to set all the
	  usual parameters for its internal download status widget, and
	  change all the creation points to do so (resurrecting the
	  various title strings that got lost earlier).

	* src/cmdline/cmdline_changelog.cc:

	  Fix the command-line changelog code: binding a reference doesn't
	  really work, you have to bind a pointer to the object you want
	  to set instead.

	* src/cmdline/cmdline_changelog.cc, src/view_changelog.cc:

	  Update the changelog viewers for the new interface.

	* src/generic/apt/pkg_changelog.cc, src/generic/apt/pkg_changelog.h:

	  Base the package changelog downloader on the download_manager
	  class.

	* src/Makefile.am, src/download.cc, src/download.h:

	  Remove the old download code.

	* src/cmdline/cmdline_upgrade.cc:

	  Use the download_manager code for upgrades too.

	* src/pkg_item.cc, src/pkg_tree.cc:

	  Eliminate more unnecessary #includes.

	* src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_update.cc:

	  Eliminate some unnecessary #includes.

	* src/cmdline/cmdline_update.cc:

	  Use the download_manager code in 'update'.

	* src/cmdline_do_action.cc:

	  Use the download_manager code to handle stuff that gets kicked
	  to do_action.

	* src/cmdline_util.cc, src/cmdline_util.h:

	  Write generic code to execute a download object from the
	  command-line.

	* src/ui_download_manager.cc:

	  Actually use both ui_start_download and ui_stop_download.

	* src/ui.cc, src/generic/download_install_manager.cc, src/generic/download_update_manager.cc:

	  Implement the before/after hooks in the UI to shut down curses
	  and to display a message while automatic autocleaning is
	  happening.

	* src/ui.cc:

	  Implement ui_stop_download.

	* po/POTFILES.in, src/Makefile.am, src/ui.cc, src/ui.h, src/ui_download_manager.cc, src/ui_download_manager.h:

	  Split the wrapper class into another file.  Added some public UI
	  routines to allow other code to manipulate the "is something
	  downloading now?" state.

	* src/ui.cc:

	  Instead of subclassing the download managers, use a generic
	  wrapper class that takes a manager as a constructor parameter.

	* src/generic/apt/download_manager.h, src/generic/apt/download_install_manager.h, src/generic/apt/download_install_manager.cc, src/ui.cc:

	  Make prepare() part of the generic download_manager interface
	  (additional arguments should be 'passed' in the constructor
	  now).  This will pave the way for fully generic code in the UI
	  to handle a download.

	* src/generic/apt/download_install_manager.cc, src/generic/apt/download_install_manager.h, src/ui.cc:

	  Make download_only a constructor parameter of the
	  download_install_manager, not an argument of finish().

	* src/generic/apt/download_update_manager.cc:

	  Instead of creating an Acquire object with no status callback,
	  pass our status callback into its constructor; also save the
	  signal generator in signallog rather than just ignoring it.

	* src/ui.cc:

	  First cut at using the download_manager code instead of the old
	  download code.

	* src/download_thread.cc, src/download_thread.h:

	  Accept download managers instead of acquire objects as the
	  thread parameter.

	* src/generic/apt/download_manager.h:

	  Make download managers SigC++ trackable objects.

	* src/generic/apt/download_install_manager.cc, src/generic/apt/download_install_manager.h, src/generic/apt/log.cc, src/generic/apt/log.h:

	  Split the log code from the download code.

	* po/POTFILES.in, src/generic/apt/download_install_manager.cc, src/generic/apt/download_install_manager.h, src/generic/apt/download_manager.cc, src/generic/apt/download_manager.h, src/generic/apt/download_update_manager.cc, src/generic/apt/download_update_manager.h, src/generic/apt/Makefile.am:

	  Write a generic interface to manage operations that involve
	  downloading something and then doing more stuff, and transform
	  the old download code into subclasses of this interface.

	* src/cmdline/cmdline_changelog.cc, src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_download.cc, src/cmdline/cmdline_progress.cc, src/cmdline/cmdline_progress.h, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_update.cc, src/cmdline/cmdline_upgrade.cc, src/download.cc, src/download.h, src/download_list.cc, src/download_list.h, src/download_thread.cc, src/download_thread.h, src/generic/apt/acqprogress.cc, src/generic/apt/acqprogress.h, src/generic/apt/Makefile.am, src/Makefile.am, src/ui.cc, src/ui.h, src/view_changelog.cc:

	  Update include file locations and class names to refer to
	  download_signal_log instead of download_manager.

	* src/download_manager.cc, src/download_manager.h, src/generic/apt/download_signal_log.cc, src/generic/apt/download_signal_log.h:

	  Move the download_manager code into the generic layer and rename
	  it.

2005-09-27  Daniel Burrows  <dburrows@debian.org>

	* src/view_changelog.cc:

	  Since the changelog pager reads in the whole changelog when it's
	  constructed, it no longer needs to ensure that the changelog
	  file (object) exists as long as the pager does; delete the file
	  object as soon as we finish reading it.

	* src/generic/util/exception.h:

	  Update the exception documentation to match reality.

	* configure.ac:

	  Fix the enabling of dynamic backtraces.

	* configure.ac, src/generic/util/exception.cc:

	  Make the dynamic generation of backtraces a configure-time
	  option; in order for them to be useful, a full symbol table
	  needs to be shipped with the program, and in the case of
	  aptitude, this DOUBLES the executable size.

	* configure.ac:

	  Put libraries detected by configure into LIBS, not LDFLAGS.

	* configure.ac, src/generic/util/Makefile.am, src/generic/util/exception.cc, src/generic/util/exception.h, src/main.cc, tests/Makefile.am:

	  Add support for backtracing the program when creating an
	  exception on systems that support it.  (currently rather broken)

	* src/download.cc:

	  Remove the assumption that stdin is line-buffered; explicitly
	  search for a \n character (and handle EOF conditions).

	* src/main.cc, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_prompt.h:

	  Toss an exception from the command-line code when EOF is
	  encountered, and write a corresponding catch handler; also
	  replace the special-cased catch blocks in main.cc with generic
	  catches for the Exception type (so the exception gets printed to
	  stderr).  In particular, this means that aptitude no longer goes
	  nuts when it encounters an EOF.  (Closes: #318749)

	* src/ui.cc:

	  Check for the existence of the old temporary directory on
	  startup and display a one-time prompt asking whether it should
	  be removed (currently defaults to "no").

	* src/ui.cc:

	  When su-ing to root, use temp::* instead of making the needed
	  temporary names manually.  (Closes: #146485)

	* src/generic/apt/pkg_changelog.cc, src/generic/apt/pkg_changeloh.h:

	  Use the temp::* classes to manage the changelog instead of
	  manually constructing a temporary name.

	* src/generic/util/Makefile.am, src/generic/util/temp.cc, src/generic/util/temp.h, tests/Makefile.am, tests/test_temp.cc:

	  Add C++-based support code for securely creating and cleaning up
	  temporary files and directories.

	* src/vscreen/config/colors.cc:

	  Don't blow up if no colors are available (e.g., if the terminal
	  doesn't support colors at all).

2005-09-26  Daniel Burrows  <dburrows@debian.org>

	* src/pkg_item.cc:

	  Make the interactive 'keep' command cancel any hold set on a
	  package; the behavior at the command line is unchanged.
	  (Closes: #326949)

	* src/generic/apt/aptcache.cc:

	  Preserve the last version of pkgstates when saving the selection
	  list. (Closes: #316460)  Also, don't remove the .new version if
	  we fail to save the cache (so the user can manually recover).

	* src/ui.cc:

	  Write a better description for the flat package list viewer.

	* src/ui.cc:

	  Also gray out autocleaning and mark-upgradable when the apt
	  cache file isn't available, and don't crash even if someone does
	  call do_autoclean with apt_cache_file == NULL.

	* src/ui.cc:

	  Gray out the install-run menu item whenever the apt cache file
	  isn't available.

	* src/ui.cc:

	  Also clear the 'active download' flag after a download that
	  failed up-front.

	* src/ui.cc:

	  If the download preparation routine fails, tell the download
	  manager that the download was complete so that the download
	  widget is destroyed.

	* src/download.cc:

	  If the user tries to start a download while the package cache is
	  NULL, print a cryptic error message instead of crashing.  If the
	  user tries to start an update while the package cache is NULL,
	  do the update instead of crashing.  (Closes: #309445)

	* src/cmdline/cmdline_moo.cc:

	  Delete the text at the end, which not only lacks a trailing
	  newline, but is also rather rude.  (Closes: #295924)

	* src/broken_indicator.cc:

	  Don't segfault if the apt cache is NULL (e.g., if apt_init
	  failed).  (Closes: #290408) -- at least for the time being; the
	  general problem is that I need to remember to test the program
	  in situations where the apt cache fails to initialize due to,
	  say, invalid configuration files.

	* src/generic/apt/aptcache.cc:

	  Fix the code that sets packages back to manual mode on a keep or
	  hold: it ran after the package was already kept back, so of
	  course the test for whether the package was to be deleted was
	  wrong! (Closes: #278490)

	* src/cmdline/cmdline_action.cc:

	  Only print a message about not being able to forbid an upgrade
	  because the package is not upgradable for packages that are
	  *NOT* upgradable, not packages that are.  (Closes: #246140)

	* src/cmdline/cmdline_show.cc:

	  Abort with an error message if some of the packages the user
	  tried to show don't exist, and return non-zero if errors were
	  generated while showing packages.  (Closes: #301291)

	* doc/en/aptitude.xml, doc/en/manpage.xml, src/generic/apt/apt.cc, src/main.cc:

	  Change Aptitude::Cmdline::Simulate to Aptitude::Simulate; if it
	  is true, always open the cache in read-only mode regardless of
	  whether the user is root or not.  This really Closes: #243192.

	* src/download.cc:

	  Write the date stamps for aptitude logs in RFC2822 format;
	  in particular, add timezones to them.  (Closes: #318501)

	* src/generic/util/util.cc, src/generic/util/util.h:

	  Add a safe wrapper for strerror_r.

	* src/generic/util/util.cc:

	  Correct get_homedir(): it was using the non-array form of delete
	  on arrays (remember, auto_ptr doesn't work on arrays...).

	* src/generic/util/util.cc, src/generic/util/util.h:

	  Write a safe strftime wrapper.

	* src/edit_pkg_hier.cc, src/generic/apt/apt.cc, src/generic/apt/pkg_changelog.cc, src/ui.cc:

	  Consistently use pkg_homedir() instead of getenv("HOME").
	  (Closes: #272429, #274216, #285334)

	* src/generic/util/util.cc, src/generic/util/util.h:

	  Write a utility routine to look up the current user's home
	  directory from the password database.

	* src/main.cc:

	  Automatically activate quiet mode if stdout is not a terminal.
	  (Closes: #276767)

	* src/pkg_item.cc:

	  Hang onto the lock while running reportbug.  This obviates the
	  need to reload the package cache, and in particular it means
	  that aptitude no longer discards information about package
	  states after reporting a bug; hence (Closes: #304748).

2005-09-25  Daniel Burrows  <dburrows@debian.org>

	* src/ui.cc:

	  Add a configuration option to suppress the warning message, and
	  display a customized dialog box that allows the user to disable
	  the message in the future.  With the other changes, this finally
	  (Closes: #175408).

	* src/ui.cc:

	  Make show_message() generate reverse video by default again.

	* src/download_list.cc, src/download_list.h, src/generic/util/slotarg.h, src/ui.h, src/vscreen/slotarg.h, src/vscreen/vs_menu.h, src/vscreen/vs_menu.cc:

	  Move slotarg to the generic code layer.

	* src/generic/apt/aptcache.cc:

	  Add a missing permission check in internal_mark_install.

	* src/ui.cc:

	  Make the package cache read-only while a download is going on.

	* src/vscreen/config/colors.cc:

	  Actually set default_colors_avail based on the result of
	  use_default_colors().  The codepath where this value is false is
	  untested, because I can't seem to find a terminal that doesn't
	  provide default colors.

	* src/ui.cc:

	  Connect up the new cache functions to display a helpful (?)
	  message when a read-only cache is modified.  This enforces a
	  rule that modifying the cache during a download is Not Allowed,
	  and it resets the cache to not-read-only after displaying a
	  single warning message otherwise.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add support for making the cache 'read-only'; writing to a
	  read-only cache will generate what you could loosely describe as
	  a 'page fault', to be dealt with by slots connected to a public
	  signal.

	* src/generic/util/bool_accumulate, src/ui/ui.h, src/vscreen/bool_accumulate, src/vscreen/vs_menu.h:

	  Move bool_accumulate to generic code.

	* doc/en/aptitude.xml, src/generic/apt/aptcache.cc:

	  Add an option to purge packages that are unused, with big red
	  warning flags in its documentation appropriate to the level of
	  foot-shooting-ness that it enables.  (Closes: #275150)

	* src/cmdline/cmdline_download.cc, src/cmdline/cmdline_upgrade.cc, src/main.cc:

	  Fix the remaining points in the code that need to be updated for
	  quietness.  The code should now work just fine in quiet mode.
	  (Closes: #217477)

	* src/cmdline/cmdline_update.cc, src/cmdline/cmdline_forget_new.cc, src/cmdline/cmdline_progress.cc, src/cmdline/cmdline_do_action.cc:

	  Fix a bunch of typos and update do_action for quietness.

	* src/cmdline/cmdline_clean.cc:

	  Update the clean and autoclean code for quietness.

	* src/cmdline/cmdline_progress.cc:

	  Make downloads quiet.

	* src/cmdline/cmdline_update.cc:

	  Update for quietness.

	* src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_spinner.cc, src/cmdline/cmdline_spinner.h:

	  Disable output from the spinner when the quiet level is greater
	  than zero.

	* doc/en/aptitude.xml, doc/en/manpage.xml, src/main.cc:

	  Add basic support for a 'quiet' option; it needs to be
	  integrated into all cmdline files.

	* doc/en/aptitude.xml:

	  Explicitly note that ~a matches the *current state* of a
	  package; for instance, ~aupgrade doesn't do what ~U does.
	  (Closes: #311290)

	* FAQ, doc/en/aptitude.xml:

	  Apply several typo fixes submitted by
	  Olivier Trichet <olivier.trichet@freesurf.fr>.
	  (Closes: #268916)

	* doc/en/manpage.xml:

	  Fix the SEE ALSO reference to the full documentation
	  (Closes: #265723).

	* src/vscreen/vscreen.cc:

	  Don't initialize the unused style WidgetFrame.

	* doc/en/aptitude.xml, src/defaults.cc, src/ui.cc:

	  Add keybindings and menu items to directly select the first and
	  last generated solution.

	* src/load_config.cc, src/vscreen/config/colors.cc, src/vscreen/config/colors.h, src/vscreen/config/style.cc, src/vscreen/config/style.h:

	  Support using the default background color by encoding it in the
	  slots that would be used for an identical foreground &
	  background color.  Attempts to set identical foreground &
	  background now return an arbitrary color with the same
	  background, and the style code sets A_INVIS in such a case
	  (resulting in a blank space with the same background).  This is
	  a bit of a hack, but it's the only way to do this when you
	  consider that xterm provides 9 colors (including the default
	  color) but only 64 color pairs.  (Closes: #161872)

	* src/cmdline/cmdline_clean.cc:

	  Unreverse the logic that determines the return value of 'clean':
	  it was returning 0 iff there WERE errors.  (Closes: #274098)

	* src/ui.cc:

	  Try to start a background solution calculation when connecting
	  up the signal (it's possible that we missed a signal that gets
	  emitted when the resolver is created).

	* src/cmdline/cmdline_upgrade.cc:

	  When we have to abort an upgrade, display any broken packages
	  that forced us to abort. Maybe this should hook into the full
	  resolver in the future? (Closes: #316027)

2005-09-25 Miroslav Kure <kurem@upcase.inf.upol.cz>

	* update Czech translation. Closes:#330014
	
2005-09-24  Daniel Burrows  <dburrows@debian.org>

	* src/generic/util/setset.h, tests/***:

	  Fix more include files that I missed (oops).

	* src/vscreen/vs_menubar.cc:

	  Display left and right arrows at the edge of the terminal if the
	  menu bar is too large for it.

	* src/***:

	  Fix all the include file problems and other stuff arising from
	  the reorganization.

	* po/POTFILES.in:

	  Update POTFILES.in.

	* Makefile.am, src/Makefile.am, src/vscreen/Makefile.am, src/generic/***:

	  Massively reorganize the generic/ subdirectory.  The code is now
	  split into three parts: code which is fully generic (util/), the
	  problem resolver, and "generic" apt routines (apt/).  Not only
	  is this more aesthetically pleasing, it also means that there
	  are no weird cross-directory dependencies (dependencies still
	  exist but they aren't weird any more: specifically, a straight
	  "make" will now always build code before its dependencies are
	  built.

	* src/ui.cc:

	  Fix do_next_solution_enabled().

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Eliminate out_of_solutions; use the solutions_exhausted member
	  of the state snapshot to calculate
	  solution_generation_complete().

	* src/generic/resolver_manager.cc:

	  Use the resolver counts instead of out_of_solutions to set the
	  solutions_exhausted member of the state snapshot.  This fixes
	  the 'are there more solutions?' indicator.

	* src/generic/problemresolver/problemresolver.h:

	  Add an element to the counts cache that mirrors 'finished', and
	  update the cache at the important exit points from the solver
	  and (if no solver is running) when retrieving queue counts.

	* src/generic/problemresolver/problemresolver.h:

	  When screening out solutions that we've already generated a
	  subset of, take into account the set of unresolved dependencies
	  as well as the set of actions.

	* src/generic/problemresolver/solution.h:

	  If an action coincidentally fixes an unresolved dependency,
	  remove that dependency from the unresolved set.

	* src/generic/problemresolver/problemresolver.h:

	  Remove the forced_broken interface from the resolver itself.
	  Switch a call to unforce_break that I missed earlier to invoke
	  unapprove_break instead.

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Rip the forced_broken stuff out of the resolver manager.

	* src/solution_item.cc:

	  Switch the solution_unresolved_item class to using the new
	  approved_broken stuff instead of forced_broken.

	* src/generic/problemresolver/problemresolver.h:

	  Doh, of course the MUTATORS for the new structure shouldn't be
	  constant!

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Expose the approved_broken stuff from the manager.

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Collect all the resolver manipulations into a common routine.

	* src/generic/problemresolver/problemresolver.h:

	  Add a set of "approved breaks" that should provide a more
	  sensible way of handling soft dependencies: instead of forbidden
	  the dependency to be solved outright, it just says that we
	  should place it in the 'unresolved' set whenever it comes up as
	  an option.  In other words, it defers any solution in which an
	  action is labelled with that dependency.

	* src/generic/problemresolver/problemresolver.h:

	  Fix the resolver indentation (finally).

2005-09-24 Rubén Porras <nahoo@inicia.es>

	* Update spanish translation

	* regenerate po/aptitude.pot, po/POTFILES.in and po files

2005-09-23  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  When force-breaking a soft dependency, make sure to reject its
	  source as well.  NOTE: the semantics of force-breaking may be a
	  bit off; maybe they should be reviewed to better match approval?
	  (i.e., only reject solutions due to force-breaking if something
	  force-broken is listed as a justification)

	* src/ui.cc:

	  Connect state_changed to vscreen_update, so an update is always
	  enqueued when the resolver state changes.  In particular, this
	  ensures that a keyboard-invoked undo will always trigger a
	  screen update.

	* src/generic/resolver_manager.cc:

	  For safety, always unsuspend a background thread before calling
	  state_changed().

	* src/generic/resolver_manager.cc:

	  Fix background_suspender::unsuspend -- it wasn't clearing its
	  suspended flag, so the suspender would try to unsuspend AGAIN
	  when it was destroyed.

	* src/solution_screen.cc:

	  Write a solution_undo_tree (analogue of apt_undo_tree) and use
	  it to activate the undo command in solution displays.

	* src/ui.cc:

	  Remove the no-longer-necessary do_undo() and undo_enabled()
	  routines.

	* src/apt_info_tree.h, src/pkg_tree.h:

	  Derive apt_info_tree and pkg_tree from the new undo-supporting
	  tree.

	* src/apt_undo_tree.cc, src/apt_undo_tree.h:

	  Add a tree class that implements an apt undo interface (i.e., so
	  package manipulation screens work as expected).

	* src/menu_redirect.cc:

	  Fix a rather silly typo.

	* src/menu_redirect.cc, src/menu_redirect.h:

	  Add menu_redirect hooks for the "undo" command.

	* src/ui.cc, src/ui.h:

	  Connect undo() through a signal instead of directly.  For now
	  do_undo() is still used, though.

	* src/generic/resolver_manager.cc:

	  Always signal state_changed() after an undo.

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Add support for tracking an undo stack for a resolver manager's
	  state.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/resolver_undo.h:

	  Correct a typo (generic_problem_resolver, not generic_resolver)
	  so the new code compiles.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/resolver_undo.h:

	  Add support in the resolver for recording the inverse of
	  operations performed on it.  (could be done at a higher level,
	  but for obvious reasons, the resolver is uniquely positioned to
	  know exactly how to reverse its actions)

	* src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h:

	  Allow the user to scroll the menu up and down on small
	  terminals.

	* src/view_changelog.cc:

	  Write a long menu description for the changelog pager.

	* src/ui.cc:

	  Edit the long menu description of the manual pager.

	* src/ui.cc:

	  Display the user's manual as a top-level widget instead of a
	  dialog box.

	* src/solution_screen.cc:

	  Switch back to using the widget itself as the menu target, and
	  bind menu handlers for the info area; the resolver menu works
	  now!

	* src/menu_redirect.cc:

	  Merge do_menu_test and do_menu_action into do_menu_callback, and
	  make the new routine use get_widget_active() to filter calls:
	  menu actions on a widget are valid only when every ancestor of
	  the widget is either the root or the 'active' widget of its
	  owner.

	* src/vscreen/vs_multiplex.cc:

	  Make it compile.

	* src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h:

	  Make get_owner() return a ref_ptr, not a bare pointer.

	* src/vscreen/vs_container.h, src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h, src/vscreen/vs_passthrough.cc, src/vscreen/vs_passthrough.h:

	  Add a routine to fetch the 'active' widget of a container (where
	  the definition of 'active' varies by widget, but is usually the
	  widget with the interaction focus).

	* src/ui.cc:

	  Add shortcut characters to the Resolver menu.

2005-09-22  Daniel Burrows  <dburrows@debian.org>

	* src/menu_tree.cc:

	  Say "Search Backwards", not "Search Back" (more readable).

	* src/ui.cc:

	  Don't talk about packages in the long menu description of
	  Search->Find and Search->Find Backwards now that other things
	  support those commands.

	* src/view_changelog.cc, src/view_changelog.h:

	  Add support for either forward or backwards searching.

	* src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h:

	  Add support for searching backwards in a file.

	* src/menu_redirect.cc, src/menu_redirect.h, src/pkg_node.cc, src/solution_item.cc:

	  Write default implementations for the menu_redirect methods that
	  cause all commands to be disabled; avoids lots of repetitive and
	  pointless code in subclasses.

	* src/view_changelog.cc:

	  Make sure that the changelog pager's scroll bar occupies the
	  full vertical extent of the screen.

	* src/menu_tree.cc, src/menu_tree.h, src/pkg_item.cc, src/pkg_item.h, src/pkg_node.cc, src/pkg_node.h, src/pkg_ver_item.cc, src/pkg_ver_item.h, src/solution_item.cc, src/solution_item.h:

	  Split up the menu_tree monstrosity and eliminate most of the
	  dynamic_casts.  Now it just does a single dynamic_cast of the
	  currently selected item to the menu_redirect interface; if the
	  cast succeeds, it just proxies for the result.

	* src/solution_screen.cc:

	  D'oh, connect up the bindings to the examiner, not the info
	  tree.

	* src/menu_tree.cc, src/menu_tree.h:

	  Implement the resolver commands.  This exposed some real
	  kludginess in the menu_tree that should be fixed in the future
	  (I imagine it acting as simply a proxy for the selection when
	  the selection is a menu_redirect).

	* src/solution_item.cc, src/solution_item.h:

	  Split the key response actions into public methods.

	* src/Makefile.am, src/apt_info_tree.h, src/load_grouppolicy.cc, src/menu_tree.cc, src/menu_tree.h, src/pkg_tree.cc, src/pkg_tree.h, src/solution_screen.cc, src/ui.cc:

	  Rename pkg_menu_tree to menu_tree and split it into a separate
	  file from pkg_tree.

	* src/solution_screen.cc:

	  Use a pkg_menu_tree instead of a vs_tree to build the solution
	  screen.  Note that pkg_menu_tree is a bit of a misnomer now...

	* src/pkg_tree.h:

	  Make pkg_menu_tree::create a static method (whoops).

	* src/menu_redirect.cc:

	  Bind up the resolver menu signals.

	* src/Makefile.am, src/menu_redirect.cc, src/menu_redirect.h, src/pkg_view.cc:

	  Split the code to bind up a menu_redirect object and the active
	  package view out into a separate .cc file.

	* src/ui.cc:

	  Actually put the new items in the menu and define the signals.

	* src/ui.h:

	  Add signals that will be used to hook up the new menu items.

	* src/solution_item.cc, src/solution_item.h, src/solution_screen.cc:

	  Split the tree items from solution_screen.cc into their own
	  file.

	* src/ui.cc:

	  Typo fix.

	* src/menu_redirect.h, src/pkg_tree.cc, src/pkg_tree.h:

	  Add stubs for future resolver menu items.

	* src/ui.cc:

	  Add a Resolver menu with various resolver commands, for those
	  who like such things.

	* src/vscreen/vs_staticitem.cc:

	  Make vs_staticitem really use the whole width (it was using one
	  character less).

	* src/solution_screen.cc:

	  Add more verbiage to unresolved soft deps when they show up as
	  possible alternatives to the selected action.

	* doc/en/aptitude.xml, src/defaults.cc, src/solution_screen.cc:

	  Modify the SolutionActionAccepted style and the
	  SolutionActionAccept keybinding to conform to the new "approved"
	  terminology; don't overspecify the SolutionAction styles.

	* doc/en/aptitude.xml, doc/en/images/broken-snapshot.png, doc/en/images/solution-screen-snapshot.png, doc/en/images/solution-screen-snapshot2.png, doc/en/images/solution-screen-snapshot3.png, doc/en/images/solution-screen-snapshot4.png, doc/en/images/solution-screen-snapshot5.png:

	  Update the broken packages tutorial.

	* src/generic/problemresolver/problemresolver.h, src/generic/resolver_manager.cc:

	  Make approving and rejecting an action mutually exclusive:
	  actions that are approved are automatically un-rejected, and
	  vice versa.

	* src/generic/problemresolver/problemresolver.h:

	  Allow mandated versions to be ignored in favor of other mandated
	  versions, and don't special-case other versions of the package.

	* doc/en/aptitude.xml, src/defaults.cc:

	  Don't explicitly set the background color in package colors, so
	  the user can globally override the background color if he/she so
	  desires.

	* doc/en/aptitude.xml, src/defaults.cc, src/pkg_item.cc, src/pkg_item.h, src/reason_fragment.cc:

	  Make a separate named style for each and every possible package
	  item state, including both highlighted and non-highlighted
	  styles.  Among other things, this makes xterm display reasonable
	  cursor colors for highlighted packages (by removing the
	  A_REVERSE flag, which seems to confuse it in some cases).  Of
	  course, it also means that people have much more flexibility in
	  customizing the colors of the package list.

	* src/generic/resolver_manager.cc:

	  Optimize for the case of block_steps == 0 (so users can
	  stop it from using any threading primitives at all).

	* src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h:

	  If the screen is too narrow to display a whole menubar, allow it
	  to "scroll" while the user is interacting with it.

	* src/vscreen/vscreen.cc:

	  (hopefully) fix the cursor placement problems that I was having.

	* src/vscreen/curses++.h:

	  Fix mvaddnstr for std::wstrings.

2005-09-22 Rubén Porras <nahoo@inicia.es>

	* Update spanish translation

	* regenerate po/aptitude.pot and po files

2005-09-21  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Document Aptitude::ProblemResolver::WaitSteps and
	  Aptitude::Spin-Interval.

	* src/generic/resolver_manager.cc:

	  Don't hold the lock while calling state_changed().  This avoids
	  deadlocks if state-changing callbacks trigger code that tries to
	  grab the instance lock from another thread.  (and just avoids
	  holding the lock over arbitrary code in general, probably a good
	  idea)

	* src/ui.cc:

	  Use the new maybe-blocking solution fetching routine.

	* src/generic/resolver_manager.cc:

	  Add support for cancelling a suspension before destroying the
	  corresponding background_suspender object.

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Add a routine that waits for the resolver to perform some number
	  of steps before returning; can be used to avoid displaying a
	  progress indicator unless the search seems to be taking a while.

	* src/ui.cc:

	  Ignore attempts to apply solutions that don't exist yet.

	* src/broken_indicator.cc, src/cmdline/cmdline_resolver.cc, src/generic/resolver_manager.cc, src/generic/resolver_manager.h, src/solution_dialog.cc, src/solution_screen.cc, src/ui.cc:

	  Make the number of steps an explicit parameter to get_solution
	  and get_solution_background.

	* src/ui.cc:

	  Signal that the resolver state changed when it runs out of
	  solutions.

	* src/broken_indicator.cc:

	  Fix the placement of a bunch of code in broken_indicator::update
	  that accidentally ended up inside a loop.

	* src/broken_indicator.cc:

	  Dim out the unavailable actions in the broken hint line.

	* src/vscreen/fragment.cc:

	  Make column fragments always have a final newline.

	* src/vscreen/vscreen.cc:

	  When determining how long the timeout thread should sleep,
	  return the absolute time that the next timeout will trigger at,
	  not the amount of time until that time (this results in the
	  timeout thread spinning forever).

	* src/ui.cc, src/ui.h:

	  Trigger package_states_changed from apply_current_solution.
	  Among other things, this means that the information area is
	  properly updated when a solution is applied.

	* src/solution_screen.cc:

	  Destroy the whole examiner when there aren't any broken
	  packages, and do it from external code (not update() or a
	  connection to destroyed) to avoid any possibility of weirdness.

	* src/cmdline/cmdline_do_action.cc, src/generic/aptcache.cc, src/generic/aptcache.h, src/ui.cc:

	  Upgrade packages that were to-be-removed when doing a
	  dist-upgrade from the command line.  This is achieved by adding
	  a new flag to mark_all_upgradable that selects one or the other
	  behavior; also fixed the handling of Unknown packages in
	  mark_all_upgradable (it was just wrong before, and probably
	  wasn't noticed because that case should never come up anyway).

	* src/broken_indicator.cc, src/dep_item.h, src/download_bar.h, src/download_list.h, src/edit_pkg_hier.h, src/mine/cmine.h, src/pkg_info_screen.h, src/pkg_tree.h, src/pkg_ver_item.h, src/pkg_view.cc, src/solution_dialog.cc, src/solution_screen.cc, src/ui.cc, src/view_changelog.cc, src/vscreen/vs_button.h, src/vscreen/vs_center.h, src/vscreen/vscreen_widget.h, src/vscreen/vs_editline.h, src/vscreen/vs_frame.h, src/vscreen/vs_label.cc, src/vscreen/vs_label.h, src/vscreen/vs_menubar.h, src/vscreen/vs_menu.h, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_multiplex.h, src/vscreen/vs_pager.h, src/vscreen/vs_scrollbar.h, src/vscreen/vs_size_box.h, src/vscreen/vs_stacked.h, src/vscreen/vs_statuschoice.h, src/vscreen/vs_table.h, src/vscreen/vs_text_layout.h, src/vscreen/vs_togglebutton.h, src/vscreen/vs_transient.h, src/vscreen/vs_tree.h:

	  Make the reference count of vscreen_widgets default to 1, not 0.
	  As a result, it is necessary for every creation routine to
	  explicitly decref() its return value before returning it.  Also
	  wrote a ::create() routine for cmine (it was missing one) and
	  changed ui.cc to call it.

	  The reason for doing this is that it allows routines run from
	  the constructor to acquire and release references without
	  causing the world to explode violently.

	* src/apt_info_tree.cc, src/broken_indicator.cc, src/download_bar.cc, src/download_list.cc, src/download_screen.cc, src/edit_pkg_hier.cc, src/mine/cmine.cc, src/pkg_info_screen.cc, src/pkg_view.cc, src/solution_dialog.cc, src/solution_screen.cc, src/vscreen/vs_bin.cc, src/vscreen/vs_button.cc, src/vscreen/vs_center.cc, src/vscreen/vs_container.cc, src/vscreen/vscreen_widget.cc, src/vscreen/vs_editline.cc, src/vscreen/vs_frame.cc, src/vscreen/vs_label.cc, src/vscreen/vs_menubar.cc, src/vscreen/vs_menu.cc, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_multiplex.cc, src/vscreen/vs_pager.cc, src/vscreen/vs_passthrough.cc, src/vscreen/vs_scrollbar.cc, src/vscreen/vs_size_box.cc, src/vscreen/vs_stacked.cc, src/vscreen/vs_statuschoice.cc, src/vscreen/vs_table.cc:

	  Take a self-reference in any routine that's not totally trivial
	  (in particular, any routine that invokes a virtual method or a
	  signal) in order to avoid future surprises like the one that
	  wasted so much time yesterday.

2005-09-20  Daniel Burrows  <dburrows@debian.org>

	* src/apt_info_tree.cc:

	  Preemptively fix a likely problem that turned up in an audit for
	  other instances of the access-this-after-self-destructing bug.

	* src/solution_screen.cc:

	  Have the examiner take a reference to itself in the destroy()
	  call; fixes a crash due to accessing members of the examiner
	  after it's deleted by destroy().

	* src/solution_screen.cc:

	  Clear out the other information areas when the multiplex goes.

	* src/vscreen/vs_multiplex.cc, src/vscreen/vs_table.cc:

	  Tighten some asserts.

	* src/vscreen/vs_table.cc:

	  Fix the logic that chooses a new focus after the current focus
	  goes away: most places were only looking at *UN*focussable
	  widgets; instead, only consider widgets that are visible and can
	  be focussed.

	* src/vscreen/vscreen_widget.cc:

	  Don't mark the widget as having been destroyed until after it's
	  been hidden and removed from its owner; this avoids some nasty
	  weirdness due to the way that the vscreen_widget accessors
	  change their behavior when the widget is destroyed.

	* src/broken_indicator.cc, src/solution_screen.cc:

	  Display the resolver progress in the solution screen instead of
	  in the broken indicator; use the new slot timeout object
	  to set up the broken indicator's timeout.

	* src/vscreen/vscreen.cc, src/vscreen/vscreen.h:

	  Add a slot_event that wraps a sigc++ slot in a safe
	  vscreen_event wrapper.

	* src/vscreen/vs_tree.cc:

	  Be robust in the face of a totally empty tree (one with a NULL
	  root pointer).

	* src/solution_screen.cc:

	  Display a list of the possible resolutions of the dependency
	  corresponding to each action.

	* src/solution_fragment.cc, src/solution_fragment.h:

	  Add a routine to display a description of a dependency that
	  might be a conflict through a Provides.

	* src/solution_screen.cc:

	  Remember that both trees have their visible flag set even though
	  only one is actually shown; the proper way to determine the
	  active child of a multiplexer is to call visible_widget().

	* src/solution_screen.cc:

	  Use the changes to vs_tree and vs_multiplex to correctly manage
	  the auxillary status areas.

	* src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h:

	  Add a signal that is emitted when the visible widget changes.

	* src/vscreen/vs_tree.cc:

	  Fix a silly compilation error.

	* src/vscreen/vs_tree.cc, src/vscreen/vs_tree.h:

	  Add hooks for highlighting or unhighlighting the currently
	  selected item.

	* src/solution_screen.cc:

	  Set up a split-screen display of prospective solutions; this
	  will be used (in the future) to display alternatives to a given
	  action.

	* src/apt_options.cc:

	  Fix button placement in the options dialog: the Ok/Cancel
	  buttons were being crammed into the first column instead of
	  spreading across both columns.

	* src/vscreen/vs_editline.cc:

	  Don't crash when creating a very small line-editor, such as when
	  displaying the options dialog in a thin terminal (it has other
	  problems in a thin terminal, but at least this one is fixed
	  now).

2005-09-19  Daniel Burrows  <dburrows@debian.org>

	* src/broken_indicator.cc, src/mine/cmine.cc, src/vscreen/vscreen.cc:

	  It turns out that sigc++ isn't really threadsafe -- thanks to
	  weak references and deletion callbacks, read access to a slot
	  created in one thread can be interefered with (disastrously) by
	  the deletion of an apparently unrelated object in another
	  thread.  As it's virtually impossible to guarantee that this
	  doesn't occur, I have decided to just avoid touching slots
	  anywhere but the main thread.  The easiest way to make this
	  explicit is to require a vscreen_event to be passed to the
	  timeout thread (although a heap structure containing a slot
	  could also be safe).

	* src/solutions_screen.cc:

	  Make pressing Enter (or whatever is bound to InfoScreen) on an
	  action solution item pop up the information screen about the
	  corresponding version.

	* doc/en/aptitude.xml, src/cmdline/cmdline_resolver.cc:

	  Make the version score tweaking default to 0.

	* src/generic/resolver_manager.cc:

	  When the resolver is interrupted, put the job we were working on
	  back onto the queue, so that we start working on it again at the
	  next opportunity.

	* src/broken_indicator.cc:

	  Format the statistics in the interactive UI better.

	* src/cmdline/cmdline_resolver.cc:

	  Display resolver statistics from the command line.

	* src/cmdline/cmdline_spinner.cc:

	  Really handle the case where the message we want to display is
	  longer than the screen width.

	* src/broken_indicator.cc:

	  Display the resolver statistics while it's running.

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Expose the resolver's queue counts in the state snapshot.

	* src/generic/problemresolver/problemresolver.h:

	  Allow users of the resolver to check the size of its various
	  queues.

	* src/generic/resolver_manager.cc:

	  Indicate that the background thread left the resolver before
	  calling the continuation (so if we ran out of threads, the
	  foreground thread will know to hide the spinner).

	* src/broken_indicator.cc:

	  Use columns to display the spinner flush-right and to display it
	  even when the user selects a finished solution again.

	* src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/testvscreen.cc:

	  Add a simple column-generating class.  It has a caveat regarding
	  indentation, but aside from that it should be safe.

	* src/broken_indicator.cc, src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_spinner.cc, src/cmdline/cmdline_spinner.h, src/cmdline/Makefile.am, src/generic/resolver_manager.cc, src/generic/resolver_manager.h, src/solution_dialog.cc, src/solution_screen.cc, src/ui.cc:

	  Use the background thread to keep the UI responsive while the
	  resolver is running.

	* src/vscreen/vscreen.cc:

	  Fix the timeout thread; it was utterly broken (whoops).

2005-09-17  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  When building a prospective solution from an old one, use
	  find_submap_containing instead of find_submap; this virtually
	  eliminates the huge amount of time that was being spent in
	  find_submap.

	* tests/test_dense_setset.cc:

	  Fix the predicate search test: the id halver was declared to
	  return bool, so it was actually only returning 0 or 1!

	* tests/test_dense_setset.c:

	  Add more tests of find_subset_containing.

	* tests/test_wtree.cc:

	  Correct a mistake in the test.

	* src/generic/immset.h:

	  Switch the second comparison of the roots of the two trees in
	  node_contains() -- I forgot to transform that one to its dual.

	* tests/test_wtree.cc:

	  Add a test for the subset (containment) routine.

	* src/generic/dense_setset.h, tests/Makefile.am, tests/test_dense_setset.cc:

	  Add a routine in dense_setset that searches for a subset of a
	  set that contains a particular element; will be useful for
	  optimizing the core resolver.

	* src/generic/immset.h:

	  Write an intrinsic subset routine for the binary trees that
	  should be quicker than iterating over them.

	* src/generic/problemresolver/conflictset.h, src/generic/problemresolver/problemresolver.h, tests/test_resolver.cc:

	  Back out the conflictset class, since it didn't speed anything
	  up and may have slowed stuff down.  Also, I have a better
	  high-level idea about cutting back on the cost of conflict
	  testing.

2005-09-16  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/conflictset.h:

	  Properly handle the case of an empty right branch by just
	  setting right_offset to one past the left branch.  This is
	  exactly correct, although it has the effect of causing the tree
	  to overlap itself (if you work it out, though, this is exactly
	  what's desired anyway).

	* tests/test_resolver.cc, src/generic/problemresolver/conflictset.h, src/generic/problemresolver/problemresolver.h:

	  Add an experimental conflict set optimized under some
	  assumptions that may or may not turn out to actually hold for
	  real programs once I get it working.

	* src/generic/resolver_manager.cc:

	  Make a thread-kill override all other control messages, so that
	  the program doesn't deadlock trying to shut the background
	  thread down.  What would happen was that if, e.g., the resolver
	  was null and the foreground thread tried to kill the background
	  thread, the background thread would sit there waiting for the
	  resolver to be non-null.

	* src/generic/resolver_manager.cc:

	  Fix a segfault that occurred when shutting down the resolver
	  thread.

2005-09-15  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/Makefile.am:

	  Don't put threads.o and util.o in LDADD any more; the changes in
	  the last commit made this unnecessary.

	* src/generic/resolver_manager.cc, src/generic/resolver_manager.h:

	  Rewrite the threading support to allow multiple simultaneous
	  jobs in the background thread; the foreground thread now just
	  posts jobs to the background thread and waits for a reply.
	  Furthermore, the complicated dance of constantly
	  stopping/starting the background thread has been removed in
	  favor of a scheme where the thread is started once and then
	  suspended using condition variables.

	* src/generic/problemresolver/problemresolver.h:

	  Allow the cancellation of a find_next_solution call to be
	  revoked or posted before the call starts.  Needed to avoid
	  races.

	* src/generic/threads.h:

	  Let the filled state of void boxes be directly set in the
	  constructor.

	* src/download_list.cc:

	  Fix a divide-by-zero.

	* src/ui.cc, src/ui.h, src/view_changelog.cc:

	  Add support for the new display mode of download_list.

	* src/generic/resolver_manager.cc:

	  Initialize the continuation to NULL to prevent nasty nasty
	  segfaults.

	* src/download_list.cc, src/download_list.h:

	  Add support for a display mode in which no estimated time is
	  provided and the progress bar assumes that all files have the
	  same size; this will be useful for list updates (where apt
	  kindly provides absolutely useless total-size information to the
	  status object).  Note that since TotalItems is not meaningful,
	  this doesn't (can't) fix all the problems.

2005-09-14  Daniel Burrows  <dburrows@debian.org>

	* src/generic/resolver_manager.cc:

	  Reset the currently selected solution to 0 when discarding the
	  resolver.

	* src/generic/resolver_manager.cc:

	  Don't let the solution pointer go past
	  one-off-the-end-of-the-list; fixes some uncaught exceptions.

	* src/resolver_manager.cc, src/resolver_manager.h:

	  Add coarse-grained threading support: the manager can start a
	  background thread for computations; thread-safety is ensured by
	  completely stopping the thread before performing dangerous
	  mutations.

	* src/generic/immset.h:

	  Fix a silly error in the implementation of clone(): pass the
	  value to the wtree_node constructor in addition to the children.
	  Also fix constructor ordering in the set-from-a-node constructor
	  (needed for the set's clone()).

	* src/generic/problemresolver/solution.h:

	  Add support for cloning an entire solution.

	* src/resolver_manager.cc, src/resolver_manager.h:

	  Instead of providing a limited interface to just step around and
	  get the current solution, allow steps to be taken without
	  implicitly calculating a new solution, and allow any solution to
	  be queried (possibly generating a bunch in the process).

	* src/ui.cc:

	  When accessing resman in contexts where the apt cache might not
	  be loaded (hence the globals don't exist), check whether it's
	  NULL before accessing it.

	* src/generic/resolver_manager.cc:

	  In maybe_create_resolver, don't try to create a resolver unless
	  none exists (sometimes maybe_create_resolver is called
	  unnecessarily, because nothing actually changed and the resolver
	  wasn't discarded).

	* src/broken_indicator.cc, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_resolver.cc, src/generic/aptcache.cc, src/generic/aptcache.h, src/generic/apt.cc, src/generic/apt.h, src/generic/Makefile.am, src/generic/resolver_manager.cc, src/generic/resolver_manager.h, src/solution_dialog.cc, src/solution_screen.cc, src/ui.cc:

	  Factor the resolver management functions of the cache file out
	  into a separate class.

	* src/generic/problemresolver/problemresolver.h:

	  includes is in namespace std, add a qualifier (why did this ever
	  compile?).

	* src/generic/problemresolver/Makefile.am:

	  Ugh: link threads.o and util.o into test.  In the future I need
	  to rearrange the files here and maybe use a less stupid build
	  system so that this isn't so fragile.

	* src/generic/problemresolver/problemresolver.h:

	  Add a missing #include <algorithm> to the resolver header.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add a method to the backend cache which applies a given
	  solution, rather than just applying the currently selected
	  solution.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add a new signal that gets called *before* the package states
	  change; this is needed to run the resolver in the background
	  (since it's a reader of the depcache, it has to be killed before
	  anything writes back to the depcache).

2005-09-13  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc:

	  Don't even try to auto-keep packages that are unused due to an
	  upgrade.  It is possible that auto-keeping a package will lead
	  to broken dependencies even in a situation where nothing was
	  previously broken; I think it's worse to break the output of the
	  problem resolver than to do the "wrong" thing sometimes in a
	  broken situation, and I don't see a simple solution that retains
	  the auto-keep behavior, so I'm just backing it out.

	* src/download_list.cc:

	  Fix download cancellation: don't actually destroy the widget
	  managing the download until Complete is received (indicating
	  that the background task is finished); just store the
	  cancellation and report it on the next Pulse.

2005-09-12  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc:

	  Only run mark-and-sweep after setting a candidate version if the
	  grouping level is 0.

	* src/generic/problemresolver/problemresolver.h:

	  I embarassingly forgot to initialize solver_cancelled and
	  solver_running; do so.

2005-09-10  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/exceptions.h, src/generic/problemresolver/problemresolver.h:

	  Add code to manage the resolver in the presence of threads; it
	  ensures that at most one find_next_solution call is running at
	  once, and allows a find_next_solution call to be cleanly
	  cancelled (throwing a special exception); it's guaranteed that
	  you can start the resolver back up after cancelling it.

2005-09-10 Jean-Luc Coulon  <jean-luc.coulon@wanadoo.fr>

	* update French translation
	
2005-09-09  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_prompt.cc:

	  Add a missing #include.

	* src/generic/immset.h:

	  Add routines to create non-overlapping copies of trees (since
	  the overhead from locking the reference count of trees is too
	  high, this is the only way to safely pass set structures between
	  threads).

	* doc/en/aptitude.xml, src/cmdline/cmdline_prompt.cc:

	  By popular demand, add a configuration option to bypass the
	  trust check in command-line mode (apparently this is useful for
	  scripted installations and so on).

	* src/download_list.cc:

	  Eliminate all uses of vscreen_mainloop by using the continuation
	  callbacks instead.  (Closes: #136973)

	* src/download_thread.cc, src/download_thread.h:

	  Directly invoke the continuation-passing methods of
	  download_manager from the background thread.

	* src/download_manager.cc, src/download_manager.h, src/download_list.h, src/generic/acqprogress.cc, src/generic/acqprogress.h:

	  Write basic support for continuation-passing in the download
	  status callbacks; this will allow complete elimination of
	  vscreen_mainloop calls.

2005-09-07  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver_universe.h, src/generic/dense_setset.h, src/generic/problemresolver/problemresolver.h:

	  Add a 'dense' set-set class optimized for the case where the set
	  elements can be mapped to a dense domain of integers (i.e., use
	  an array instead of a hash table); yields a small but noticable
	  improvement in the code's performance.

2005-09-06  Daniel Burrows  <dburrows@debian.org>

	* src/download_list.cc:

	  Remove a bunch of no-longer-necessary tryupdate calls and don't
	  invoke vscreen_poll; only queue display updates if the download
	  list is visible..

	* src/ui.cc:

	  Move package downloads to a background thread.

	* src/generic/setset.h:

	  Significantly speed up the operation of find_subset by
	  preallocating space to store its hit counts.  This means that it
	  has to pass over the whole conflict set, but it appears that
	  it's better to do that than to allocate; I get a speedup of 2-3
	  times out of this change, which is fairly important when you
	  consider that find_subset is invoked almost a million times and
	  is where most of the time of the test case I'm considering is
	  spent.

	  Note that this makes find_subset NOT threadsafe.

	* doc/cs/aptitude.xml:

	  Correct several XML errors in the Czech documentation.

	* doc/en/aptitude.xml:

	  Apply Miroslav's corrections to fix some typos.

	* src/generic/problemresolver/problemresolver.h:

	  When a solution is encountered immediately after forcing a
	  dependency, actually produce it instead of silently discarding
	  it.

	* src/generic/solution.h:

	  Yes, I need to check that it compiles before I commit it.

	* src/generic/solution.h:

	  Actually factor in the full_solution_score when a new solution
	  will be broken-dep-less.

	* tests/test_resolver.cc:

	  Fix a stupidity in the test (infinity is expected to be
	  positive, not negative, when setting up the resolver).

	* tests/test_resolver.cc:

	  Add a basic test that the rejection system won't go nuts and
	  reject other versions of the same package.

	* tests/test_wtree.cc:

	  Strip out some useless debugging dumps and correct some thinkos
	  in the tests.

	* tests/test_wtree.cc:

	  Explicitly test commutativity of intersection.

	* src/generic/immset.h, tests/test_wtree.cc:

	  Fix a very dumb error when intersecting against an empty set.

	* src/generic/immset.h, tests/test_wtree.cc:

	  Generalize the intersection routine to only find intersections
	  matching a predicate; add hooks in the map class to test for
	  domain intersection, containing an identical element, and
	  general intersection.

	  Also, actually fail if the intersection test doesn't work
	  (oops); this turns up a mistake in the current implementation
	  (double oops).

	* src/generic/immset.h, tests/test_wtree.cc:

	  Write a set routine to test whether two sets intersect.

2005-09-05 Miroslav Kure <kurem@upcase.inf.upol.cz>

	* update Czech translation and Czech manual translation

2005-09-05 Miguel Figueiredo <elmig@debianpt.org>

	* update Portuguese translation
	
2005-09-04  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Fix a bug in contains_rejected: instead of returning true on
	  solutions that installed a rejected version, it was returning
	  true on solutions that installed a package with a rejected
	  version.

	* src/generic/problemresolver/problemresolver.h:

	  Add more debugging output for figuring out why deferrals occur.

	* src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_upgrade.cc, src/download.cc, src/download.h, src/ui.cc:

	  Split the download-and-install routines the same way that update
	  was split.  NB: both splits should be refined in the future by
	  creating classes that encapsulate the algorithms.

	  In the process of doing this, made the message about
	  installation failures a little less silly.  (Closes: #230188)

2005-09-04 Clytie Siddall <clytie@riverland.net.au>

	* Update vietnamese translation
	
2005-09-04 Rubén Porras <nahoo@inicia.es>

	* Update spanish translation

	* regenerate po/aptitude.pot and po files
	
2005-09-03  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_update.cc, src/download.cc, src/download.h, src/download_thread.cc, src/download_thread.h, src/ui.cc:

	  Use the download_thread class to run list updates in the
	  background.

2005-09-02  Daniel Burrows  <dburrows@debian.org>

	* src/Makefile.am, src/download_thread.cc, src/download_thread.h:

	  Write harness code for running downloads in the background.

	* src/generic/threads.h:

	  Fix some silly compilation errors; make all broken-out box
	  functions inline so they don't cause link failures.

	* src/generic/threads.h:

	  Add a helper class to bootstrap noncopyable functors in threads,
	  and write an explicit specialization of threads::box for void
	  that acts as a "baton repository".

	* src/cmdline/cmdline_update.cc, src/download.cc, src/download.h:

	  Split the package-list updating code around the download
	  operation, so that the download itself can be pushed into a
	  separate thread eventually.

	* configure.ac, src/download_bar.cc, src/download.cc, src/download_list.cc, src/download_screen.cc, src/vscreen/Makefile.am, src/vscreen/curses++.cc, src/vscreen/vscreen.cc, src/vscreen/vscreen.h:

	  Explicitly support and use threading in the vscreen core.  The
	  design is relatively conservative: only the "main" thread is
	  permitted to access most vscreen stuff; other threads carry out
	  vscreen tasks by "posting" events to the main loop; the events
	  are run serially in the main loop.

	  The core vscreen loop has been split into a small main loop and
	  three auxillary threads that dispatch input, timeout, and
	  asynchronous signal events to the main loop.  The resulting code
	  should be a lot cleaner than what I had before, although there
	  are still some warts that could be taken care of.
	  Unfortunately, resizing seems to be slightly broken by this, or
	  at least broken in a different way than it was before; the
	  terminal sometimes displays incorrectly until you press a key.

	* src/generic/threads.h:

	  Support mutex attributes and add a recursive mutex type (for
	  static initialization).

2005-09-01  Daniel Burrows  <dburrows@debian.org>

	* src/generic/threads.h:

	  Bind pthread_cancel.

	* src/generic/threads.h:

	  Add a convenience box proxy that stores a pointer and deletes it
	  when destroyed (if it's full).

	* src/generic/event_queue.h, src/generic/threads.h, tests/test_threads.cc:

	  Add support for timed waits.

	* src/generic/event_queue.h, tests/test_threads.cc:

	  Write a simple event queue abstraction.

2005-08-31  Daniel Burrows  <dburrows@debian.org>

	* src/generic/threads.cc, src/generic/threads.h, test/test_threads.cc:

	  Add some generic code that wraps pthreads in a less error-prone
	  interface, based on boost::threads (didn't just use
	  boost::threads because of the unstable interface and the extra
	  dependency it would introduce).

	* src/generic/immset.h:

	  When extracting and removing the minimum element of a tree,
	  remember that while the minimum has (by definition) no *left*
	  children, it might have a *right* child.  Thus, instead of just
	  replacing the removed element with an empty tree, replace it
	  with its right child.

	* src/generic/immset.h, tests/interactive_set_test.cc:

	  Make the set dump a dump() routine instead of operator<<, since
	  it's not really suitable as a generic way of displaying a tree.

	* tests/test_wtree.cc:

	  Write a test targetted at the bug that showed up today in
	  imm::set.

	* tests/Makefile.am, tests/interactive_set_test.cc:

	  Add a simple interactive test for the set code.

	* src/generic/immset.h:

	  Yet another silly error from moving the code: use getRight, not
	  getLeft.

	* src/generic/immset.h:

	  Add missing #include of iostream.

	* src/generic/immset.h:

	  Right, don't crash on empty nodes (somehow that got lost when
	  pasting from the code in the staging area).

	* src/generic/immset.h:

	  Add operator<< implementations that show the structure of each
	  set/map.

2005-08-31 Sorin Batariuc <sorin@bonbon.net>

	* Update Romanian translation
	
2005-08-31  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver_universe.cc:

	  Don't skip packages that aren't InstBroken when searching for
	  broken packages; fixes the broken-list anomaly that recently
	  turned up.

	* tests/test_apt_universe.cc, tests/data/*:

	  Add an apt_universe test for the consistency of the broken list,
	  and update the data to my current system, where the consistency
	  check fails.  (TODO: support several data directories and test
	  all of 'em)

	* src/generic/aptitude_resolver_universe.cc:

	  Fix the self-dependency check in broken_iterator::operator++;
	  now the global list of broken packages in aptitude_universe
	  properly excludes self-conflicts.  Fixes an assert failure.

	* src/generic/problemresolver/dummy_universe.cc, src/generic/problemresolver/dummy_universe.h, src/generic/problemresolver/solution.h, src/generic/aptitude_resolver_universe.cc:

	  Canonicalize some of the debugging output of the resolver to
	  make it a bit easier to verify that it works properly.

	* src/generic/problemresolver/dummy_universe.cc:

	  Don't put commas in the dumped form of dummy dependencies.

	* src/generic/aptcache.cc:

	  Update the dump format to match the expected input format of the
	  resolver test.

	* src/generic/util.cc, src/generic/util.h, src/solution_fragment.cc:

	  Lift pkg_name_lt and ver_name_lt to generic code.

	* src/solution_fragment.cc:

	  Sort elements of a solution by name.

	* src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_util.cc, src/cmdline/cmdline_util.h, src/ui.cc, src/ui.h:

	  Let the user enter the visual interface from the resolver
	  prompt.

	* src/generic/aptcache.cc:

	  In mark_all_upgradable, only mark packages that are already
	  installed; don't flag uninstalled but stickily-to-be-installed
	  packages for installation.  (Closes: #317885)

	* src/generic/aptitude_resolver_universe.h, src/generic/apt.cc, src/generic/apt.h:

	  Pass the package cache into surrounding_or when calling it
	  before apt_cache_file is initialized, to avoid crashes.

	* src/generic/apt.h:

	  Add a const qualifier that might not matter but that certainly
	  can go in.

2005-08-30  Daniel Burrows  <dburrows@debian.org>

	* src/generic/tags.cc:

	  Optimize tag::operator++: testing for whitespace isn't strictly
	  necessary so don't waste time calling isspace.

	* src/main.cc:

	  Add a "nop" command, which might or might not be useful for
	  profiling the startup activities.

	* src/generic/setset.h:

	  Also use a hash table to represent the intermediate map object
	  used in find_subset.

	* src/generic/problemresolver/problemresolver.h, src/generic/setset.h, tests/test_setset.cc:

	  Use a hash table to represent the by-value indexing in a setset.
	  This appears to significantly speed up the setset structure --
	  by which I mean that finds go from being a major time sink (over
	  20% of the time in my test case) to taking negligible amounts of
	  time.

	* src/generic/setset.h:

	  Use a vector instead of a set to store the sets containing an
	  element.

	* src/generic/problemresolver/problemresolver.h:

	  Print a newline after the resolver statistics.

	* src/generic/immset.h:

	  Don't automatically split pairs in imm::map::for_each.

	* src/generic/util.h:

	  Also add project1st.

	* src/generic/util.h:

	  Add some missing functor classes that are in libstdc++ but
	  aren't standard.

	* src/generic/immset.h:

	  Add a missing const qualifier.

	* src/generic/immset.h:

	  Slightly optimize for_each and the other immset routines by
	  avoiding some wtree_node copies (hence avoiding reference-count
	  updates).

2005-08-30  Christian Perrier  <bubulle@debian.org>

	* po/fr.po: Completed by Jean-Luc Coulon and the French team

2005-08-30  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Make the conflict set a mapset instead of a std::set; use
	  setmap's special abilities to accelerate searches.

	* src/generic/setset.h:

	  Add a size() routine in setset and mapset.

	* src/generic/setset.h, tests/test_setset.cc:

	  Add a setset wrapper for sets of maps.

	* src/generic/immset.h, tests/test_wtree.cc:

	  Make imm::map::put update existing entries.

	* src/generic/immset.h:

	  Expose key_compare at the toplevel.

2005-08-29  Daniel Burrows  <dburrows@debian.org>

	* src/generic/setset.h, tests/test_setset.cc:

	  Make the necessary modifications to the 'setset' object to allow
	  extra relations on sets to be calculated (mainly to support
	  the subsumption relation as used to find conflicts).

	* src/generic/setset.h, tests/test_setset.cc:

	  Add a data structure that stores a set of sets, optimized for
	  searching for a superset or a subset of a given set without
	  using imm::set's slow operator++.

	* src/generic/immset.h:

	  Add missing const qualifier on wtree_node::for_each.

	* src/generic/problemresolver/problemresolver.h:

	  Fix compilation error in contains_rejected.

	* src/generic/immset.h:

	  Doh, fix for_each.

	* src/generic/immset.h:

	  Add a for_each operation that should be quicker for simple
	  iteration over trees.

	* src/generic/problemresolver/problemresolver.h:

	  Fix contains_rejected, which was not just slow (due to
	  imm::*::const_iterator), but was actually flat-out wrong.

	* src/broken_indicator.cc, src/cmdline/cmdline_resolver.cc, src/generic/aptcache.cc, src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/solution.h, src/generic/problemresolver/test.cc, src/solution_fragment.cc, src/solution_screen.cc, tests/test_resolver.cc:

	  Use the new imm::* containers instead of std::*.  This makes
	  everything much slower...but on the upside, aptitude no longer
	  eats all my memory before giving up on a search.

	* src/generic/immset.h, tests/test_wtree.cc:

	  Add a 'node' member type to imm::map, and write comparison and
	  equality tests for wtrees.

	* tests/test_apt_universe.cc:

	  Actually load the local test data in the apt tests.

	* src/generic/problemresolver/problemresolver.h:

	  Eliminate the major bottleneck in the resolver code: rather than
	  constructing full solutions while searching for forcings and
	  unresolved dependencies, just construct as much of the solution
	  as is necessary.  In particular, the resolver now just
	  constructs a new actions map to search for conflicts.

	  With this change, the resolver goes from taking several minutes
	  to return a first result from 'dist-upgrade' to returning it
	  almost instantaneously.  The clue to finding this bottleneck was
	  the observation that the profiler reported a huge amount of time
	  being spent in broken_under, but that in fact hardly any time at
	  all was being spent in each individual call to that routine; the
	  problem was that it was being called millions of times to
	  construct the sets of broken dependencies for successor
	  solutions that were being discarded.

	* src/generic/problemresolver/solution.h:

	  Dereferencing a revdep_iterator is a bit expensive; cache the
	  result of doing so.

	* src/generic/immset.h:

	  Add a convenience routine to check if a value is in the domain
	  of a mapping.

2005-08-28  Daniel Burrows  <dburrows@debian.org>

	* src/generic/apt.cc:

	  Memoize surrounding_or: somewhat surprisingly, gprof reports
	  that aptitude's resolver is now (since the recent changes -- and
	  I suspect that the ones which caused this were *required* for
	  correctness' sake) spending 25% of its time in this routine!
	  The current change just memoizes the start of the OR group,
	  calculating the group's end directly from the start.

	* src/generic/immset.h:

	  Correct the corresponding thinko in the double left rotate.

	* tests/test_wtree.cc:

	  Write simple test cases for *all* the rotation operations.

	* tests/test_wtree.cc:

	  Correct a wrong test assertion.

	* src/generic/immset.h:

	  Correct a rather dumb thinko in the double right rotation that
	  caused segfaults.

	* src/generic/immset.h, tests/test_wtree.cc:

	  Rename wtree to set, and add a wrapper class to make it work as
	  a mapping.

2005-08-27  Daniel Burrows  <dburrows@debian.org>

	* src/generic/immset.h, tests/test_wtree.cc:

	  Add support for removing elements from a wtree and for finding a
	  particular element in the tree.

2005-08-26  Daniel Burrows  <dburrows@debian.org>

	* src/generic/immset.h, tests/Makefile.am, tests/test_wtree.h:

	  Write a basic framework for weight-based immutable trees.  These
	  trees explicitly share memory between different versions of a
	  tree (for instance, if a tree is updated by adding one element)
	  and I hope they'll help with some of the time and space issues
	  in the problem resolver.

	* src/generic/problemresolver/problemresolver.h:

	  Fix the generation of conflicts from forbiddings: if a -> b c
	  and a was removed, an attempt to install b would generate a
	  conflict against b rather than against a.

	* src/generic/problemresolver/problemresolver.h:

	  Fix an assertion failure: when re-processing a solution that's
	  been forced, remember that the iteration over dependencies
	  should be over the new solution's dependency set, not the old
	  one's.

2005-08-25  Daniel Burrows  <dburrows@debian.org>

	* tests/test_apt_universe.cc:

	  Add more diagnostic information to the connectivity tester.

	* src/generic/apt.cc:

	  Fix the behavior of is_interesting_dep on reverse dependencies:
	  they weren't being expanded to the surrounding OR, so the
	  subsumption relation was wrong.

	* tests/test_apt_universe.cc:

	  Provide more specific information in failure messages for the
	  connectivity test.

	* src/generic/aptitude_resolver_universe.cc:

	  Finally (I hope) fix the case of conflicts-through-provides in
	  solved_by().  It passes the test now.

	* tests/test_apt_universe.cc:

	  Discard apt errors rather than spewing them out (is this a good
	  idea?).

	* tests/test_apt_universe.cc:

	  Add a tester to verify that only interesting dependencies are
	  produced by the various dependency iterators.

	* src/generic/aptitude_resolver_universe.cc:

	  Give in and strictly conform to the providedness rule (i.e.,
	  dependencies that represent conflicts-through-provides are
	  exactly tuned to a single Provides relationship).  It's not
	  clear how to validate the reverse connectivity of the dependency
	  graph without this change.

	* src/generic/aptitude_resolver_universe.cc:

	  Set 'provides_open' to true before calling applicable(), so that
	  versioned reverse dependencies on a provided package are
	  correctly handled.  Also, remove a bunch of redundant
	  is_interesting_dep() calls.

	* src/generic/aptitude_resolver_universe.h:

	  When comparing dependencies, ignore the attached provides
	  iterator unless the dependency is a conflict.  This solves
	  problems caused by junk Provides iterators showing up when
	  revdep_iterators that passed through a Provides were
	  dereferenced.

	* tests/test_apt_universe.cc:

	  Fix the connectivity test to actually ignore stuff that fixes
	  the dependency under consideration (doh).

	* tests/test_apt_universe.cc:

	  Right, take sources into account in the other branch (this code
	  should probably be reorganized to be less brittle!).

	* tests/test_apt_universe.cc:

	  Instead of completely ceasing tests after a certain amount of
	  time, just test the rest of the archive less aggressively.

	* tests/test_apt_universe.cc:

	  Arbitrarily limit testSolves() so that it terminates in a
	  reasonable amount of time.

	* src/generic/aptitude_resolver_universe.cc:

	  Further fix handling of conflicts-through-provides in
	  solved_by(): claim that any version not providing the conflicted
	  package "solves" the conflict, for consistency with the
	  solver_iterator class.

	* src/generic/aptitude_resolver_universe.cc:

	  Fix handling of conflicts-through-provides.

	* src/generic/aptitude_resolver_universe.cc:

	  Follow Provides in solved_by().

2005-08-24  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver_universe.cc:

	  Don't crash when an UNINST version is passed to solved_by().

	* tests/test_apt_universe.cc:

	  Handle dependency sources correctly when testing the solver
	  graph.

	* tests/test_apt_universe.cc:

	  Generate more useful test failure messages.

	* tests/Makefile.am, tests/data:

	  Add some test data so I can have well-defined tests in the
	  future.

	* src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h, src/generic/aptitude_resolver_universe.cc, src/generic/aptitude_resolver_universe.h, tests/test_apt_universe.cc:

	  Move the operator<< for aptitude_universe_dep objects to
	  aptitude_resolver_universe, so stuff that just uses the universe
	  (e.g., the test code) can avoid including the whole resolver.

	* tests/Makefile.am, tests/test_apt_universe.cc:

	  Add tests for the graph-structure of the apt universe
	  translation layer.

	* src/generic/problemresolver/solution.h, tests/test_resolver.h:

	  Avoid crashing in test code by making the tester a friend of the
	  solution and directly constructing solutions for the solution
	  test (bypassing the sanity-checking public constructors).

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/solution.h, tests/test_resolver.h:

	  Massive refactoring of the problem resolver.  The solution
	  abstraction is now much stronger: solutions can *only* be
	  constructed as either a root node or a successor to an existing
	  solution, and score calculation is handled in the constructor
	  (actually a static factory function).

	  Instead of trying hard to not actually build solution objects,
	  the main resolver now generates all solutions up-front; this
	  introduces some new inefficiencies while removing others, but it
	  does seem to have slightly slowed the program down.

	  Needless to say, separating solution generation from solution
	  processing makes everything so much cleaner that it's not even
	  funny.  Some errors may also been introduced that will need to
	  be dealt with; actual testing is probably a good idea here.

2005-08-23  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Fix several obvious errors and inconsistencies in calculating
	  solution scores.

	* src/generic/problemresolver/problemresolver.h:

	  Efficiency tweak: when comparing solutions by their contents,
	  don't do a full lexicographical compare unless the two solutions
	  have different sizes and different scores.  This moves
	  lexicographical_compare from second place with 18% of the
	  running time to ninth place with 2.47% of the running time.

2005-08-20  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver_universe.cc:

	  Fix the projection of conflicts-through-provides into the
	  abstract universe: the gateway test should check that the
	  current version provides the *target* of the Conflict, not the
	  *source*.

	* src/generic/problemresolver/problemresolver.h:

	  Fix a silly error: of course when populating a partial conflict
	  map, we shouldn't randomly stick the forbidden versions into it.

	* src/generic/matchers.cc:

	  Fix an uninitialized variable usage turned up by compiling with
	  -O2.

	* src/generic/problemresolver/problemresolver.h:

	  Don't spew quite so much in debug mode when checking for
	  conflicts, and add a note about how long the search took when it
	  fails.

	* src/generic/problemresolver/problemresolver.h:

	  When checking whether a solution is irrelevant, also check
	  whether it contains a known conflict.

	* src/generic/problemresolver/problemresolver.h:

	  Split the monstrosity of will_conflict into four routines.

	* src/generic/problemresolver/problemresolver.h:

	  Get everything compiling and sort of working.  Probably all
	  sorts of stuff needs to be fixed up, though :-/.

2005-08-19  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Fix will_conflict (the previous definition was obviously wrong).

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/solution.h:

	  Add preliminary support for tracking logical conflicts within
	  solutions.  This will eventually allow the elimination of some
	  cases where the resolver currently goes exponential.

	* src/generic/problemresolver/problemresolver.h:

	  Improve debugging output (used to catch the below bug) and add
	  early branching for user requests (should mean that if the user
	  requests something impossible, we tell them ASAP).

	* src/generic/aptitude_resolver_universe.cc:

	  Fix solved_by(): it was returning "true" for most non-virtual
	  Conflicts (whoops).

	* src/broken_indicator.cc:

	  Base the decision on whether to really update the broken
	  indicator both on the actual generated solution and on whether
	  the completed-state of the backend resolver changed.

	* src/generic/aptcache.cc:

	  Call selected_solution_changed() when we run out of solutions.

	* src/broken_indicator.cc:

	  When displaying the summary of the current number of broken
	  packages, always show how many solutions have been generated so
	  far; for instance, 1(2)/... .

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Tell parties who are interested in the resolver that they should
	  update themselves even if we only might have changed the
	  open-endedness of the queue.

	* src/generic/problemresolver/problemresolver.h:

	  Always check the deferred queue before checking whether we've
	  run out of solutions.

	* src/cmdline/cmdline_resolver.cc:

	  Fix the messages displayed when accepting a version, and
	  actually accept it!

	* src/generic/aptitude_resolver_universe.cc, src/generic/aptitude_resolver_universe.h, src/generic/problemresolver/dummy_universe.cc, src/generic/problemresolver/dummy_universe.h, src/generic/problemresolver/problemresolver.h:

	  Redefine acceptedness of versions: instead of rejecting all
	  other versions of the package (which is wrong anyway), accepting
	  a version now discards any solution that *COULD* have picked
	  that version but didn't.

2005-08-18  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Extend the tutorial on managing packages with notes about broken
	  dependencies, and document the new styles corresponding to
	  solutions.  Needs more work (but I've realized that the code is
	  actually wrong now).

	* src/solution_fragment.cc:

	  Add a newline after each note about an unresolved
	  recommendation.

	* src/solution_screen.cc:

	  Fix the text displayed for a 'story' in the curses interface
	  when a package's removal is going to be cancelled.

	* doc/en/aptitude.xml:

	  Start updating the documentation for the next version: fix some
	  comments in the tutorial, and fix some keystroke documentation.

2005-08-17  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Add support for adding an extra penalty to solutions that break
	  a user hold or install a forbidden package version.

	* src/vscreen/vs_tree.cc:

	  Fix the bug that caused the screen to scroll pointlessly at the
	  end of the list.

	* src/generic/problemresolver/problemresolver.h:

	  Check for unresolved hardened deps both when enqueuing solutions
	  and when dequeuing them.

	* src/generic/problemresolver/problemresolver.h:

	  Fix breaks_hardened() to actually work.

	* src/solutions_screen.cc:

	  Use the new hardening/force-breaking stuff to allow users to
	  manipulate solutions containing a broken recommendation.

	* src/generic/problemresolver/problemresolver.h:

	  Fix force_break() and unforce_break() to call reject_version()
	  and unreject_version() rather than reject() and unreject().
	  Fixes compilation.

	* src/generic/problemresolver/problemresolver.h, src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add support for "hardening" soft dependencies; basically this
	  functions like a rejection of the decision to leave the
	  dependency unresolved.

	* src/solution_screen.cc:

	  Use an aptitude_universe::dep, not a pkgCache::DepIterator, to
	  track unresolved soft deps.

	* src/vscreen/transcode.h:

	  Remove format_arg specifiers, they don't work and break
	  compilation.

	* src/vscreen/transcode.h:

	  Add format_arg specifiers that are presently useless since gcc
	  doesn't know about wide strings.

	* src/aptitude.h:

	  Add a format_arg attribute to P_.

	* src/solution_screen.cc:

	  Fix a bad parameter type turned up by the ssprintf attribute.

	* src/generic/util.h:

	  Add a formatting __attribute__ specifier to ssprintf (can't add
	  one to swsprintf because gcc doesn't know about checking wide
	  strings).

	* src/generic/aptcache.cc:

	  Penalize broken soft deps less than removals, and add some
	  cautionary text about the danger of fiddling with the resolver
	  settings.

	* src/cmdline/cmdline_resolver.cc:

	  In the 'story', make sure to insert the dep_text with %ls, not
	  %s.

	* src/cmdline/cmdline_resolver.cc:

	  Add support for rejecting/accepting versions from the
	  command-line.

	* src/solution_fragment.cc:

	  Silly compilation fix.

	* src/solution_fragment.cc, src/solution_fragment.h, src/solution_screen.cc:

	  Move archives() to solution_fragment and call it
	  archives_text(); eliminate archives_fragment().  (probably this
	  whole collection of routines should be pushed down to generic/)

	* src/generic/problemresolver/problemresolver.h, src/generic/aptcache.cc, src/generic/aptcache.h, src/solution_screen.cc:

	  Push the mandatory-version handling down into the generic
	  problem resolver class.

	* doc/en/aptitude.xml:

	  Document SearchBack and that '\' is no longer ReSearch.

	* src/vscreen/vscreen.cc:

	  Fix the definition of ReSearch.

	* src/pkg_tree.cc:

	  Fix the initialization of last_search_backwards when incremental
	  search is enabled.

	* src/vscreen/vs_tree.cc:

	  When directly setting the selection to a new tree location, make
	  sure to expand the parents of the new selection first.

	* src/menu_redirect.h, src/pkg_tree.cc, src/pkg_tree.h, src/pkg_view.cc, src/ui.cc, src/ui.h, src/vscreen/vscreen.cc:

	  Add UI hooks to support reverse searching.  (Closes: #323239)

	* src/vscreen/vs_tree.cc, src/vscreen/vs_tree.h:

	  Add widget support (untested) for reverse searching.

	* src/solution_screen.cc:

	  Use the fragment subsystem to add text attributes to the story.

	* src/defaults.cc, src/solution_screen.cc:

	  Add support for switching between a 'solution' viewing mode and
	  a 'story' viewing mode.

	* src/vscreen/vs_tree.cc:

	  Clean up line_up and line_down (NB: it's not quite clear that
	  their behavior is identical) and rewrite set_selection so that
	  it adjusts the top of the screen correctly, at the cost of a
	  line_of call.

2005-08-16  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_tree.cc:

	  Handle the case of the first element in a tree being
	  unselectable in line_up().

	* src/solution_screen.cc:

	  Add and activate support for displaying a "story" in the visual
	  interface (currently you can't switch between story and
	  non-story mode, though).

	* src/cmdline/cmdline_resolver.cc, src/solution_fragment.cc, src/solution_fragment.h:

	  Change dep_fragment to dep_text, returning a wstring, not a
	  fragment.

	* src/dep_item.cc, src/dep_item.h:

	  Expose the dep_item class to the world.

	* src/cmdline/cmdline_resolver.cc, src/generic/solution.h:

	  Move the by-id comparison functor to the solution class.

	* src/solution_screen.cc:

	  Add a class that describes an action instead of just presenting
	  its associated version.

	* src/generic/problemresolver/dump_universe.h:

	  Indent soft dependencies the same way as hard dependencies.

	* src/generic/apt.cc:

	  Uh, yeah, recommends-important defaults to true.

	* src/generic/apt.cc:

	  Make recommends interesting iff Recommends-Important is true.

	* src/generic/aptcache.cc:

	  Discard any extant resolver when Recommends-Important changes.

	* src/generic/aptcache.cc:

	  Connect the mark-and-sweep signal to keep-suggests, not
	  keep-important.

	* src/generic/apt.cc:

	  Fix the deletion of cached_deps_interesting on a cache reload,
	  and set it up to also be deleted+reset when the
	  Recommends-Important variable is modified.

	* src/generic/apt.cc:

	  Only treat currently satisfied recommendations as interesting if
	  they belong to the current package version OR they subsume/are
	  subsumed by a recommendation of the current version.

	* src/generic/apt.cc:

	  Fix subsumes(): when the first dependency used a >= comparison,
	  it was checking for (> | <= | =) instead of (> | >= | =).  This
	  resulted, unsurprisingly, in >= recommendations that hadn't even
	  changed appearing as soft dependencies to the resolver.

	* src/generic/apt.cc:

	  Fix or_group_subsumes to not enter an infinite loop.

	* src/generic/aptcache.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver_universe.cc, src/generic/aptitude_resolver_universe.h:

	  Memoize calls to is_interesting_dep().  The major change caused
	  by this is that objects in the aptitude_universe store
	  backpointers to the universe, not the cache (because calls to
	  is_interesting_dep need to go through the universe).

	  NB: is_interesting_dep could also be a global function in
	  apt.cc; would it be useful there?

	* src/generic/aptitude_resolver_universe.cc:

	  Redefine is_interesting_dep in terms of "subsumption": a
	  recommendation is now considered "interesting" iff it covers
	  neither a subset nor a superset of the version space covered by
	  a recommendation of the current version.

	* src/generic/aptitude_resolver_universe.cc, src/generic/aptitude_resolver_universe.h:

	  Make the is_interesting_dep function really be a static member
	  of aptitude_universe, and move it into the .cc file.

	* src/generic/Makefile.am, src/generic/aptitude_resolver_universe.cc, src/generic/aptitude_resolver_universe.h:

	  Move most of the implementation of the resolver universe into a
	  .cc file.

	* src/solution_screen.cc:

	  View unresolved recomendations in the solution tree too.
	  Untested; I need to come up with a test case where recommends
	  can't be satisfied.

	* src/solution_fragment.cc, src/solution_fragment.h:

	  Rename dep_targets_fragment to dep_targets; now it just
	  generates a plain string (and is a candidate for being pushed
	  down into the generic layer).

	* src/generic/aptcache.cc:

	  Slightly *reward* longer solutions, rather than slightly
	  penalizing them.  Although this might produce lower-quality
	  solutions, it has the effect of encouraging the resolver to
	  focus on more "mature" lines of reasoning, rather than backing
	  up and looking at alternatives first.

	* src/cmdline/cmdline_resolver.cc, src/solution_fragment.cc, src/solution_fragment.h:

	  Move some code for formatting information relevant to solutions
	  into solution_fragment.cc, and use it to output a list of
	  unresolved soft dependencies.

	* src/generic/problemresolver/problemresolver.h:

	  When looking for forced deps, leave soft deps with exactly one
	  resolver alone instead of discarding them.

2005-08-15  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Add an assert to check that things remain sane.

	* src/generic/problemresolver/problemresolver.h:

	  Correct the calculation of the new score when choosing to leave
	  a soft dependency unfixed.

	* tests/test_resolver.cc:

	  Correct the comparison of s1 and s2 (they should be equivalent).

	* src/generic/problemresolver/solution.h:

	  Uh, yeah, let's construct the set of unresolved soft deps by
	  *inserting* elements instead of removing them, eh?

	* tests/test_resolver.cc:

	  Fix the solution test to not require an operator<.

	* src/generic/problemresolver/problemresolver.h:

	  Make the ResolverTest class a friend so it can test internals of
	  the resolver.

	* src/generic/problemresolver/solution.h:

	  Keep the compiler from automatically generating an operator< for
	  solutions (which fooled me on at least one occasion into using
	  solutions as if they had a meaningful operator<).

	* tests/test_resolver.cc:

	  Fix several outright crashes in the solution test.

	* src/generic/problemresolver/test1.txt, src/generic/problemresolver/test3.txt:

	  Fix the test cases for the new solution formats.

	* tests/test_resolver.cc:

	  Add a test case for solution comparison; add more test cases to
	  action comparison.

	* tests/Makefile.am, tests/test_resolver.cc:

	  Add a first iteration of a real test case for the resolver.

	* src/generic/problemresolver/dummy_universe.cc, src/generic/problemresolver/dummy_universe.h, src/generic/problemresolver/test.cc:

	  Move some of the universe parsing code to the dummy_universe
	  interface file.  More to be done here.

	* src/generic/problemresolver/dummy_universe.h:

	  Add an interface for changing the current version of a package
	  after the fact.

	* src/generic/problemresolver/Makefile.am, src/generic/problemresolver/dummy_universe.cc, src/generic/problemresolver/dummy_universe.h, src/generic/problemresolver/test.cc:

	  Split the dummy universe out of the resolver test program so
	  that it can be used by other code.

	* src/generic/Makefile.am:

	  Add exceptions.h to Makefile.am.

	* src/generic/problemresolver/exceptions.h:

	  Make the problem resolver exceptions variants of Exception.

	* src/generic/Makefile.am, src/generic/exception.h:

	  Move the Exception class to the generic layer.

	* src/generic/problemresolver/problemresolver.h:

	  Fix comparison-by-contents of solutions so that the set of
	  unresolved soft dependencies is taken into account; should fix
	  the bug where the option of leaving a soft dependency unresolved
	  was dismissed immediately.

	* src/generic/problemresolver/solution.h:

	  Write operator== and operator!= that obey the rule about action
	  identities being based on the version installed.

	* src/generic/problemresolver/problemresolver.h:

	  Add missing conditionalization (only dump information about soft
	  dependencies when debugging is enabled).

	* src/generic/problemresolver/solution.h:

	  Fix how unresolved soft dependencies are displayed when dumping
	  a solution.

	* src/generic/aptitude_resolver_universe.h:

	  Make all critical deps and all recommends interesting.

2005-08-15 Miroslav Kure <kurem@upcase.inf.upol.cz>

	* General Czech translation update
	
2005-08-12  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc, src/generic/aptitude_resolver_universe.h, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h, src/generic/problemresolver/dump_universe.h, src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/solution.h, src/generic/problemresolver/test.cc:

	  Add basic support for "soft dependencies" (i.e., recommends) to
	  the resolver.

	* src/generic/aptcache.cc:

	  Don't try so hard to avoid keeping or upgrading packages, try a
	  little harder to preserve manual selections.

	* src/generic/aptitude_resolver.cc:

	  Make changes to automatically installed, automatically
	  to-be-removed, or removed packages costless.  This fixes an
	  exponential blowup caused by one-step-forward-two-steps-back
	  tendencies in the resolver.

	* src/generic/problemresolver/problemresolver.h:

	  Add a counter to show (when debugging) how many steps the
	  resolver took to converge on a solution.

2005-08-11  Daniel Burrows  <dburrows@debian.org>

	* src/solution_screen.cc:

	  Advance to the next element after selecting/rejecting an element
	  in a solution.

	* src/generic/problemresolver/problemresolver.h, src/generic/aptcache.h, src/generic/aptcache.cc, src/solution_screen.cc:

	  The "I have too many forbids floating around" commit: change the
	  API that lets the user entirely forbid the resolver from
	  generating solutions containing a particular version so that it
	  instead talks about "rejecting" such solutions.

	* src/cmdline/cmdline_action.cc:

	  Honor the Auto-Install option in the command-line layer.

	* src/generic/aptitude_resolver.cc, src/generic/problemresolver/problemresolver.h:

	  Add an option to enable or disable the elimination of "stupid
	  pairs".

	* src/generic/problemresolver/problemresolver.h:

	  Only put destupidified solutions back on the open queue if they
	  dropped versions (otherwise we just discard them because they're
	  already on the closed queue).

	* src/generic/problemresolver/problemresolver.h:

	  Add a debug output line and an assert.

	* src/generic/problemresolver/problemresolver.h:

	  Drop stupid pairs that are eliminated from the table of stupid
	  pairs.

	* src/cmdline/cmdline_resolver.cc:

	  Add support for viewing a solution in "action order".

	* src/solution_fragment.h:

	  Export archives_fragment.

	* src/ui.cc:

	  Trim unnecessary #includes here too.

	* src/solution_screen.cc:

	  Trim unnecessary includes here too.

	* src/solution_fragment.cc:

	  Don't #include problemresolver.h from here either.

	* src/solution_dialog.cc:

	  Trim back #includes further.

	* src/cmdline/cmdline_resolver.cc:

	  Trim back #includes of problemresolver stuff.

	* src/cmdline/cmdline_dump_resolver.cc:

	  Trim back the #includes of problemresolver stuff.

	* src/cmdline/cmdline_do_action.cc:

	  Remove an unnecessary #include.

	* src/broken_indicator.cc:

	  Trim back the #includes of problemresolver stuff to just the
	  solution class.

	* src/generic/problemresolver/solution.h: 

	  Add #includes that are missing now that this file has been
	  lifted out of problemresolver.h.

	* src/main.cc:

	  Only #include exceptions.h, not problemresolver.h.

	* src/generic/problemresolver/Makefile.am, src/generic/problemresolver/exceptions.h, src/generic/problemresolver/problemresolver.h:

	  Move the exceptions generated by the resolver to a separate
	  file.

	* src/generic/problemresolver/Makefile.am, src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/solution.h:

	  Move the solution class to a separate file.

	* src/generic/Makefile.am, src/generic/aptitude_resolver.h, src/generic/aptitude_resolver_universe.h:

	  Push the aptitude resolver "universe" into a separate file.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Add an initial implementation of the stupid pair elimination
	  algorithm.  This is a bit messy; some of the auxillary templated
	  classes I introduced look to me like candidates for elimination
	  or candidates to be moved to a more generic location.

2005-08-10  Daniel Burrows  <dburrows@debian.org>

	* src/generic/util.h, tests/test_misc.cc:

	  Add a generic routine to compare pairs without respect to order.

	* src/generic/problemresolver/model.tex:

	  Put both algorithms on one page.

	* src/generic/problemresolver/model.tex:

	  Fix LaTeX errors.

	* src/generic/problemresolver/model.tex:

	  Finish the correctness proof of the algorithm, start blathering
	  about efficiency.

	* src/generic/problemresolver/model.tex:

	  Start describing how to eliminate "stupid pairs" from solutions,
	  including a preliminary writeup of the algorithm to use.

2005-08-10  Clytie Siddall <clytie@riverland.net.au>

	* Update to Vietnamese translation. (Closes: #322276)
	
2005-08-09  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Add support for reading off dependencies and placing them in
	  "story order".

	* src/defaults.cc, src/solution_fragment.cc:

	  Use the new methods to allow the user to interactively narrow
	  the search for a solution.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add hooks in the apt cache interface layer for manipulating
	  forbidden versions.

	* src/generic/problemresolver/problemresolver.h:

	  Add initial support for user-forbidden versions.

	* src/solution_screen.cc:

	  Fix item highlighting.

	* src/vscreen/vs_tree.cc:

	  Include the highlight status in the style passed to
	  vs_treeitem::paint().

	* src/solution_screen.cc:

	  Write a specialized treeitem class to represent the elements of
	  a solution.

	* src/Makefile.am, src/solution_screen.cc, src/solution_screen.h, src/ui.cc:

	  Initial work towards a top-level solution examination screen.

	* src/pkg_info_screen.cc:

	  Remove a #include of vs_staticitem.

	* src/vscreen/vs_staticitem.h:

	  Further adjustment to vs_staticitem: tag() and label()
	  should be non-const now.

	* src/vscreen/vs_staticitem.cc, src/vscreen/vs_staticitem.h:

	  Make vs_staticitem a concrete class.

	* src/vscreen/vscreen.cc:

	  When trapping KEY_RESIZE, check first that we have a
	  KEY_CODE_YES event.

	* src/ui.cc:

	  If su-to-root fails, load selections from the file that we saved
	  in order to become root (rather than immediately zapping it and
	  forgetting all stored selections). (Closes: #281232)

	* src/vs_progress.cc:

	  Hide the progress bar in Done *after* triggering a screen
	  update, and un-hide it in Update().  With this change, progress
	  bars will be displayed across multiple Done() calls, but will
	  hide themselves after the last Done() call.

2005-08-08  Daniel Burrows  <dburrows@debian.org>

	* src/ui.cc:

	  Redesign how the active preview and tree are handled: use the
	  active preview for everything but actually building the tree; it
	  particular, show and destroy it instead of the tree.  Fixes the
	  problem where the preview tree disappeared from the preview
	  screen, without crashing due to double-destroying the preview.

	* src/download_list.cc:

	  *Do* destroy the download list when the download is complete, so
	  it disappears (it's safe: the only other way to destroy it is
	  from the 'q' handler, which can't trigger once the list is
	  destroyed).

	* src/ui.cc:

	  Don't redundantly delete the preview tree; fixes a segfault.

	* src/generic/matchers.cc, doc/en/aptitude.xml:

	  Add a "downgrade" action for use with ~a.

	* Makefile.am:

	  Distribute README.SMART-POINTERS.

	* src/vscreen/vs_label.cc, src/vscreen/vs_label.h:

	  Restore the old behavior of setting the background of the whole
	  widget from the constructor of vs_label, not just the color of
	  the actual text.

	* src/ui.cc:

	  Use sw?sprintf rather than a local w?snprintf in several spots.

	* src/vscreen/vs_util.cc:

	  Change an implementation signature of vs_dialog_fileview to
	  match the corresponding interface signature (fixes an undefined
	  reference at link time).

	* src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	  Fill in the missing focus_widget_bare routine.

	* src/ui.cc:

	  Pre-emptively weaken a bound reference.

	* src/view_changelog.cc:

	  Update the changelog viewer for refcounting.

	* src/vscreen/vs_pager.h:

	  Restore the default value for the "encoding" argument of the
	  vs_file_pager constructors.

	* src/vscreen/vs_pager.h:

	  Make the vs_file_pager constructors protected, not private.

	* src/download_list.cc:

	  Fix the default second parameter to download_list::create.

	* src/ui.cc:

	  Many updates to ui.cc to bring it in line with the new
	  interfaces and conventions.

	* src/dep_item.h:

	  Update pkg_dep_screen for the reference-counting protocol.

	* src/download_manager.cc:

	  Doh, set_widget isn't a constructor, don't write it like one.

	* src/download_manager.cc, src/download_manager.h:

	  Implement the constructors and set_widget in the .cc to avoid
	  needing more includes.

	* src/vscreen/vscreen_widget.cc:

	  Go past silently doing nothing if a widget is destroyed twice;
	  actually abort the program if this occurs.

	* src/vscreen/vs_menubar.cc, src/vscreen/vs_minibuf.cc, src/vscree/vs_stacked.cc, src/vscreen/vs_table.cc:

	  Make sure that we explicitly zero out the "owner" field of
	  widgets that are removed from these containers.  This has the
	  useful side effect of causing the Curses windows to be
	  invalidated and hence making the assertion(!win) succeed.

	* src/vscreen/vs_radiogroup.cc:

	  Fix a thinko: when we're removing the last button in a radio
	  group, of course there should be exactly ONE button in the
	  group, not exactly ZERO.

	* src/vscreen/vs_table.cc:

	  Be more careful in handling iterators so that the table routines
	  don't crash when the last widget is removed.

	* src/vscreen/vs_bin.cc, src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h, src/vscreen/vs_menubar.cc, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_multiplex.cc, src/vscreen/vs_stacked.cc, src/vscreen/vs_table.cc:

	  Make sure that all containers destroy their contents in their
	  own destroy() routines.  NB: since destroy() has a side effect
	  of "remove me from my parent", the actual form of these routines
	  may be a bit surprising!.

	* src/ui.cc, src/vscreen/testvscreen.cc, src/vscreen/vscreen.cc, src/vscreen/vscreen.h:

	  Update the handling of the top-level widget: you should now call
	  vscreen_shutdown() when shutting the program down instead of
	  rootwin.endwin(), which will destroy and drop the top-level
	  widget; and you can retrieve the old top-level when setting up a
	  new one (in fact, you must, in order to make sure that destroy()
	  is called before deleting the pointer).

	* src/vscreen/vscreen_widget.cc:

	  Don't call destroy() from the destructor, and don't bother
	  clearing out the signals in destroy() (the latter change could
	  be reversed if I made it a requirement for ALL derived classes
	  to clear ALL signal lists in destroy(), but I think that for the
	  time being, I'll settle for requiring the widget to be
	  disconnected from all events after destroy().

	  Incidentally, calling destroy() from the destructor was a truly
	  awful idea -- not only is it a complex member function, it's
	  virtual! [EDIT: doh, it wasn't being called from a destructor.
	  Please ignore my stupidity]

	* src/vscreen/vs_radiogroup.cc:

	  Handle the case of removing the last button in a radio group.

	* src/vscreen/testvscreen.cc:

	  Close a memory leak reported by valgrind.

	* src/vscreen/vs_bin.cc, src/vscreen/vs_bin.h, src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h, src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h, src/vscreen/vs_stacked.cc, src/vscreen/vs_stacked.h, src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	  Create a new protocol for destroying widgets: a widget should
	  destroy and disconnect all of its children immediately upon
	  receiving destroy(), but the actual deletion of its instance
	  might be deferred if strong references to it exist (for
	  instance, if some information needs to be retrieved from it).

	  The test program runs and exits without errors now.

	* src/vscreen/vscreen_widget.cc:

	  Only assert that we lost our window if we had an owner: owned
	  widgets are removed from their owners, which must invalidate the
	  window, but unowned widgets can be the top-level widget and
	  might still have a window when the program exits.

	* src/solution_dialog.cc, src/solution_dialog.h:

	  Update the solution dialog for refcounting.

	* src/pkg_view.cc, src/pkg_view.h:

	  Update the package view generation code for refcounting.

	* src/vscreen/ref_ptr.h:

	  Make the dynamic downcast take a target class, not a target
	  class pointer, as its template argument.

	* src/pkg_ver_item.cc, src/pkg_ver_item.h:

	  Update pkg_ver_item for refcounting.

	* src/pkg_info_screen.h:

	  Update the pkg_info_screen signature for refcounting.

	* src/pkg_tree.cc, src/pkg_tree.h:

	  Update pkg_tree for refcounting.

	* src/edit_pkg_hier.h:

	  Whoops, make ::create() static.

	* src/pkg_item.cc:

	  Update the pkg_item implementation for refcounting.

	* src/edit_pkg_hier.h:

	  Update the vs_hier_editor class for the refcounting protocol.

	* src/vs_progress.cc, src/vs_progress.h:

	  Update the vs_progress class for the refcounting protocol.

	* src/download_bar.cc, src/download_bar.h:

	  Add missing size request implementations so the bar compiles.

	* src/download_list.cc, src/download_list.h:

	  Update the download list for refcounting.

	* src/download_bar.cc:

	  Make the constructor protected.

	* src/download_bar.cc:

	  Fix the download bar for the refcounting protocol.

	* src/download.cc:

	  Fix the download code for the refcounting protocol.

	* src/broken_indicator.cc, src/broken_indicator.h:

	  Fix the broken_indicator class to work in the presence of
	  reference counting.

	* src/vscreen/vs_text_layout.h:

	  Constructors should be protected, not private.

	* src/apt_config_widgets.cc, src/apt_config_widgets.h, src/apt_options.cc, src/apt_options.h:

	  Convert the configuration <-> UI interface layer to use the
	  reference-counting protocol (and, while I'm at it, stop using
	  multiple inheritance here).

	* src/main.cc:

	  Use a counting reference for the initial progress bar.

	* README.SMART-POINTERS:

	  Add some documentation on the use of smart pointers in aptitude.

	* src/cmine/cmine.cc, src/cmine/cmine.h:

	  Fix the Minesweeper code for ref_ptrs.

	* src/ui.h:

	  Use ref_ptrs in interface routines.

	* src/vscreen/vs_editline.h:

	  Add missing "const" qualifier to a constructor reference
	  argument.

	* src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Further reduce header interdependencies by forward-declaring the
	  ref_ptr class.

	* src/vscreen/ref_ptr.h, src/vscreen/testvscreen.cc, src/vscreen/vs_bin.cc, src/vscreen/vs_bin.h, src/vscreen/vs_container.cc, src/vscreen/vs_container.h, src/vscreen/vs_frame.cc, src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h, src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h, src/vscreen/vs_radiogroup.cc, src/vscreen/vs_radiogroup.h, src/vscreen/vs_stacked.cc, src/vscreen/vs_stacked.h, src/vscreen/vs_table.cc, src/vscreen/vs_table.h, src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Binding references as slot arguments causes weird and painful
	  problems.  Instead, use sigc++ weak references (sigc::ref);
	  since I want to be able to easily connect signals to public
	  methods, adopt the convention of providing a (non-virtual) _bare
	  variant of methods that take a refcounted pointer as an
	  argument; the variant accepts a reference to the underlying type
	  and wraps it in a ref_ptr before handing it to the real method.

2005-08-06 Rubén Porras <nahoo@inicia.es>

	* updated po/es.po

	* fixed Last-Translator field in po/vi.po

	* regenerate po/aptitude.pot and po files.
	
2005-08-06 Erçin EKER <erc.caldera@gmx.net>

	* updated po/tr.po

	* new help-tr.txt
	
2005-08-06  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/fragment.cc:

	  Fix an access-past-end-of-string discovered by valgrind.

	* src/vscreen/testvscreen.cc, src/vscreen/vs_bin.cc, src/vscreen/vs_bin.h, src/vscreen/vs_button.h, src/vscreen/vs_center.cc, src/vscreen/vs_center.h, src/vscreen/vs_container.cc, src/vscreen/vs_container.h, src/vscreen/vscreen.cc, src/vscreen/vscreen.h, src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h, src/vscreen/vs_editline.cc, src/vscreen/vs_editline.h, src/vscreen/vs_frame.cc, src/vscreen/vs_frame.h, src/vscreen/vs_label.cc, src/vscreen/vs_label.h, src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h, src/vscreen/vs_menu.h, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h, src/vscreen/vs_pager.h, src/vscreen/vs_passthrough.cc, src/vscreen/vs_passthrough.h, src/vscreen/vs_radiogroup.cc, src/vscreen/vs_radiogroup.h, src/vscreen/vs_scrollbar.h, src/vscreen/vs_size_box.cc, src/vscreen/vs_size_box.h, src/vscreen/vs_stacked.cc, src/vscreen/vs_stacked.h, src/vscreen/vs_statuschoice.h, src/vscreen/vs_table.cc, src/vscreen/vs_table.h, src/vscreen/vs_text_layout.h, src/vscreen/vs_togglebutton.h, src/vscreen/vs_transient.cc, src/vscreen/vs_transient.h, src/vscreen/vs_tree.h, src/vscreen/vs_util.cc, src/vscreen/vs_util.h, src/vscreen/ref_ptr.h:

	  Convert the vscreen code over to using reference-counted
	  pointers for inter-object references.  This is a sensible thing
	  to do since widgets form a tree -- normally you'll just see a
	  widget's owner holding onto references to it (but in special
	  cases some other references could exist).

	  This change breaks everything.  Whee!

	* src/vscreen/vscreen_widget.cc:

	  Fix a gaping bug and memory leak that only just came to my
	  attention.  Stuff that was destroyed wasn't being deleted!
	  Apparently I commented the code that did the deletion out while
	  debugging and never reinstated it.  Doh!

	* src/ui.cc:

	  Really set the global apt error dialog to NULL when it is
	  destroyed.  Should fix the problem where the apt error dialog
	  only appears once...not to mention any weird memory corruption
	  bugs caused by this.

	* src/pkg_tree.cc:

	  Fix the invocation of parse_pattern so it doesn't flag errors
	  (restoring the past behavior).

	* src/generic/matchers.cc:

	  Change the 'keep' matcher to detect ANY package that no action
	  is being performed on, including not-installed packages.

	* src/generic/matchers.cc:

	  Fix the behavior of NOT when match results are being stored.

	* src/generic/aptcache.cc:

	  Only write the target version if the user actually planned to
	  install it; only set up an installation if the user requested it
	  previously (i.e., the Upgrade field was written).

	* src/pkg_item.cc, src/pkg_ver_item.cc, src/ui.cc:

	  Always destroy progress bars when we're done with them, so they
	  don't leak and hang around taking up space (in the past they
	  just leaked silently, but now they also make stuff look bad!)

	* src/vscreen/vscreen.cc, src/vscreen/vscreen.h, src/vscreen/vscreen_widget.h:

	  Explicitly reset SIGCONT and SIGTSTP to SIG_DFL in
	  vscreen_suspend and restore them in vscreen_resume.  If you
	  don't want to reset the signals for some reason, you can use
	  vscreen_suspend_without_signals().  (Closes: #137311, #169479)

2005-08-05  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc:

	  Always save the version to be installed, so long as it's a
	  change from the current version but not the same as the default
	  candidate version.  This should handle the problem that the
	  version to install isn't saved in a reasonably intuitive way.
	  (Closes: #158771)

	* src/ui.cc:

	  Add canned views to display a flat package list and to display a
	  debtags browser.

	* src/cmdline/cmdline_show.cc, src/desc_parse.cc, src/desc_parse.h, src/pkg_info_screen.cc, src/pkg_view.cc:

	  Show package tags right after the description everywhere that
	  it's appropriate.

	* src/load_grouppolicy.cc:

	  Parse empty policies without crashing.

	* doc/en/aptitude.xml, src/load_grouppolicy.cc, src/pkg_grouppolicy.cc, src/pkg_grouppolicy.h:

	  Add support for grouping packages using debtags information.

	* src/generic/tags.cc, src/generic/tags.h:

	  Add code to load in the tag vocabulary database.

	* src/download.cc:

	  Apply Michael Vogt's patch for apt status reporting.

2005-08-04  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml, src/generic/matchers.cc, src/generic/matchers.h:

	  Make the matching language whitespace-insensitive: to include
	  literal whitespace, you must now place it between double quotes
	  or tilde-escape it.

	* src/generic/matchers.h, src/load_grouppolicy.cc, src/pkg_grouppolicy.h:

	  Total rewrite of the load_grouppolicy code, and a few interface
	  changes to accomodate it.  Instead of assuming a fully regular
	  syntax and splitting grouping declarations up-front,
	  load_grouppolicy now works by chaining parsers together, where
	  each parser implicitly pulls its text off as a side effect.
	  This will make nested policies feasible; it also means that the
	  pattern grouping policy should now work correctly even in the
	  presence of things like parentheses within the pattern.

	* src/generic/matchers.cc, src/generic/matchers.h:

	  Change the parse_pattern interface again (and make it less
	  efficient) in order to allow arbitrary (possibly
	  multi-character) strings to be used as terminators.  In
	  particular, this will mean I can get the patterns grouping
	  policy (with its "=>" delimiter) working properly without
	  comprimising on the syntax.

	* src/generic/util.cc, src/generic/util.h:

	  Write generic (inefficient) code to produce string objects
	  from formatting codes (like printf).

2005-08-02  Daniel Burrows  <dburrows@debian.org>

	* src/generic/matchers.cc, src/generic/matchers.h:

	  Make the parser more generic: you can pass in a set of
	  characters that should terminate the match if they are
	  encountered at the top syntactic level.  The loader will use
	  this (but doesn't yet) to safely split its arguments.

2005-07-27  Daniel Burrows  <dburrows@debian.org>

	* src/generic/matchers.cc, src/generic/matchers.h:

	  Change the external and internal interfaces to use iterators
	  rather than passing in a string and directly indexing into it.
	  The start iterator is modified as a side-effect, which should
	  eventually allow continuation-based parsing (i.e., just parse
	  the first thing that looks like a match term and then stop).  I
	  might need to think more about just how this will work, though.

2005-07-26  Daniel Burrows  <dburrows@debian.org>

	* tests/Makefile.am, tests/test_misc.cc:

	  Add a file for tests that don't belong elsewhere.

	* tests/Makefile.am, tests/test_tags.cc:

	  Update the source to compile with the lifted suites.

	* configure.ac, Makefile.am, src/generic/Makefile.am, src/generic/tests/, tests/:

	  Move the test suites up to the top level.

2005-07-25  Daniel Burrows  <dburrows@debian.org>

	* src/pkg_grouppolicy.cc:

	  In the custom pattern-based grouping policy, stop checking
	  patterns after the first match.

	* src/pkg_grouppolicy.cc:

	  In the custom pattern-based grouping policy, when creating a new
	  subtree of the current tree, make sure to actually add the
	  object that triggered the creation of the subtree to the new
	  subtree.

	* src/generic/tasks.cc:

	  For some reason, pkgTagSection.Scan() requires one more than the
	  length of the section to work properly.  Either that or GetRec
	  returns an inclusive range.  Either way, parsing tags from the
	  Packages file should work now.

	* src/generic/tags.cc, src/generic/tags.h, src/generic/tests/test_tags.cc:

	  Keep a local copy of the data for each tag and tag list.
	  Without this, all sorts of hell breaks loose due to stuff being
	  deleted at bad times (doh).

	* src/generic/tags.cc:

	  Fix the tag list parser so it doesn't routinely skip the first
	  tag out of a list of tags.  All tests pass now!

	* src/generic/tests/test_tags.cc:

	  Fix a reversed-sense test (we want to test a<b and b>a,
	  not a<b and a>b).

	* src/generic/tags.h:

	  Fix the breakage in the comparison operators.

	* src/generic/tests/test_tags.cc:

	  Add specialized test forms for comparison tests.

	* src/generic/tags.cc:

	  Fix an incorrect bounds-check (I tested an iterator on the
	  container "other" against the end() of "this").  Clears up
	  another failing test case. :-)

	* src/generic/tags.cc:

	  Strip whitespace from the front and back of tags upon
	  construction.

	* src/generic/tests/test_tags.cc:

	  Add an operator<< implementation to write tags directly
	  for debug messages.

	* src/generic/tests/test_tags.cc:

	  Use ASSERT_EQUAL instead of ASSERT for equality-based tests; I
	  hope that this prints more useful assertion-failure messages.

	* src/generic/tests/main.cc:

	  As I suspected, the return value of runner.run() was reversed;
	  fix it so the test harness actually reports errors to its
	  caller.

	* src/generic/tests/Makefile.am:

	  Run the tests on "make check".

	* src/generic/tests/test_tags.cc:

	  Test the tag parser more exhaustively.

	* doc/en/aptitude.xml, src/generic/matchers.cc:

	  Add a tag matcher, to match against the new Tags field.
	  Currently it's broken, but it's a start.
	  (Closes: #243830)

	* src/generic/tags.h:

	  Add a routine to retrieve the plain text of a single tag.

	* src/cmdline/cmdline_changelog.cc:

	  Add heuristics to guess where the changelog of a package that we
	  don't have direct information about /might/ be; i.e., to allow
	  fetching changelogs of packages that aren't referenced from
	  sources.list.

	* src/generic/pkg_changelog.cc:

	  It's no longer necessary to look up the source package in
	  pkg_changelog_form_source, so don't.

	* src/generic/pkg_changelog.cc:

	  Don't crash if an end version iterator is passed into
	  get_changelog.

	* doc/en/manpage.xml, src/cmdline/cmdline_changelog.cc, src/generic/pkg_changelog.cc, src/generic/pkg_changelog.h:

	  Let the user pass source packages as well as binary packages
	  into the "changelog" command-line action.

	* src/cmdline/cmdline_changelog.cc, src/generic/pkg_changelog.cc, src/generic/pkg_changelog.h:

	  Add the ability to find changelog based on the source package
	  name as well as an iterator to a binary package version.  Also
	  eliminated the hardcoded default for PulseInterval and changed
	  the invocation of pkg_changelog in cmdline_changelog.cc
	  accordingly.

	* src/pkg_grouppolicy.cc:

	  Patch up a memory leak in the matchers grouping policy.

	* doc/en/aptitude.xml, src/load_grouppolicy.cc, src/pkg_grouppolicy.cc, src/pkg_grouppolicy.h, src/pkg_tree.cc, src/ui.cc:

	  Do something like the "missing" filter in pkg_tree itself.
	  Handle patterns in the filter class now, but for backwards
	  compatibility, interpret the literal string "missing" as a NOP.

	* doc/en/aptitude.xml, src/load_grouppolicy.cc, src/pkg_grouppolicy.cc, src/pkg_grouppolicy.h, src/generic/Makefile.am, src/generic/util.cc, src/generic/util.h:

	  Add a "patterns" grouping policy and start a long-overdue
	  collection of generic utility routines to kill off some of my
	  duplication of code. (Closes: #156065)

	* src/generic/matchers.cc:

	  Match anything with an empty pattern.

2005-07-24 Clytie Siddall <clytie@riverland.net.au>

	* Updated Vietnamese translation
	  Closes: #319702

2005-07-24  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Fix the formatting of the %# documentation and change the
	  dangling secStyles reference to refer to secStyle.

2005-07-23  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml, src/cmdline/cmdline_search.cc, src/pkg_columnizer.cc, src/pkg_item_width_subtree.h, src/vscreen/config/column_definitions.cc, src/vscreen/config/column_definitions.h:

	  Add support for parametric column formatting.

	* src/generic/matchers.cc, src/generic/matchers.h:

	  Move implementation of ~pkg_matcher to the .cc file,
	  mark get_match in pkg_matcher as abstract; give get_match
	  in pkg_task_matcher the correct signature to implement
	  the abstract interface.

	* src/generic/matchers.cc, src/generic/matchers.h:

	  Add support for retrieving a string corresponding to a match.

2005-07-22  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Fix the Python tribute (thanks to Andy G. Wood for pointing this
	  out).

2005-07-21  Daniel Burrows  <dburrows@debian.org>

	* configure.ac, src/generic/Makefile.am, src/generic/tests/Makefile.am, src/generic/tests/main.cc, src/generic/tests/test_tags.cc:

	  Add some basic magic to generate a unit tester with cppunit.

	* src/generic/Makefile.am, src/generic/apt.cc, src/generic/tags.cc, src/generic/tags.h:

	  Add backend support for parsing the new tag database.

	* src/generic/tasks.cc, src/generic/apt.h:

	  Lift the stuff to order versions by their file location
	  into apt.h so other modules can use it.

2005-07-12 Jean-Luc Coulon  <jean-luc.coulon@wanadoo.fr>

	* Completed French translation. Closes: #318906
	
2005-07-19 Sorin Batariuc <sorin@bonbon.net>

	* Updated romanian translation. Closes #318947 

2005-07-16 Rubén Porras <nahoo@inicia.es>

	* Fix po/aptitude.pot and po files. Last time I forgot to add
	  --keyword=P_ to xgettext.

	* Fix redundancy in displayed string. Thanks to Jacobo Tarrio
	  <jtarrio@trasno.net>. Closes #318396

2005-07-16 Morten Bo Johansen <mojo@gatsby.mbjnet.dk>
	
	* Updated danish translation. Closes #317824 
	
2005-07-15 Rubén Porras <nahoo@inicia.es>

	* Add comments for tranlators to src/pkg_ver_item.cc and
	  src/pkg_columnizer.cc

	* Regenerated po/aptitude.pot and all po files

	* Updated spanish translation

	* Now we need to add --add-comments=ForTranslators to xgettext
	  command line to generate the aptitude.pot with comments.
	  NOTE: the full command is 
	  xgettext --keyword=_ --keyword=P_ --keyword=N_ 
	  --add-comments=ForTranslators -o po/aptitude.pot -f po/POTFILES.in
	  

2005-07-13  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Remove an obsolete reference to Aptitude::UI::Colors.

	* doc/en/manpage.xml, src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_do_action.h, src/cmdline/cmdline_upgrade.cc, src/cmdline/cmdline_upgrade.h, src/main.cc:

	  Add basic support for writing commands to the selection database
	  without actually executing them.  (NB: this may do bad things in
	  corner cases, like selecting particular versions)

	  (Closes: #312249)

	* doc/en/aptitude.xml, src/cmdline/cmdline_do_action.cc, src/main.cc:

	  Add support for "keep" and "keep-all" commands; the former
	  cancels actions on a single package, while the latter cancels
	  all currently contemplated actions.  (Closes: #312923)

2005-07-12 Jean-Luc Coulon  <jean-luc.coulon@wanadoo.fr>

	* Updated French translation (sent through the French mailing list)
	
2005-07-11  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Remove some no-longer-necessary debug code.

	* src/generic/aptitude_resolver.h:

	  When leaving a Provides list while iterating over broken deps,
	  make sure to explicitly set the variable indicating whether the
	  list is open or not to "false" (oops!).  The other pieces of
	  code that use the prv_open pattern seem to handle it correctly.

	* src/pkg_grouppolicy.cc, src/pkg_grouppolicy.h:

	  Add missing virtual destructor for pkg_grouppolicy_factory.

	* src/generic/strhash.h:

	  Add a missing "template <>".

	* src/generic/problemresolver/problemresolver.h:

	  Remove a never-used method that referred to a nonexistant
	  variable.

2005-07-10  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/test.cc:

	  Disable dumping the world in the test code by default, but let
	  the user enable it with --dump.

	* doc/en/aptitude.xml:

	  Correct the documentation of the default binding of DumpResolver
	  (it was originally F6, which was a bad idea for obvious reasons,
	  but I apparently changed it to '*' and forgot to change the
	  docs).

2005-07-10 Clytie Siddall <clytie@riverland.net.au>

	* Updated Vietnamese translation
	  Closes: #317629
	
2005-07-07  Daniel Burrows  <dburrows@debian.org>

	* src/cmine.cc, src/ui.cc:

	  Use the new support to add search repetition capabilities to all
	  dialogs. (Closes: #270699)

	* src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Also add support for binding up a callback for the 'ReSearch'
	  keystroke.

	* src/reason_fragment.cc:

	  Remove a no longer necessary %S escape.

	* src/view_changelog.cc:

	  Add support for searching for text in the changelog viewer.

2005-07-05 Rubén Porras <nahoo@inicia.es>

	* New spanish help file help-es.txt
	
2005-07-07 Jean-Luc Coulon <jean-luc.coulon@wanadoo.fr>

	* Updated French translation (still to be completed)
	
2005-07-06  Daniel Burrows  <dburrows@debian.org>

	* src/ui.cc:

	  Delete a no-longer-needed reference to a style name.

	* src/vscreen/fragment.cc:

	  Actually recognize the %S escape.

	* src/vscreen/vs_pager.cc:

	  Fix a number of corner cases involving negative widths and
	  unprintable characters.  (Closes: #317115)

	* src/cmdline/cmdline_show.cc:

	  Fix output of wide characters. (Closes: #317115)

2005-07-05 Rubén Porras <nahoo@inicia.es>

	* Convert to UTF8 the following files:
	  help-zh_CN.txt
	  help-ja.txt
	  help-fi.txt
	  help-cs.txt
	  help-gl.txt
	  help-fr.txt
	  help-pl.txt
	  help-pt_BR.txt
	
2005-07-05 Jaakko Kangasharju <ashar@iki.fi>

	* Complete Finnish translation for Aptitude. After adding the
	  relevants patches from #316225 (the ones modifing debian'n dir
	  in aptitude-fi.patch.gz) we can close this bug.
	
2005-07-05 Clytie Siddall <clytie@riverland.net.au>

	* Updated Vietnamese translation
	  Closes: #316994
	
2005-07-05  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_resolver.cc:

	  Display information about what went wrong when there's a problem
	  writing out a resolver dump.

	* src/generic/aptitude_resolver.h:

	  Don't abort when trying to dump a package that has only one
	  version.  (doh, 0 is a valid index!)

	* doc/en/aptitude.xml:

	  Fix several typos pointed out by Miroslav Kure.

	* src/cmdline/cmdline_progress.cc:

	  Calculate the screen width correctly: I suspect that there is an
	  off-by-one error in the progress bar that the
	  update_screen_width function originally compensated for.

	* src/cmdline/cmdline_search.cc:

	  Fix a minor race condition that could have resulted in "search"
	  not obeying the -w (width) option if the terminal was resized
	  during a search.

	* src/cmdline/cmdline_search.cc:

	  Fix "search" output. (Retroactively Closes: #317115)

2005-07-05 Rubén Porras <nahoo@inicia>
	
	* Updated spanish translation
	
2005-07-04  Daniel Burrows  <dburrows@debian.org>

	* NEWS, README, doc/en/aptitude.xml:

	  Bump version to 0.3.3.

	* doc/en/aptitude.xml:

	  Correct the documentation of several configuration options that
	  had been invalidated by changes to the program.

	* src/download.cc, src/view_changelog.cc:

	  Decrease the polling rate of downloads.  Again.

	* doc/aptitude.css:

	  Various tweaks to make the generated documentation a bit
	  nicer-looking (maybe too fancy in some places, though?).

	* doc/aptitude.css, doc/aptitude-common.xsl:

	  Update the stylesheets: shade.verbatim is deprecated, so I've
	  moved those configuration parameters into CSS.

	* doc/en/aptitude.xml:

	  Replace the documentation dealing with color configuration with
	  documentation addressing style configuration.

	* src/load_config.cc:

	  Pass Value to parse_color, not Tag; setting colors in the
	  configuration file now works.

	* src/load_config.cc:

	  Don't go into an infinite loop trying to parse text attributes.

2005-07-03  Daniel Burrows  <dburrows@debian.org>

	* src/generic/pkg_changelog.cc, src/generic/pkg_changelog.h, src/view_changelog.cc:

	  Update more frequently when downloading changelogs, too.

	* doc/en/aptitude.xml, src/download.cc:

	  Drop the frequency of screen updates by an order of magnitude,
	  to quit hogging the CPU.

	* src/mine/cmine.cc:

	  Add and use support for adjusting the coloration of uncovered
	  squares according to how many bombs adjoin them.  Make detonated
	  mines bright red too.

	* src/mine/cmine.cc:

	  In the new-game dialog, connect the Confirm binding with
	  connect_key_post so that it doesn't override pressing Enter on
	  the Cancel button.

	* src/mine/cmine.cc:

	  Fix the location of the right-hand border, and add some more
	  color customization possibilities.

	* src/main.cc:

	  Don't complain loudly about invalid encodings; just generate
	  output with the offending characters replaced by '?'.

	* src/vscreen/vs_pager.cc:

	  Actually support wide characters in the pager: calculate
	  widths correctly and use wide character output routines
	  (so characters don't get randomly degraded to ASCII..oops!)

	* README.i18n:

	  Document the existence of encoding translations.

	* src/mine/cmine.cc:

	  Allow the encoding of mine-help.txt to be specified, and
	  be robust against it missing.

	* src/ui.cc:

	  Also allow the encoding of README to be specified.

	* po/Makefile.in.in:

	  Rebuild po/Makefile if po/Makevars changes.

	* po/Makevars:

	  Recognize P_() as a gettext marker.

	* src/ui.cc:

	  Fix various places in the ui glue code to handle the new pager
	  API.

	* src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h:

	  Allow the encoding to be specified when a vs_pager is created
	  with a pre-loaded file (oops).

	* src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Allow the user to specify the encoding of the file to be loaded
	  in a vs_dialog_fileview.

	* src/aptitude.h:

	  Whoops, need to #include <string.h> for strchr.

	* src/aptitude.h, README.i18n:

	  Add a routine 'P_()' which strips off everything up to the first
	  pipe symbol in the string.

	* src/vscreen/transcode.cc:

	  When coding errors are encountered, replace the offending
	  characters with '?' and continue attempting to decode the rest
	  of the string.

	* src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h:

	  Use wide characters in the vs_pager, and transcode the input
	  text from a (optionally specified) encoding.

	* src/vscreen/transcode.cc, src/vscreen/transcode.h:

	  Add transcode-with-punted-errors variants that read directly
	  from a character buffer.

2005-07-02  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver.h:

	  Add some safety code to make sure that the resolver compiles
	  even when the compiler is being ultra-strict.

	* po/POTFILES.in:

	  Remove another reference to strhash.h.

	* src/Makefile.am:

	  Remove reference to strhash.h.

	* src/download.cc:

	  Try greatly increasing the resolution of pulses, to make the UI
	  more responsive during a download.

	* src/ui.cc:

	  Force the broken indicator to start out hidden.

	* src/vscreen/columnify.cc:

	  Fix the algorithm that "renders" column-formatted text:
	  due to a logic error, nothing at all was being produced.

	* src/ui.cc:

	  Instead of trying to pass a NULL string to pkg_tree::pkg_tree,
	  just don't pass the third argument.  Fixes a SIGABRT.

	* src/ui.cc:

	  Implement the wstring variant of show_message.

	* src/main.cc:

	  Add default transcoding error handlers that push an error on the
	  apt error stack.

	* src/vs_progress.cc:

	  Update the core progress bar for wide characters.

	* src/ui.cc:

	  Update ui.cc to use wide characters internally.

	* src/apt_info_tree.cc, src/apt_info_tree.h:

	  Update copyright info.

	* src/apt_info_tree.cc, src/apt_info_tree.h:

	  Make the desc_signal of apt_info_trees accept a wide string.

	* src/solution_fragment.cc:

	  Pass a wchar_t* to join_fragment instead of a char*.

	* src/reason_fragment.cc:

	  Pass a wchar_t* to join_fragment instead of a char*.

	* src/pkg_view.cc:

	  Update the pkg_view code for wide characters and new interfaces.

	* src/pkg_info_screen.cc:

	  Fix the pkg_info_screen code to pass a wstring to desc_parse.

	* src/cmdline/cmdline_show.cc:

	  Fix the 'show' command to pass a wstring to desc_parse.

	* src/desc_parse.cc, src/desc_parse.h:

	  Update the description parser to take a wide string as input.

	* src/mine/cmine.cc, src/mine/cmine.h:

	  Update cmine for the new prompt_string signature.

	* src/vscreen/vs_tree.h, src/vscreen/vs_treeitem.h:

	  Explicitly make searches take wide character strings as input.

	* src/pkg_tree.cc, src/pkg_tree.h:

	  Wide-character conversion of pkg_tree.

	* src/ui.h:

	  Make the string callbacks take wstrings.

	* src/ui.h:

	  Add wstring variants of some interface functions.

	* src/pkg_sortpolicy.h:

	  Make operator() non-const; the new sort policy protocol
	  requires this.

	* src/pkg_sortpolicy.cc:

	  Fix the sorting policy to work with the new internal interfaces.

	* src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h:

	  Update the display of the multiplex's tabs for wide characters.

	* src/pkg_grouppolicy.cc, src/pkg_grouppolicy.h:

	  Update pkg_grouppolicy for wide characters.

	* src/pkg_item.cc, src/pkg_item.h:

	  Update the pkg_item code for wide characters.

	* src/ui.h:

	  Undo that last change: most of the code passes statically
	  translated strings into those routines, so it will be a lot
	  simpler to do the transcoding in ui.cc.

	* src/ui.h:

	  Use wstrings in the UI's external interface.

	* src/pkg_info_screen.cc:

	  Update pkg_info_screen for wide characters.

	* src/load_grouppolicy.cc:

	  Update the #include of strhash to use the correct copy, not the
	  old one that I removed.

	* src/load_config.cc:

	  Update the configuration loader for wide characters.

	* src/download_list.cc, src/download_screen.cc:

	  Allow the user to cancel a media change.  Although I can't
	  really test it, this hopefully Closes: #315885.

	* src/generic/Makefile.am, src/generic/mut_fun.h:

	  Add a functor class that assigns its argument to a fixed
	  variable.

	* src/download_screen.cc, src/download_screen.h:

	  Update the download-screen class for wide characters.

	* src/download_item.cc, src/download_item.h:

	  Update the download-item class for wide characters.

	* src/vscreen/vs_subtree.h:

	  Update the current display column properly in vs_subtree::paint.
	  Fixes the bug where the current line's highlight "overflowed" to
	  the next line.

	* src/edit_pkg_hier.cc:

	  Update the package hierarchy editor for wide characters
	  (slightly hackily?)

	* src/download_bar.cc:

	  Update the download-bar to use the new signature of
	  show_string_as_progbar.

	* src/dep_item.cc:

	  Make dep_item.cc work with wide characters.

	* src/pkg_item_with_subtree.h:

	  Convert the package-item-plus-subtree class to wide characters.

	* src/pkg_subtree.cc, src/pkg_subtree.h:

	  Convert the pkg_subtree class to wide characters.

	* src/pkg_node.cc, src/pkg_node.h:

	  Convert the core package node class to wide characters.

	* src/pkg_item_with_subtree.h, src/pkg_item.h, src/pkg_ver_item.cc, src/pkg_ver_item.h:

	  Fix some more tree items, to the point that pkg_ver_item now
	  compiles.

	* src/pkg_ver_item.cc, src/pkg_ver_item.h:

	  Update the pkg_ver_item to reflect the changes in the vscreen
	  API.

	* src/vscreen/vs_layout_item.cc:

	  Make vs_layout_item less absurdly inefficient by really caching
	  all of its contents up-front, rather than calling layout() once
	  for EVERY LINE IN THE ITEM.

	* src/vscreen/vs_layout_item.cc, src/vscreen/vs_layout_item.h:

	  Avoid several copies when displaying a vs_layout_item.

	* src/vscreen/testvscreen.cc, src/vscreen/vs_layout_item.cc, src/vscreen/vs_layout_item.h, src/vscreen/vs_staticitem.h, src/vscreen/vs_subtree.h, src/vscreen/vs_tree.cc, src/vscreen/vs_treeitem.cc, src/vscreen/vs_treeitem.h:

	  Adjust the treeitem interface to use wide characters; while I'm
	  at it, I removed a bunch of const qualifiers that looked
	  dangerous (const qualifiers on a virtual method are potentially
	  problematic).

	* src/edit_pkg_hier.cc, src/edit_pkg_hier.h:

	  Update the package hierarchy editor for wide characters.

	* src/download_list.cc, src/download_list.h:

	  Update the download_list for wide characters.

2005-07-01  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/curses++.cc, src/vscreen/curses++.h, src/vscreen/vscreen_widget.h:

	  While I'm at it...pass strings by reference, not value.

	* src/vscreen/curses++.cc, src/vscreen/curses++.h, src/vscreen/vscreen_widget.h:

	  Update show_string_as_progbar for wide characters.

	* src/download_bar.cc, src/download_bar.h:

	  Fix the download bar for wide characters.

	* src/defaults.cc:

	  Change the default setting initializations to use the new
	  wide-character interfaces.

	* src/broken_indicator.cc:

	  Convert the broken indicator to handle wide characters.

	* src/apt_config_widgets.cc, src/apt_config_widgets.h:

	  Convert the apt config widgets to support wide characters.

2005-06-30  Daniel Burrows  <dburrows@debian.org>

	* src/mine/cmine.cc, src/mine/cmine.h:

	  Update the mine code for wide characters.  Sort of, anyway.
	  At least, it should work.

2005-06-31 Tim Dijkstra <tim@famdijkstra.org>

	* Updated minor corrections to nl.po
	  Closes: #316279

2005-06-29  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/curses++.cc, src/vscreen/curses++.h, src/vscreen/vscreen_widget.h:

	  Update display_header and display_status to handle wide
	  characters.

	* src/vscreen/vs_button.cc, src/vscreen/vs_scrollbar.cc:

	  Convert all uses of ACS_* to WACS_*.

	* src/vscreen/vs_statuschoice.cc, src/vscreen/vs_statuschoice.h:

	  Convert vs_statuschoice to handle wide characters.

	* src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h, src/vscreen/testvscreen.cc:

	  Convert vs_menubar to handle wide characters.

	* src/vscreen/vscreen.cc:

	  Use A_REVERSE on HighlightedMenuEntry -- this gives a more
	  brilliant white background than the non-reversed version (ew).

	* src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h:

	  Don't bother caching the width for now (this is much more
	  obviously correct; width caching can be reinstated without
	  losing correctness if speed ever becomes an issue).

	* src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h:

	  Rewrote vs_menu to properly handle wide characters.

	* src/vscreen/curses++.h, src/vscreen/vscreen_widget.h:

	  Get rid of the attribute argument, it seems to cause unexpected
	  behavior.  Add variants to pass in pregenerated cchar_t strings.

	* src/vscreen/curses++.h, src/vscreen/vscreen_widget.h:

	  Expose the add_wch and wadd_wch functions.

2005-06-28  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_editline.cc:

	  Correct several errors in how normalize_cursor works.

	* src/vscreen/vs_editline.cc:

	  Fix get_char() to produce correct results (oops).

	* src/vscreen/config/colors.cc:

	  Don't make the cursor invisible, at the cost of losing
	  black-on-black text.

	* src/vscreen/vs_editline.cc, src/vscreen/vs_editline.h:

	  Fix the line editor widget to support wide characters properly
	  (it now honors wide character widths).

	* src/vscreen/curses++.h:

	  #undef the *add_wch functions for future use.

2005-06-27  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/fragment.cc:

	  Initialize the current line's width to 0 in clipbox::layout
	  rather than using random uninitialized values.

	* src/vscreen/fragment.cc:

	  Fix a segfault in clipbox::layout due to an insufficiently
	  bounded loop.

	* src/vscreen/testvscreen.cc:

	  Add some actual wide characters to test the formatting code.

	* src/vscreen/fragment.cc:

	  Add a long string escape to fragf (for printing out stuff that's
	  already been transcoded).

	* src/vscreen/testvscreen.cc:

	  Use setlocale() to actually enter the current locale (so UTF-8
	  locales actually work now!).

	* src/vscreen/config/keybindings.cc:

	  Fix the definition of KEY_CTRL and keyname to be slightly more
	  sane (as sane as is possible given how control keys are
	  handled).

2005-06-27 Hĺvard Korsvoll <korsvoll@skulelinux.no>

	* Updated Norwegian nynorsk translation
	  Closes: #315988

2005-06-23 Miguel Figueiredo <elmig@debianpt.org>

	* Updated Portuguese translation
	  Closes: #315486

2005-06-27  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/testvscreen.cc:

	  Update the testvscreen code for the new keybindings magic.

	* src/vscreen/vs_subtree.h src/vscreen/vs_tree.cc src/vscreen/vs_treeitem.h:

	  Convert various dispatch_char routines to dispatch_key. (DANGER:
	  forgetting to do this will result in a silently broken widget at
	  the moment)

	* src/vscreen/vs_tree.cc, src/vscreen/vs_tree.h:

	  Convert vs_tree::handle_char to vs_tree::handle_key.

	* src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	  Convert vs_table::handle_char to vs_table::handle_key.

	* src/vscreen/vs_text_layout.cc, src/vscreen/vs_text_layout.h:

	  Convert vs_text_layout::handle_char to
	  vs_text_layout::handle_key.

	* src/vscreen/vs_statuschoice.h:

	  Convert vs_statuschoice::handle_char to
	  vs_statuschoice::handle_key.

	* src/vscreen/vs_passthrough.cc, src/vscreen/vs_passthrough.h:

	  Convert vs_passthrough::handle_char to
	  vs_passthrough::handle_key.

	* src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h:

	  Convert vs_pager::handle_char to vs_pager::handle_key.

	* src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h:

	  Convert vs_menubar::handle_char to vs_menubar::handle_key.

	* src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h:

	  Convert vs_menu::handle_char to vs_editline::handle_key.

	* src/vscreen/vs_editline.cc, src/vscreen/vs_editline.h:

	  Convert vs_editline::handle_char to vs_editline::handle_key.

	* src/vscreen/vs_button.cc, src/vscreen/vs_button.h:

	  Convert vs_button::handle_char to vs_button::handle_key.

	* src/vscreen/vscreen_widget.cc:

	  Name change update: handle_char -> handle_key.

	* src/vscreen/vscreen.cc, src/vscreen/vscreen.h:

	  Fix compilation problems from the new keybindings stuff.

	* src/vscreen/vscreen.cc:

	  Use the function-key information from get_wch() to decide what
	  sort of key event to generate, and call the new names of the
	  key-handling methods.

	* src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h:

	  Make the key-handling methods take keys instead of wint_ts.

	* src/vscreen/config/keybindings.cc, src/vscreen/config/keybindings.h:

	  First crack at revising the keybinding routines to handle
	  Unicode input.  In particular, the "key" type now includes a
	  flag to indicate function-key-ness (this is useful since we need
	  to distinguish function keys (KEY_*) from other keys now --
	  curses uses a special return value from get_wch to indicate
	  them, and I think it's because they might overlap real
	  codepoints).

	  This probably breaks everything again.

2005-06-26  Daniel Burrows  <dburrows@debian.org>

	* src/strhash.h:

	  This copy of strhash is obsolete and broken, remove it to avoid
	  confusion.

	* src/vscreen/vscreen.cc:

	  Update the other place where input is read to handle wide
	  characters (oops).

	* src/vscreen/testvscreen.cc:

	  Update the test program for the new vscreen interfaces.

	* src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h:

	  Use const string &'s in the vs_file_pager interface.

	* src/vscreen/vs_pager.cc:

	  Allow wide character strings to be used for the filename of a
	  vs_file_pager, to make it easy to bind the vs_editline's
	  "entered" signal to vs_file_pager::load_file.  Is this a hack?
	  (and for that matter, why is vs_file_pager still separate from
	  vs_pager?)

	* src/vscreen/columnify.cc:

	  Use the new transcoder, so transcoding errors can be reported at
	  a higher level.

	* src/vscreen/transcode.cc, src/vscreen/transcode.h:

	  Implement the new transcoder, and fix some types in the
	  header (oops).

	* src/vscreen/vs_util.cc:

	  Add explicit transcoding in the fallback routines.

	* src/vscreen/vs_label.cc, src/vscreen/vs_label.h:

	  Add initializers for wstrings.

	* src/vscreen/transcode.h:

	  Add a kinder, gentler transcoding interface for when error
	  detection isn't important.

	* src/vscreen/vs_editline.cc, src/vscreen/vs_editline.h:

	  Convert the public interface of the line-editor to wide
	  characters.  (this is important since it's the main interface
	  for string input at the moment)

	* src/vscreen/transcode.h:

	  Add inline convenience functions to "directly" go from
	  strings to strings.

	* src/vscreen/vs_button.cc, src/vscreen/vs_button.h:

	  Change the argument type of handle_char() so it gets correctly
	  overridden.

	* src/vscreen/config/keybindings.cc, src/vscreen/config/keybindings.h:

	  Make the keybinding lookup tables take wide character values.

	* src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h:

	  Modify the prototypes of dispatch_char and handle_char to
	  take wint_t values.

	* src/vscreen/vs_button.h:

	  Doh, actually overload vs_button::vs_button.

	* src/vscreen/vscreen.cc:

	  Use get_wch() instead of getch() -- this will need to be
	  propagated into the vscreen_widget hierarchy.

	* src/vscreen/curses++.h:

	  Doh, make it compile (forgot to #undef the macros and dropped
	  some paramters from mvget_wch).

	* src/vscreen/curses++.h:

	  Expose wget_wch and mvwget_wch as methods on cwindow.

	* src/vscreen/vs_button.cc, src/vscreen/vs_button.h:

	  Add a variant constructor for wstrings.

	* src/vscreen/transcode.cc, src/vscreen/transcode.h:

	  Add a transcode variant that changes strings from wide character
	  codings to multibyte codings.

	* src/pkg_view.cc:

	  When altering the column format of a view, transcode the input
	  column template.

	* src/vscreen/vs_label.cc, src/vscreen/vs_label.h:

	  Add an overloading of set_text that accepts wstrings.

	* src/pkg_ver_item.cc:

	  Store the output of the columnizer in a wstring.

	* src/Makefile.am, src/pkg_item_with_subtree.cc, src/pkg_item_with_subtree.h:

	  Doh, of course since pkg_i_w_s is templated, all its method
	  implementations have to go in the .h (ew).

	* src/pkg_item.cc:

	  Store the output of the columnizer in the right type.

	* src/pkg_columnizer.cc:

	  Oops, missing std::.

	* src/pkg_columnizer.cc, src/pkg_columnizer.h:

	  Make the column name formatter return a wstring.

	* src/pkg_columnizer.cc:

	  Transcode column definitions before parsing.

	* src/pkg_columnizer.cc:

	  Mark an overlooked string for translation.

	* src/vscreen/columnify.cc, src/vscreen/columnify.h:

	  Add an implicit transcoding constructor for column_disposition.

2005-06-25  Daniel Burrows  <dburrows@debian.org>

	* src/load_pkgview.cc:

	  When parsing column information, transcode it to a wide
	  character set first.

	* src/Makefile.am, src/pkg_item_with_subtree.cc, src/pkg_item_with_subtree.h:

	  Transcode the package name to force it into the wide character
	  set; move the column-generation function for the
	  item-with-subtree class into a .cc file to avoid polluting other
	  headers with too much junk.

	* src/vscreen/curses++.h, src/vscreen/vscreen_widget.h:

	  Expose the addwstr family of functions.

	* src/broken_indicator.cc:

	  Fix two calls to join_fragments().

	* src/cmdline/cmdline_show.cc:

	  Fix a number of calls to join_fragments() to use wide joining
	  strings, and extract the character text using ().ch, not
	  ()&A_CHARTEXT.

	* src/cmdline/cmdline_search.cc:

	  Transcode the format string specified by the user for displaying
	  search results.

	* src/vscreen/fragment.cc:

	  Rewrite the clipbox for wide characters.

	* src/vscreen/fragment.cc:

	  Fix the fill algorithm to compile, and rewrite the hard-wrapping
	  algorithm to handle wide characters.

	* src/vscreen/fragment.cc:

	  Rewrite the fill algorithm to handle wide characters.

	* src/vscreen/fragment.cc:

	  Rewrite the main flow algorithm to handle wide characters (i.e.,
	  separate the concepts of "visible width" and "character count").

	* src/vscreen/columnify.cc, src/vscren/columnify.h, src/vscreen/config/column_definition.cc, src/vscreen/config/column_definition.h:

	  Rewrite the columnification code to handle wide characters
	  properly: you can include literal wide characters in the
	  configuration, and multi-column wide characters are accounted
	  for in calculating widths.

	* src/vscreen/transcode.cc:

	  Get rid of the use of auto_ptr and new[], they aren't really
	  appropriate here.  Use good old malloc/realloc/free calls to
	  manage our dynamic store.

	* src/vscreen/transcode.cc:

	  Use nl_langinfo(), not localeset(), to find out what the current
	  charset is when transcoding.

	* src/vscreen/curses++.cc:

	  Fix the generation of attributes+wide characters to preserve
	  color information.

	* src/vscreen/transcode.cc:

	  Doh, correct the actual name of the transcoding function.
	  Everything links now.

	* src/vscreen/vs_button.cc, src/vscreen/vs_layout_item.cc, src/vscreen/vs_layout_item.h:

	  Update places where chstring was explicitly used to call on
	  fragment_line instead; factor some common code in
	  vs_layout_item::paint and vs_layout_item::vs_layout_line::paint
	  into vs_layout_item::paint_line.

	* src/vscreen/vscreen_widget.h:

	  Mirror the new cwindow addstr routines in vscreen_widget.

	* src/vscreen/fragment.cc, src/vscreen/fragment.h:

	  Instead of requiring a separate function to be called for
	  transcoding, just overload text_fragment (NB: is this wise?).

	* src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/fragment_contents.h:

	  Use wide character strings internally to format text fragments,
	  and require explicit conversion of std::strings.

	* src/vscreen/curses++.h:

	  Add a convenience constructor to build a wchstring by repeating
	  a wchar_t.

	* src/vscreen/curses++.cc, src/vscreen/curses++.h:

	  Add a preliminary, very hacky, routine to output wide-character
	  strings.

	* src/vscreen/Makefile.am, src/vscreen/transcode.cc, src/vscreen/transcode.h:

	  Add support code to wrap iconv in a simpler (less efficient)
	  interface.

	* src/vscreen/curses++.h:

	  Fix formatting errors in a comment.

2005-06-22  Daniel Burrows  <dburrows@debian.org>

	* src/pkg_tree.cc:

	  Make the package tree progress bar actually move (I forgot to
	  increment its progress!  Oops).

	* src/vs_progress.cc:

	  Done() just indicates that a suboperation completed, not that
	  everything completed.  Don't hide() the widget in Done()
	  (anyway, it'll get hidden when it's destroyed).

	* src/generic/aptcache.cc:

	  Disable auto-installation of dependencies when restoring package
	  states, to make sure we reproduce the state the user expects and
	  to avoid ordering bugs (my goodness, how did this big gaping
	  monster manage to avoid detection for so long?).
	  Closes: #315359

2005-06-22 Luk Claes <luk@debian.org>

	* Updated Dutch translation
	  Closes: #315376

2005-06-22 Michal Politowski <mpol@charybda.icm.edu.pl>

	* Updated Polish translation
	  Closes: #315338
	
2005-06-21 Dennis Stampfer  <seppy@debian.org>

	* Small German translation update by Jens Seidel

2005-06-18  Darius Zitkevicius  <skystis@splius.lt>

	* Updated Lituanian translation
	  Closes: #314643

2005-06-16  Miroslav Kure  <kurem@upcase.inf.upol.cz>

	* Updated Czech translation
	  Closes: #314328

2005-06-15  Yongtao Yang  <yongtao.yang@telia.com>

	* Updated Simplified Chinese translation
	  Closes: #314330

2005-06-15  Daniel Burrows  <dburrows@debian.org>

	* src/broken_indicator.cc:

	Fix the generation of the solution summary: due to a logic error,
	cancelled installations were being counted as installations rather
	than keeps.

	* src/vscreen/curses++.cc, src/vscreen/curses++.h:

	Fix the missing reference to operator=(wstring&) in wchstring by
	removing it and just writing it into the constructor where it was
	used.

	* src/vscreen/config/style.h, src/vscreen/curses++.cc, src/vscreen/curses++.h:

	Add definitions of a chstring-analogue for wide-characters (it
	stores wide characters combined with attributes).  Currently this
	isn't used anywhere; that's the next step of UTF8ization.

2005-06-15  Jens Seidel  <jensseidel@users.sf.net>

	* Spellcheck German translation
	  Closes: #313663

2005-06-15  Yuri Kozlov  <yuray@id.ru>

	* Update Russian translation
	  Closes: #313619

2005-06-15  dooteo <dooteo@euskalgnu.org>

	* Update Basque translation

2005-06-13  BjĂ¸rn Steensrud  <bjornst@powertech.no>

	* Update Norwegian Bokmal translation
	  Closes: #313459

2005-06-13  Ruben Porras  <nahoo82@telefonica.net>

	* Update Spanish translation (still incomplete)
	  Closes: #313412

2005-06-13  Jaakko Kangasharju  <ashar@iki.fi>

	* Complete Finnish translation
	  Closes: #313450

2005-06-13  Stanislav ValĂĄĹĄek  <valasek@fastmail.fm>

	* Complete Slovak translation. Closes: #309824

2005-06-13  Christian Perrier  <bubulle@debian.org>

	* src/cmdline/cmdline_prompt.cc: Corrected typo : "modifaction"
	  Closes: #313322

2005-06-13  Clytie Siddall  <clytie@riverland.net.au>

	* Completed Vietnamese translation. Closes: #313321

2005-06-13  Daniel Burrows  <dburrows@debian.org>

	* src/generic/apt.cc:

	Make the read-only-ness warning more explicit (Closes: #313417)

2005-06-08  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/config/colors.cc, src/vscreen/config/colors.h, src/vscreen/curses++.cc:

	Call init_colors() from init_curses(), and don't call it from the
	color-handling routines.  This makes it safe to perform 'dummy'
	color mixing when Curses isn't initialized (for instance, when
	formatting text from the command-line).

	* src/cmdline/cmdline_show.cc, src/solution_fragment.cc:

	Fix several places where aptitude could crash because I forgot
	that PkgFileIterator::Archive can return a NULL pointer.
	(Closes: #312553)

2005-06-08 Christian Perrier  <bubulle@debian.org>

	* po/fi.po: Overtranslation corrected. Closes: #312311

2005-06-07 Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_util.cc:

	Implement the file viewer as a specialized OK dialog.

	* src/vscreen/vscreen.cc:

	Force edit-line widgets to always appear white-on-black, even in
	A_REVERSE environments.

	* src/generic/matchers.cc, src/generic/matchers.h:

	Add an option to parse_matcher that causes the matchers generated
	for plain strings to match both names and descriptions.

	* src/vscreen/fragment.cc:

	Take the style of an indentbox's formatting from the surrounding
	context.

	* src/ui.cc:

	Use %N in one appropriate place.

	* src/vscreen/fragment.cc, src/vscreen/fragment.h:

	Add a %N escape that resets the current style to the empty style.

	* src/ui.cc:

	Remove several uses of %C or replace them with %S.

	* src/load_config.h, src/ui.cc:

	Call load_styles from ui.cc, not load_colors.

	* src/view_changelog.cc:

	Update the changelog viewer for the new display code.

	* src/ui.cc:

	Fix compilation by deleting a stray parenthesis.

	* src/vscreen/vs_statuschoice.cc, src/vscreen/vs_statuschoice.h:

	Update the statuschoice widget for styles.

	* src/vs_progress.cc, src/vs_progress.h:

	Update the vs_progress code for styles.

	* src/ui.cc, src/ui.h:

	Update the core UI code for styles.

	* src/trust.cc:

	Update the trust dialog for styles.

	* src/solution_dialog.cc:

	Update the solution dialog for styles.

	* src/defaults.cc:

	Make bullets 'transparent' (the style now only changes the
	foreground color).

	* src/reason_fragment.cc:

	Update the generation of 'reason' fragments for styles.

	* src/vscreen/fragment.cc:

	Fix the composition of styles by style_fragments: instead of
	composing our style with the enclosing style, compose the
	enclosing style with our style (remember, composition is
	noncommutative).

	* src/vscreen/fragment.cc, src/vscreen/fragment.h:

	When generating a text fragment from a string and a style,
	actually wrap it in a style fragment.  (maybe I should just
	include a style in every text fragment, to increase locality?
	Probably doesn't really matter, though, and a lot of text
	fragments don't need styles) This makes it easy to generate styled
	text that does the right thing (i.e., where the style overrides
	any outer styles rather than vice versa).

	Also stopped using chstrings for text_fragments: they are almost
	guaranteed to do the wrong thing anyway.

	* src/pkg_view.cc:

	Adjust the remaining bits of pkg_view to handle styles properly:
	change paint()'s signature, and use set_bg_style instead of
	set_bg.

	* src/pkg_item.cc, src/pkg_item.h:

	Extend the signature of pkg_item::paint() to properly override its
	abstract ancestor, and adjust the code that sets the attributes of
	a package item to be style-based.

	* src/load_pkgview.cc, src/pkg_view.h:

	Adjust the package view loading code to use styles rather than
	colors, and change the package view structure to store a style
	rather than a color.

	* src/load_config.cc:

	Change load_colors to load_styles.

	* src/edit_pkg_hier.cc, src/edit_pkg_hier.h:

	Update for the new display protocols; add missing copyright
	boilerplate.

	* src/download_screen.cc:

	Use get_style instead of get_color.

	* src/download_screen.h:

	Extend the signature of download_tree::paint, so that it
	implements the virtual method as expected.

	* src/download_list.cc:

	Adjust the download list code for styles.

2005-06-06  Daniel Burrows  <dburrows@debian.org>

	* src/download_item.cc:

	Update the download item code to use styles instead of colors.

	* src/download_bar.cc:

	Update to use styles.

	* src/dep_item.cc:

	Fix the signature of pkg_depitem::paint().

	* src/pkg_subtree.cc, src/pkg_subtree.h:

	Adjust method signatures so all abstract methods are implemented.

	* src/dep_item.cc, src/dep_item.h:

	Change pkg_depitem::get_normal_attr to pkg_depitem::get_normal_style.

	* src/pkg_ver_item.cc, src/pkg_ver_item.h:

	Fix some confusion over the return type of pkg_ver_item::get_normal_style.

	* src/pkg_item_with_subtree.h:

	Change the signature of paint() to match its new signature in
	vs_subtree.

	* src/pkg_ver_item.cc, src/pkg_ver_item.h:

	Adjust the attribute-selection methods to work with styles instead
	of colors.

	* src/pkg_ver_item.h:

	Also fill in the virtual "paint" method of pkg_vertree_generic.

	* src/pkg_ver_item.cc, src/pkg_ver_item.h:

	Fill in the virtual method "paint" of pkg_ver_item.

	* src/defaults.cc:

	Change the assignment of default colors to an assignment of
	default styles.

	* src/broken_indicator.cc:

	Update for styles.

	* src/apt_options.cc:

	Update the option dialog generation to use styles.

	* src/apt_config_widgets.cc:

	Don't bother setting the color of apt_bool_widget; this shouldn't
	be necessary any more.

	* src/desc_parse.cc:

	Update the description parser for styles.

	* src/mine/cmine.cc, src/mine/cmine.h:

	Fix the minesweeper game for the new display system.

	* src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_show.cc:

	Adjust the command-line code to work properly with the new
	fragment API (note: arguably a better approach is to add a routine
	that does the layout and output of a fragment in one step).

	* src/vscreen/vscreen_widget.cc:

	Change both the widget's attributes and its background in
	apply_style.  I don't for the life of me know why this should be
	necessary, but without it, buttons in dialog boxes don't display
	properly.

	* src/vscreen/vscreen.cc:

	Fix the color of highlighted multiplexer tabs, and get rid of
	unnecessary reverse attributes.

	* src/vscreen/testvscreen.cc:

	Also make sure that the scrollbar fills its vertical space. (this
	change is needed to compensate for past adjustments in vs_table's
	behavior)

	* src/vscreen/testvscreen.cc:

	Fix the creation of the main test screen so that the scrollbar is
	visible again.

	* src/vscreen/testvscreen.cc:

	Get rid of no-longer-necessary uses of the removed %C escape.

	* src/vscreen/vs_button.cc:

	Don't drop character attributes from the enclosed text -- this is
	safe now that we have cascading styles.  This means that button
	labels can have (for instance) highlighted characters.

	* src/vscreen/vs_minibuf_win.cc:

	Fix the minibuf window to set the basic style of its header and
	status labels from the corrent style (use Status instead of
	ScreenStatusColor).

	* src/vscreen/config/colors.cc:

	Correct color updating: use PAIR_NUMBER to retrieve the old pair
	number (since color is now an attribute set, not a pair number).

	* src/vscreen/vscreen.cc:

	Fix menu coloration by putting full style information into each
	menu style, rather than implicitly expecting the menu code to
	inherit from the "Menu" style (which it doesn't).

	* src/vscreen/config/colors.cc, src/vscreen/config/colors.h, src/vscreen/config/style.h:

	Further fixes to how styles and colors are applied to characters.
	mix_color now operates on attribute values and returns an
	attribute value, and the appropriate bits of code have been
	updated to reflect this change.

	* src/vscreen/vscreen.cc:

	Remove some uses of the NOP style_attrs_on(0).

	* src/vscreen/config/style.h:

	Fix the composition of styles by including information from both
	styles, not just the last one (doh).

	* src/vscreen/config/style.h:

	Fix part of the problem with compositing styles: previously,
	colors only got overwritten if they were *currently*
	nontransparent (correct behavior would be to only use
	nontransparent colors to overwrite the existing colors).

	* src/vscreen/vscreen_widget.cc:

	Initialize pre_display_erase to 'true' in the constructor.

	* src/vscreen/vscreen.cc:

	Fix some style definitions.

	* src/vscreen/vs_label.cc:

	Fix an infinite recursion in vs_label::set_text.

	* src/vscreen/curses++.cc:

	Add a missing definition of chstring::chstring.

	* src/vscreen/testvscreen.cc:

	Update the test program to use styles instead of attributes.

	* src/vscreen/vs_editline.cc, src/vscreen/vs_editline.h:

	Update the line-editor widget for the new display protocol.

	* src/vscreen/vs_pager.cc:

	Update the pager for the new display protocol.

	* src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	Update the vscreen dialog utilities to use styles instead of
	attributes.

	* src/vscreen/vs_scrollbar.cc, src/vscreen/vs_scrollbar.h:

	Update the scrollbar widget to the new display protocol.

	* src/vscreen/vs_text_layout.h:

	D'oh, update the signature of freshen_contents() and make lastst
	non-const.

	* src/vscreen/vs_text_layout.cc, src/vscreen/vs_text_layout.h:

	Finish updating the text_layout widget: include style information
	in its cache and handle the enclosing style environment in
	paint().

	* src/vscreen/vscreen_widget.cc:

	Always set the display attributes of a widget to its basic style,
	even if it's non-opaque.  No change to current behavior as all
	existing transparent widgets are also invisible except for their
	subwidgets.

	* src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	Update the vs_table widget for the new display protocol.

	* src/vscreen/vs_togglebutton.cc:

	Update the vs_togglebutton widget for the new display protocol.

	* src/vscreen/vs_text_layout.cc:

	Update the text layout widget to use the new display protocol.

	* src/vscreen/vs_stacked.cc, src/vscreen/vs_stacked.h:

	Update the stacked widget to use the new display protocol.

	* src/vscreen/vs_size_box.cc:

	Update the size-box to use set_opaque() instead of set_bg().

	* src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_minibuf_win.:h:

	Update the minibuf-win for the new display protocol.

	* src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h:

	Update the multiplexer for the new display protocol.

	* src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h:

	Update the menubar for the new display protocol.

2005-06-04  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h:

	Update menus for the new display protocol.

	* src/vscreen/vs_layout_item.cc, src/vscreen/vs_layout_item.h:

	Handle the new display protocol.

	* src/vscreen/vs_subtree.h:

	Update a few minor things in vs_subtree (particularly
	added code to avoid string copies).

	* src/vscreen/vs_tree.cc, src/vscreen/vs_tree.h, src/vscreen/vs_treeitem.cc, src/vscreen/vs_treeitem.h:

	Update the core tree code to the new display protocol.

	* src/vscreen/vs_label.cc, src/vscreen/vs_label.h:

	Update the label widget to the new display protocol.

	* src/vscreen/vs_editline.cc:

	Update the edit-line widget to the new display protocol.

	* src/vscreen/vs_frame.cc, src/vscreen/vs_frame.h:

	Update the frame widget to the new display protocol.

	* src/vscreen/vs_center.cc:

	Update the center widget to the new display protocol.

	* src/vscreen/vs_bin.cc, src/vscreen/vs_bin.h:

	Update the bin widget to the new display protocol.

	* src/vscreen/fragment.h:

	Add a note clarifying the guarantees provided by layout().

	* src/vscreen/vs_button.cc, src/vscreen/vs_button.h:

	Fix the vs_button class for the new display protocol.

	* src/vscreen/vscreen_widget.cc:

	Properly pass style information into the paint() call.

	* src/vscreen/config/style.h:

	Make several operators const that should be and weren't.

	* src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h:

	Remove the stack of styles, it's the Wrong Way to do things.  (if
	this were Lisp, a with-style macro would be appropriate, but it's
	not so it isn't) Instead, just let the user directly set the
	current text attributes based on a full style.

2005-06-02  Tetralet  <tetralet@pchome.com.tw>

	* po/zh_TW.po: Updated from sarge branch. Closes: #311587

2005-05-26  Ruben Porras  <nahoo@inicia.es>

	* po/es.po: Various updates

2005-05-26  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vscreen_widget.cc, src/vscreen/vscreen_widget.h:

	Fix some compilation problems with the new stuff.

	* src/vscreen/vscreen_widget.h:

	Add in a per-widget stack of styles to be used when drawing the
	widget.

	* src/vscreen/config/style.h:

	Take the color data into account when generating attrs from a
	style.

2005-05-26  Christian Perrier  <bubulle@debian.org>

	* po/fr.po: Typo corrections from sarge branch

2005-05-20  Stanislav ValĂĄĹĄe k <valasek@fastmail.fm>

	* po/sk.po: Updated. Closes: #309824

2005-05-10  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/fragment_cache.cc:

	Fix the compilation errors in fragment_cache.  Note: the cache now
	updates itself based on its last known style; would it make any
	sense to keep a map of styles for fragments whose formatting
	changes?

	* src/vscreen/config/style.h:

	Write operator== and operator!=.

	* src/vscreen/fragment.cc:

	Fix compile errors.

	* src/vscreen/curses++.cc, src/vscreen/curses++.h:

	Add some new constructors to chstring that will be needed later;
	remove direct attribute manipulation and replace it with style
	adjustment.

	* src/vscreen/config/colors.cc:

	Fix a silly compile error.

	* src/vscreen/config/style.h:

	Add an interface to apply a style to a chtype value.

	* src/vscreen/config/colors.cc, src/vscreen/config/colors.h:

	Add an interface to 'mix' colors.

2005-05-08  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/fragment.cc, src/vscreen/fragment.h:

	Rewrite the fragment code to handle styles.

	* src/vscreen/vscreen.cc, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_treeitem.h:

	Make vscreen.cc compile, and change some 'get the color' routines
	to 'get the style'.  Note that 'normal' colors now just correspond
	to an empty style!

	* src/vscreen/config/style.h:

	Oops, use attrs_on, not attr_on.

	* src/vscreen/config/style.cc, src/vscreen/config/style.h:

	Cancel that; instead, just return a 'null' style.  I'd like to
	have unknown styles blow up, but that has other problems
	(especially when the user is allowed to create screen regions and
	specify their styles).

	* src/vscreen/config/style.cc, src/vscreen/config/style.h:

	Throw an exception if a style is missing, rather than just
	silently creating a new style.

	* src/vscreen/config/style.h:

	Add factory routines to make it easy to generate canned styles.

2005-05-07  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/config/colors.cc, src/vscreen/config/colors.h:

	Change the color database to allow orthogonal selection of fg/bg
	colors.  Now nothing compiles.  Whee!

	* src/vscreen/config/Makefile.am, src/vscreen/config/styles.cc, src/vscreen/config/styles.h:

	Add basic support for styles that allow you to override the
	surrounding character attributes orthogonally.

2005-05-05  Daniel Burrows  <dburrows@debian.org>

	* src/main.cc:

	Make it compile without them.

	* src/main.cc:

	Remove the utf8 guards in main.

	* configure.ac, src/vscreen/curses++.h:

	Start using ncursesw instead of straight curses.

2005-05-04  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/model.tex:

	More Stuff[tm] -- wrote up some comments on Recommends, added a
	Future Work section.

	* src/generic/problemresolver/model.tex:

	Edit a bunch of stuff in the document, and write up that second proof.

2005-05-01  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	Document the change to StepLimit.

	* src/generic/aptcache.cc:

	Live dangerously: bump the default StepLimit to 5000.  It seems
	from empirical tests that the various changes to the problem
	resolver -- especially the 'forbidden' version tests, forced
	installations, and the reduction of the branching factor -- have
	made longer searches feasible; also, some interesting test cases
	(like 'aptitude -s -t experimental dist-upgrade') need more steps
	to complete.

	* src/cmdline/cmdline_resolver.cc:

	Give up, don't loop forever, if the user asks to terminate a
	search.

	* src/generic/aptcache.cc:

	Bump the default StepLimit to 500, to deal with the fact that some
	interesting problems are a bit too hard for 100.

	* src/generic/aptitude_resolver.h:

	Fix reversed logic in checking whether a Conflicts is broken.

	* src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	Fix a mistake in how successors are generated -- of course we have
	to test the dependencies of the new version being installed as
	well!

	* src/solution_fragment.cc:

	Fix a silly thinko that caused segfaults when trying to display
	problem solutions.

	* src/generic/problemresolver/Makefile.am:

	Uh, yeah, also distribute the problem resolver's header file.

	* src/generic/problemresolver/Makefile.am:

	Distribute more problemresolver-related stuff, including the TeX
	file explaining how it all works.

	* po/*.po, po/aptitude.pot:

	Ran "make dist" and update-po.

	* src/generic/Makefile.am:

	Add problemresolver to the "official" source tree as seen by
	automake.

	* NEWS, configure.ac, doc/en/aptitude.xml:

	Bump version to 0.3.2.

	* doc/en/manpage.xml:

	Oops, fix a link target to actually work.

	* src/cmdline/cmdline_action.cc:

	Actually support keeping packages from the command-line prompt, as
	advertised.

	* po/*.po, po/aptitude.pot:

	Run update-po again.

	* doc/en/manpage.xml:

	Further correct the manual page to adjust for the new stuff in
	0.3.2.

	* configure.ac:

	Add vi to ALL_LINGUAS (it was left out..oops).

	* Everything:

	Merge with the stable branch up to r3238.  In order to keep from
	going nuts, though, I held out most of the .po changes (they seem
	to be impossible to automatically merge).

	* doc/en/manpage.xml:

	Minor tweaks to more accurately reflect the way the world works
	now.

--------------- END MERGE FROM 0.2.x ---------------

2005-04-28  Carlos Z.F. Liu  <carlosliu@users.sourceforge.net>

	* Correct both Chinese translations for "DL size".
	  Closes: #306361

2005-04-27  Clytie Siddall  <clytie@riverland.net.au>

	* Added Vietnamese translation.

2005-04-24  Inaki Larranaga Murgotio  <dooteo@euskalgnu.org>

	* Complete Basque translation. Closes: #275704

2005-04-20  Daniel Burrows  <dburrows@debian.org>

	* doc/en/manpage.xml:

	  Document dist-upgrade (with prodding from Branden).
	  Closes: #268697.

2005-04-17  Sorin Batariuc  <sorin@bonbon.net>

	* Complete Romanian translation. Closes: #305282

2005-04-17  Danilo Piazzalunga  <danilopiazza@libero.it>

	* Complete Italian translation. Closes: #304906

2005-04-11  Luk Claes  <Luk.Claes@UGent.be>

	* Complete Dutch translation. Closes: #304210

2005-04-06  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml, doc/cs/aptitude.xml, doc/fr/aptitude.xml, doc/de/aptitude.xml, doc/fi/aptitude.xml:
	  Just to be completely safe, use DocBook 4.2 for now
	  (not 4.3, which is also available).

	* doc/en/aptitude.xml, doc/cs/aptitude.xml, doc/fr/aptitude.xml, doc/de/aptitude.xml, doc/fi/aptitude.xml:

	  Make sure to use file: URLs, not http: URLs, for retrieving
	  the DTD.

2005-04-04  Konstantinos Margaritis  <markos@debian.org>

	* Complete Greek translation. Closes: #302851

2005-04-02  Olivier Trichet  <trichet.olivier@ec-lille.fr>

	* Make French documentation consistent with the program
	  translation

2005-03-29  Miroslav kure  <kurem@upcase.inf.upol.cz>

	* Complete Czech translation. Closes: #302107

2005-03-29  Ryan Escarez  <rescarez@gmail.com>

	* First Tagalog translation. Closes: #302085

2005-03-29  Luk Claes  <luk.claes@ugent.be>

	* Really completed Dutch translation. Closes: #301809

2005-03-28  Miguel Figuereido  <elmig@debianpt.org>

	* Completed Portuguese translation. Closes: #301830

2005-03-28  Luk Claes  <luk.claes@ugent.be>

	* Completed Dutch translation. Closes: #301809

2005-03-28  Daniel Burrows  <dburrows@debian.org>

	* po/*.po:

	  Ran update-po.

	* src/cmdline/cmdline_prompt.cc:

	  Use a more formal wording for the security prompt.

2005-03-28  Christian Perrier  <bubulle@debian.org>

	* Completed French translation (to be proofread)

2005-03-26  Daniel Burrows  <dburrows@debian.org>

	* po/*.po:

	  Re-run update-po again.

	* po/lt.po:

	  Update the Lithuanian translation (same bug).

	* src/cmdline/cmdline_prompt.cc:

	  Use "Yes"/"No", not "yes"/"no" to make translations work better.

	* doc/fr/Makefile.am:

	  Oops, distribute the mysterious "fixman" program.

	* configure.ac, doc/cs/aptitude.xml, doc/de/aptitude.xml, doc/en/aptitude.xml, doc/fi/aptitude.xml, doc/fr/aptitude.xml:

	  Bump the version to 0.2.15.9.

	* po/*:

	  Run update-po.

	* po/POTFILES.in:

	  Add trust.cc and trust.h.

	* doc/fr/Makefile.am:

	  Make the French documentation compile instead of blowing up.

	* configure.ac:

	  Same for doc/fr/images/Makefile.

	* configure.ac:

	  Actually generate doc/fr/Makefile.

	* src/pkg_columnizer.cc:

	  Make sure it compiles against the older apt version.

	* src/pkg_columnizer.cc, src/pkg_columnizer.h, src/pkg_ver_item.cc:

	  Backport the column display of untrusted packages.

	* src/defaults.cc:

	  Backport a default color for TrustWarning.

	* src/Makefile.am, src/pkg_info_screen.cc, src/pkg_view.cc, src/trust.cc, src/trust.h:

	  Backport the display of trust info in the package information
	  displays.

	* src/cmdline/cmdline_prompt.cc:

	  Add a security warning prompt to the command-line mode.

	* src/generic/apt.cc, src/generic/apt.h, src/ui.cc:

	  Backport the apt 0.6 support (compiled out by default, unless
	  you compile aptitude on a system with apt 0.6).

	* src/download_item.cc:

	  Fix the compile failure with apt 0.6 (use conditional
	  compilation to compile the right version of the code depending
	  on the version of apt that's in use).

	* NEWS:

	  Start preparing a new release (mostly translations).

2005-02-16  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Correct a major oversight in the documentation of Delete-Unused:
	  the documentation stated that packages matching it would be the
	  only things deleted, whereas it's packages that DON'T match it
	  that will be the only things deleted.

	  Probably this was originally a coding error, but in the stable
	  branch I won't change the name or behavior of the option, so the
	  documentation is getting fixed instead.

	  Thanks to Michael Vogt for pointing this out.

2005-02-02  Dennis Stampfer <seppy@debian.org>

	* Correcting German shortcut for cleaning cache
	  in de.po: Closes: #293127

2005-01-28  Christian Perrier <bubulle@debian.org>

	* Corrected Lithuanian translation by
	  Darius Zitkevicius
	  Closes: #280049

2005-01-19  Christian Perrier <bubulle@debian.org>

	* Corrected Traditional Chinese translation
	  and help file. Closes: #290284

2005-01-05  Christian Perrier <bubulle@debian.org>

	* Corrected Dutch translation. Closes: #288815

  ----------------- BEGIN MERGE FROM 0.2.x --------------------

2005-05-01  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/test.cc:

	  Fix dummy_universe::broken_under (it was returning false for all
	  dependencies except totally unsatisfiable ones (i.e., deps with
	  no solvers whatsoever).

	* src/generic/problemresolver/test.cc:

	  Always enable debugging.

	* src/generic/problemresolver/test.cc:

	  Fix a refcounting error.

	* src/generic/aptcache.cc:

	  Fix the dumper to conform to the test input format.

	* src/generic/problemresolver/test.cc:

	  Remove a now-unnecessary try/catch pair, reindent a lot of stuff
	  as a result.

	* src/generic/problemresolver/test.cc:

	  Fix a crash that occured when an error was encountered in
	  parsing a test file: the resolver copied the universe, which had
	  references to the package objects, and hence the packages got
	  double-deleted.  Now universes are reference-counted and it's
	  the references that are copied around, so the problem should go
	  away.

	* src/generic/problemresolver/problemresolver.h:

	  When dumping version scores, actually write the scores instead
	  of just writing which versions have non-zero scores.

	* src/cmdline/cmdline_resolver.cc:

	  Add support for dumping the resolver state from the
	  command-line. (enter a tilde)

	* doc/en/aptitude.xml, src/defaults.cc, src/ui.cc:

	  Add support for dumping the resolver state to a file from the
	  visual interface.

	* doc/en/aptitude.xml:

	  Add a brief overview of the command-line resolver interface to
	  the documentation, and fix a minor typo.

	* src/cmdline/cmdline_prompt.cc:

	  Before, if the list of actions had not been modified by the time
	  they were displayed, the prompt would be skipped even if some
	  packages were broken.  Now, if packages are broken, we always
	  continue to the prompt (including the resolver).

	* doc/en/aptitude.xml:

	  Finish documenting the new configuration options.

	* src/generic/aptitude_resolver.cc:

	  When tweaking scores based on priority, don't tweak the score of
	  the not-installed version.

2005-04-30  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml:

	  Start documenting the new configuration options.

	* doc/en/aptitude.xml, doc/en/images/views-tab-bar.png:

	  Document the business with having tab-bars at the top of the
	  display.

	* doc/en/aptitude.xml:

	  Document the new keybindings.

	* doc/en/aptitude.xml:

	  Move a tip around to a place where it will make more sense soon.

	* doc/en/aptitude.xml:

	  Update the tutorial on broken dependencies to discuss the new
	  dependency resolver.

	* src/generic/problemresolver/model.tex:

	  Further description of the algorithm.

	* src/generic/aptcache.cc:

	  Make packages installed/removed by the resolver get marked as
	  "automatic" (using a new changed_reason value).

	* src/solution_dialog.cc:

	  Make the top row of the dialog shrinkable, so the buttons never
	  disappear -- even if it gets too tall.

	* src/solution_dialog.cc:

	  Fix up the layout options in the solution dialog.  The most
	  important change is that the button box is now shrinkable, which
	  in turn means that the scrollbar will always be visible (because
	  the first column of the table will be preferentially shrunk).

	* src/cmdline/cmdline_prompt.cc:

	  After running the resolver, always fall out to the main loop, so
	  that a new preview gets displayed before the prompt is shown
	  again.

	* src/cmdline/cmdline_download.cc, src/cmdline/cmdline_progress.cc, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_search.cc, src/cmdline/cmdline_show.cc, src/main.cc:

	  Quit running update_screen_width all over the place in
	  command-line mode; instead, set up a SIGWINCH handler and read
	  the screen width for the first time in main.

	* src/cmdline/cmdline_do_action.cc:

	  Get rid of the separate resolve step prior to prompting, which
	  should make the command-line interaction a bit nicer.

	* src/cmdline/cmdline_prompt.cc:

	  Display the prompt help using fragments, so it gets properly
	  flowed.

	* src/cmdline/cmdline_resolver.cc:

	  Remove an unneeded flowbox, make indentation work correctly
	  (remember: indentboxes go *outside* flowboxes).

	* src/cmdline/cmdline_do_action.cc:

	  Support the new action flags and stuff in the name-mangling
	  code.

	* src/cmdline/cmdline_action.cc, src/cmdline/cmdline_common.h, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_resolver.h:

	  Add support for manipulating the automatic flag from the
	  command-line prompt.

	* src/cmdline/cmdline_resolver.cc:

	  Add a space after the resolver prompt string.

	* src/cmdline/cmdline_action.cc, src/cmdline/cmdline_common.h, src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_resolver.cc:

	  Add a 'keep' action (invoked via ':') to the command-line
	  prompts.

	* src/cmdline/cmdline_action.cc, src/cmdline/cmdline_action.h, src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_resolver.h:

	  Add support for modifying package states from the resolver
	  prompt; in the process, moved the routine responsible for doing
	  this from cmdline_prompt.cc to cmdline_action.cc.

	* src/cmdline/cmdline_resolver.cc:

	  Fix some of the formatting problems with the resolver help text.
	  Introduce help for not-yet-extant commands.

	* src/generic/aptcache.cc, src/generic/aptcache.h, src/generic/problemresolver/problemresolver.h:

	  Add support in the cache abstraction for dumping the resolver
	  state (including, importantly, the current set of version
	  scores).

	* src/generic/problemresolver/test.cc, src/generic/problemresolver/test1.txt:

	  Fix the test code to work with the new problem resolver.

	* src/generic/aptitude_resolver.h:

	  Adjust the get_name() routine of versions to mangle versions
	  when several versions with the same name are available.

	* src/generic/aptcache.cc:

	  Default score tweaking: double the penalty for broken deps, make
	  infinity much larger, and only work with the first dependency
	  that generates successors, rather than generating all possible
	  successors; this is done in order to decrease the branching
	  factor.  In theory only looking at a single dep could generate
	  worse solutions overall, but it seems to work OK in my tests.

	  Also, only check up to 100 solutions before giving up!

	* src/generic/problemresolver/problemresolver.h:

	  Right, only spew if debug is enabled.

	* src/generic/problemresolver/problemresolver.h:

	  When generating the successors of a solution, detect "forced"
	  installs (i.e., installs which must be in any successor
	  solution, such as deps that have only one solver) and perform
	  them immediately.  In the process, refactored and complicatified
	  the problem resolver.

	* src/generic/problemresolver/problemresolver.h:

	  Actually drop attempts to install "forbidden" package versions.

	* src/generic/problemresolver/problemresolver.h:

	  Add basic support for maintaining a list of "forbidden" package
	  versions that varies by solution.

2005-04-29  Daniel Burrows  <dburrows@debian.org>

	* po/POTFILES.in, po/*.po:

	  Update POTFILES (oops, forgot to do that for a while) and run
	  'make update-po'.

	* src/cmdline/cmdline_resolver.cc:

	  Be less strict about obeying command-line instructions, to avoid
	  spending lots of time searching really bad solutions if the user
	  asks for something impossible.

	* src/cmdline/cmdline_resolver.cc:

	  Oops, iterate over the whole version list, not just the part of
	  it that follows the current version.

	* src/cmdline/cmdline_resolver.cc:

	  Uninvert the tweaking logic: now, instead of giving a bonus to
	  removal if the user *didn't* ask for a package to be removed, we
	  give a bonus to removal if the user *did* ask for a package to
	  be removed.

	* src/cmdline/cmdline_resolver.cc:

	  When tweaking scores, generate an end iterator (not an invalid
	  iterator) for the UNINST version.

	* src/generic/aptitude_resolver.h:

	  Add some asserts to cache situations that shouldn't happen.

	* src/generic/problemresolver/problemresolver.h:

	  Right, test subset-inclusion in the correct order...

	* src/ui.cc:

	  Fix some typos in various strings that were pointed out by the
	  Vietnamese translator.

2005-04-28  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptitude_resolver.h, src/generic/aptitude_resolver.cc, src/generic/problemresolver/problemresolver.h:

	  Fix a monumentally stupid decision (storing references to a
	  universe in the problem resolver), fixing the segfault caused by
	  the previous segfault's fix.

	* src/cmdline/cmdline_dump_resolver.cc, src/generic/aptcache.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Carry a backpointer to the cache around in all the resolver glue
	  code, to avoid segfaulting if apt_cache_file is uninitialized
	  when we're called (e.g., if packages are broken on startup).

	* src/cmdline/cmdline_resolver.cc:

	  Fix a very stupid infinite loop bug.

	* src/generic/problemresolver/problemresolver.h:

	  Ignore any solution that's a subset of another solution.

	* src/generic/problemresolver/problemresolver.h:

	  Write in a definition of operator!= for solutions -- I don't
	  know where the default was coming from, but it's wrong, wrong,
	  WRONG.

	* src/generic/problemresolver/problemresolver.h:

	  Fix an ugliness in the debugging output.

	* src/cmdline/cmdline_resolver.cc:

	  Use the new hooks to enable debugging based on the option
	  Aptitude::CmdLine::Resolver-Debug.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add hooks for enabling resolver debugging.

	* src/cmdline/cmdline_resolver.cc:

	  Streamline the "reject solution" command.

	* src/cmdline/cmdline_resolver.cc:

	  Doh, C++ varargs have to be explicitly terminated; do that
	  instead of crashing.

	* src/main.cc:

	  Add debugging catches to trap unhandled exceptions.

	* src/cmdline/cmdline_action.cc, src/cmdline/cmdline_action.h, src/cmdline/cmdline_do_action.cc, src/cmdline/cmdline_prompt.cc, src/cmdline/cmdline_prompt.h, src/cmdline/cmdline_resolver.cc, src/cmdline/cmdline_resolver.h, src/cmdline/cmdline_show_broken.cc, src/cmdline/cmdline_show.cc, src/cmdline/cmdline_show.h, src/cmdline/cmdline_simulate.cc, src/cmdline/cmdline_simulate.h, src/cmdline/cmdline_upgrade.cc, src/cmdline/Makefile.am:

	  Start work on hooking the new resolver into the command-line.
	  The new approach works by having a sub-loop that gets entered if
	  broken dependencies are detected at the command-line prompt.

	* src/generic/aptcache.cc, src/generic/aptcache.h, src/generic/problemresolver/problemresolver.h:

	  Add provisions for adjusting package scores before running the
	  resolver.

2005-04-27  Daniel Burrows  <dburrows@debian.org>

	* src/main.cc:

	  Ignore -s when running in interactive mode. (Closes: #243192)

	* src/vscreen/vs_multiplex.cc:

	  Recognize mouse clicks on the "tabs".

	* src/download.cc, src/pkg_item.cc, src/pkg_ver_item.cc, src/ui.cc, src/ui.h, src/view_changelog.cc:

	  Use tabs for the main multiplex.

	* doc/en/aptitude.xml, src/vscreen/vscreen.cc:

	  Use less vomit-inducing default colors for multiplex tabs.

	* src/vscreen/vs_multiplex.cc:

	  Use the correct addstr() variant; the chstring variant is a bit
	  broken right now :( (and of course it doesn't preserve
	  attributes).

	* src/vscreen/testvscreen.cc:

	  Enable tabs in the test program.

	* src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h:

	  Oh yeah, make it possible to actually turn on the tab support.

	* doc/en/aptitude.xml, src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h, src/vscreen/vscreen.cc:

	  Add theoretical support for 'tabbed' multiplexes (untested as
	  yet).  In order to do this properly, I had to extend the
	  vs_multiplex API and rewrite its internals to represent each
	  child using an actual structure.

	* src/main.cc:

	  Hook the layer of indirection up to "dump errors to cerr" before
	  executing command-line requests.

	* src/generic/apt.cc, src/generic/apt.h, src/ui.cc:

	  Add a layer of indirection (a signal) between the request to
	  clear the error list and the clearing of the error list.  Among
	  other things, this means that the command-line no longer
	  segfaults when errors occur.

	* src/ui.cc:

	  Use the new support in vs_text_layout to not open tons of
	  extraneous error dialogs (instead we just reuse the existing
	  ones).

	* src/vscreen/vs_text_layout.cc, src/vscreen/vs_text_layout.h:

	  Add a way to append text to a vs_text_layout 'after the fact'.

	* src/generic/apt.cc:

	  Hackily avoid discarding the error list by instead asking the UI
	  to clear it out for us (making sure that errors don't get lost).
	  (Closes: #160418)

	* doc/en/aptitude.xml, src/generic/matchers.cc:

	  Make ~ahold find packages that are actually *held*.  ~akeep now
	  finds packages upon which no action is being taken; the old
	  meaning of ~ahold is available via "~U~akeep".
	  (Closes: #216730)

	* src/apt_info_tree.cc, src/apt_info_tree.h, src/ui.cc:

	  Apply a similar treatment to the various apt_info_trees: create
	  a method that explicitly re-issues the various signals, and tell
	  the user to invoke it after connecting said signals.

	* src/pkg_tree.cc, src/pkg_tree.h, src/ui.cc:

	  Don't implicitly build a pkg_tree when it's created.  Instead,
	  expect the caller to call build_tree() once the tree is fully
	  hooked up.  This avoids the inconsistencies caused by the tree's
	  signal getting emitted before it's connected to anything.

	* src/vscreen/vs_text_layout.cc:

	  Fix the caching of text layouts: the 'lastw' variable wasn't
	  being updated, so the layout always looked stale!

	* src/vscreen/vs_tree.cc:

	  Remove the grotesque hack of calling highlighted() in paint();
	  among other things, it was responsible for making everything
	  slow when the user was scrolling around the description area.

	* src/generic/aptcache.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Put a cap on how many successors will be generated for any given
	  dep.  This is sufficient to generate all solutions (albiet
	  possibly in a bad order); for simple problems (where everything
	  worked already) it has no effect if the cap is large enough; and
	  it should produce reasonable results for complicated programs.

	* src/generic/aptcache.cc:

	  Penalize brokenness less again; placing too high a bounty on
	  fixing broken deps makes solutions turn up in the wrong order.

	* src/generic/aptcache.cc:

	  Make infinity smaller and penalize brokenness more.  Now if
	  aptitude goes nuts (although I should do more to stop this) it
	  at least won't eat all your virtual memory before figuring out
	  that no solutions exist.  This is a bit of a hack, though..

	* src/generic/problemresolver/problemresolver.h:

	  Incrementally calculate the new score, and abort as soon as it
	  drops below minimum_score.

	* src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Add a 'broken_under' method to the aptitude_resolver_dep class,
	  and use it in the problem resolver to (hopefully) speed up
	  checking whether dependencies are broken in a given solution.

	* src/generic/aptcache.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Add basic support in the problem-resolver for specifying
	  "infinity" -- a boundary for solution badness beyond which all
	  solutions are dropped.

	* src/generic/aptcache.cc:

	  Decrease the default max_steps value so that hard-to-resolve
	  problems don't cause aptitude to lock up.  (not very successful
	  yet)

	* src/vscreen/config/keybindings.cc, src/vscreen/keybindings.h:

	  Make a global readable_keyname as well.

	* src/vscreen/config/keybindings.cc, src/vscreen/config/keybindings.h:

	  Oops, properly declare the new keyname function.

	* src/broken_indicator.cc, src/solution_dialog.cc, src/ui.cc, src/vscreen/testvscreen.cc, src/vscreen/vs_menu.cc:

	  Use the readable_keyname function as appropriate.

	* src/vscreen/config/keybindings.cc, src/vscreen/config/keybindings.h:

	  Add a 'readable_keyname' function, whose current useful feature
	  is that it maps ',' to ',' instead of 'comma'.

	* src/pkg_item.cc:

	  Reflow some manually wrapped messages.

	* src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Add a vs_dialog_string variant that allows raw fragments to be
	  passed.

	* src/download_bar.cc, src/download_list.cc:

	  Word the question less awkwardly.

	* src/download_bar.cc, src/download_list.cc:

	  Flow the other media-change question, and get rid of an
	  unnecessary newline in both media-change questions (since the
	  text is wrapped now, there's no need to break after the first
	  half).

2005-04-26  Daniel Burrows  <dburrows@debian.org>

	* src/download_bar.cc:

	  Flow the media-change question.

	* src/ui.cc:

	  Also flow the query regarding switching to the root account.

	* src/ui.cc:

	  Wrap the menu descriptions in the status area and eliminate some
	  literal newlines (need to get rid of other literal newlines
	  elsewhere in the program...)

	* src/vscreen/vs_label.cc:

	  Implement the fragment set_text and fix a memory leak.

	* src/vscreen/vs_label.cc:

	  When no attribute is provided, the widget's background is used
	  to set default text attributes.

	* src/vscreen/vs_util.cc:

	  Fix the canned dialogs to properly initialize the attributes of
	  their labels.

	* src/vscreen/testvscreen.cc:

	  Fix the label test.

	* src/vscreen/testvscreen.cc, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_label.cc, src/vscreen/vs_label.h:

	  Add a attribute-less set_text; fix various places where it needs
	  to not be used.

	* src/vscreen/vs_label.cc, src/vscreen/vs_label.h:

	  Make labels use fragments internally.  IMPORTANT: this means
	  that implicit interpretation of \n and \t no longer works...

	* src/apt_options.cc:

	  Use FILL appropriately so the buttons at the bottom of the
	  options dialogs get appropriately centered.

	* src/ui.cc:

	  Use FILL so that we get a display that actually works.

	* src/pkg_view.cc:

	  When setting up the description, insert all widgets with
	  EXPAND/FILL.

	* src/vscreen/testvscreen.cc:

	  Fix the test program's use of EXPAND/FILL.

	* src/vscreen/vs_table.cc:

	  Change the semantics of FILL/EXPAND: EXPAND only changes whether
	  a widget's row can be expanded; in order to expand the widget
	  itself you must also specify FILL.  For backwards compatibility
	  and ease of use, the non-opts add_widget sets FILL if EXPAND is
	  set.

	* src/apt_options.cc:

	  Put the Ok/Cancel button in a separate table.

	* src/apt_config_widgets.cc:

	  Flow the text in the configuration button labels.

	* src/vscreen/vs_togglebutton.cc, src/vscreen/vs_togglebutton.h:

	  For multiline toggles, make sure to put the cursor on the line
	  containing the toggle button.  Also, choose that line according
	  to the widget size, not the text layout size; if the widget is
	  smaller than the text layout, only step up to its height when
	  drawing.

	* src/vscreen/fragment_cache.cc, src/vscreen/fragment_cache.h, src/vscreen/vs_button.cc, src/vscreen/vs_button.h, src/vscreen/vs_togglebutton.cc:

	  Get the cache working, and use it to hold the fragments of
	  buttons.

	* src/vscreen/fragment_cache.cc, src/vscreen/fragment_cache.h:

	  Add a special intermediate fragment widget that caches the
	  output of its contents.

	* src/vscreen/vs_togglebutton.cc, src/vscreen/vs_togglebutton.h:

	  Fix the display of toggle buttons; in particular, make sure the
	  "check" gets lined up in the center of the button.

	* src/vscreen/testvscreen.cc:

	  In the button test screen, use different settings to insert the
	  various buttons; make sure the buttons are center-aligned.

	* src/vscreen/vs_button.cc:

	  Fix multi-line push-buttons.

	* src/vscreen/testvscreen.cc:

	  Test multi-line fragments.

	* src/vscreen/testvscreen.cc:

	  Test using actual fragments in button labels.

	* src/vscreen/vs_togglebutton.cc:

	  Make sure the right half of the toggle button's check gets
	  displayed.

	* src/vs_button.cc:

	  Don't go into infinite loops drawing buttons.

	* src/vscreen/vs_button.cc, src/vscreen/vs_button.h, src/vscreen/vs_togglebutton.cc, src/vscreen/vs_togglebutton.h:

	  Add basic support for using fragments as button labels.

	* src/vscreen/fragment_contents.h:

	  Make size() const.

	* src/ui.cc:

	  Oops, actually show a preview after auto-fixing.

	* src/solution_fragment.cc:

	  Don't require that the solution is a sensible solution right
	  this instant; this allows a fragment describing an
	  already-applied solution to be generated.

	* src/ui.cc:

	  Eliminate all uses of try_fix_broken() in the pre-installation
	  phase; in the process, factored out a bunch of common code from
	  some of the preview setup functions.

	* src/generic/aptcache.h:

	  Pack the extended state information more tightly using field
	  widths.

	* src/vscreen/fragment.cc:

	  For more correctness, tie the cache to the last seen
	  indentations.  (only the last values are preserved because I
	  expect them never to change; this is so that in case they do for
	  some odd reason, the results are still correct)

	* src/vscreen/fragment.cc:

	  Fix sequence_fragment::trailing_width to return the correct
	  value (previously, it would always return 0, due to an
	  accidental bool -> int conversion).

	* src/solution_dialog.cc:

	  Make the solution dialog disappear when the user presses the
	  apply key.

	* src/solution_fragment.cc:

	  Put parens around archives, don't uselessly translate format
	  strings.

	* src/vscreen/vs_table.cc:

	  Fix a memory leak -- vs_tables didn't delete their children.

	* src/vscreen/fragment.cc:

	  Slightly fix the way sequence fragments calculate their width.

	* src/solution_fragment.cc:

	  Fix some missing newlines in the solution fragment formatting.

	* src/cmdline/cmdline_show.cc, src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/vs_layout_item.cc, src/vscreen/vs_text_layout.cc:

	  Make the text layout algorithm also take indentation into
	  account.

	* src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/vs_text_layout.cc:

	  Adjust the fragment width calculation to properly take
	  indentation into account.

	* src/solution_dialog.cc:

	  Move the buttons into a separate "box" table, and add a
	  scrollbar to the solution dialog.

2005-04-25  Daniel Burrows  <dburrows@debian.org>

	* src/solution_dialog.cc:

	  Disable reverse-video for now, till I get proper support for
	  cascading video attributes (otherwise I lose the bold attribute
	  on the headers of the various sections, if that makes sense..)

	* src/vscreen/fragment.cc:

	  Make the max-width calculation more obviously correct.

	* src/vscreen/vs_text_layout.cc:

	  When the text layout's fragment changes, queue a full layout run
	  (not just an update).

	* src/solution_dialog:

	  Make the dialog "dialog colored" in the usual hacky way.

	* src/solution_dialog.cc, src/ui.cc, src/ui.h:

	  Add some pushable buttons to issue solution-viewing commands.

	* src/ui.cc:

	  Pop up an examination dialog when the user presses 'e'.

	* src/broken_indicator.cc, src/solution_dialog.cc, src/solution_dialog.h:

	  Add a start on a dynamically updating solution dialog.  The
	  change to broken_indicator just removes an unnecessary
	  translatable format string (now what's translated is an argument
	  to the format string).

2005-04-23  Daniel Burrows  <dburrows@debian.org>

	* src/broken_indicator.cc:

	  Actually indicate how many downgrades are needed.

	* src/generic/aptitude_resolver.h:

	  Fix a silly logic error in the revdep_iterator that caused
	  reverse dependencies through Provides: to not be considered.

	* src/generic/aptitude_resolver.h:

	  Don't generate inapplicable revdeps, even if they're the first
	  item in the list.

	* src/generic/problemresolver/problemresolver.h:

	  Fix the solution dumper to work properly on non-cout streams too
	  (it called cout instead of its parameter in a few places).

	* src/generic/aptcache.h:

	  Remove the need to include problemresolver.h from every single
	  source file by using the fact that templates can be forward
	  declared.

	* src/generic/aptcache.cc:

	  Deprioritize keeps relative to installs/upgrades: the user
	  rarely wants us to cancel his/her decisions! (removals are still
	  deep-sixed unless abolutely necessary, though) Also, greatly
	  *decrease* the bonus for preserving automatic packages.

	* src/ui.cc:

	  Put the broken indicator above the status area, not in it.

	* src/broken_indicator.cc:

	  Don't display the total number of calculated solutions unless
	  they've been exhausted (I think that's likely to be confusing).

	* src/broken_indicator.cc:

	  Capitalize the command names in the indicator, to match the
	  hints at the top of the screen, and make then i18nable.

	* src/broken_indicator.cc:

	  Make the whole broken indicator red, not just the text.

2005-04-22  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc:

	  Avoid the dread assertion failure in a slightly hacky way.

	* src/cmdline/cmdline_do_action.cc, src/generic/aptcache.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Instead of automatically floating complete solutions to the head
	  of the queue, apply a configurable bonus score to them (and in
	  fact it's set rather low by default).  This should avoid
	  situations where a really bad solution happens to appear before
	  a pretty good one.

	  Also, remove the now-useless debugging invocation of the
	  resolver.

	* src/solution_fragment.cc:

	  Display the score of the solution.

	* src/generic/aptcache.cc:

	  Tweak the default scores: be slightly less hostile to changing
	  the user's selections, and greatly increase the penalties for
	  broken deps and for removing packages.

	* src/generic/aptcache.cc:

	  Fix a reversed comparison in solutions_exhausted.

	* src/generic/problemresolver/problemresolver.h:

	  For more correctness, always throw NoMoreSolutions when we're
	  out of potential solutions, even if the last element of the open
	  queue is a solution.

	* src/broken_indicator.cc:

	  Incorporate the solution counts into the suggestion bar.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add routines to extract more information about cached solutions
	  (to add to the suggestion bar).

	* src/generic/aptcache.cc:

	  In next_solution(), always advance to the newly created solution
	  after generating it, and signal that the selection changed.

	* src/solution_fragment.cc, src/solution_fragment.h, src/ui.cc:

	  Add preliminary code to display a solution, and hook it up in
	  the simplest possible way.

	* src/broken_indicator.cc:

	  Fix an assertion failure due to an incorrect assumption.

	* src/broken_indicator.cc:

	  Use the new signal to reset the broken indicator at appropriate
	  times.

	* src/generic/aptcache.cc:

	  Actually perform the function call so everything compiles.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add a signal that gets called whenever the currently selected
	  solution is changed, and make sure to set selected_solution to 0
	  when we insert the first solution.

	* src/ui.cc:

	  In do_next_solution(), handle exceptional situations from the
	  problem resolver.

	* src/ui.cc:

	  Hook up the various solution-related commands to do *something*,
	  although some of them are still incomplete.

	* src/generic/aptcache.h:

	  Clarify the documentation of apply_current_solution.

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Add an interface routine to easily apply the currently selected
	  solution.

	* src/defaults.cc:

	  Set up default key bindings for the problem resolver.

	* src/broken_indicator.cc:

	  Also display keeps, don't display ungrammatical text for
	  singular actions, and move the key hints to the next line.

	* src/pkg_view.cc, src/ui.cc:

	  Move the broken indicator into the status bar area.

	* src/broken_indicator.cc:

	  Hide an inactive indicator; correctly handle cache reloading.

	* src/generic/problemresolver/problemresolver.h:

	  Add a method on solutions to explicitly invalidate them.

	* src/broken_indicator.cc: 

	  Doh, fix a compile error.

	* src/generic/aptcache.cc:

	  Add yet one more missing call to package_state_changed (in
	  end_action_group).

	* src/broken_indicator.cc:

	  Add a sanity-check.

	* src/generic/aptcache.cc:

	  Also call the package-state-changed signal after an
	  installation.

	* src/broken_indicator.cc:

	  Use the new signal to update the broken indicator.

	* src/generic/aptcache.cc, src/generic/aptcache.h, src/main.cc:

	  Make "package_state_changed" an argumentless signal, and call it
	  whenever a package's install version changes.  Also added a
	  missing discard_resolver()/create_resolver() pair in
	  set_candidate_version.

	* src/generic/problemresolver/problemresolver.h:

	  Add a flag to enable or disable debugging; debugging is disabled
	  by default.

2005-04-21  Daniel Burrows  <dburrows@debian.org>

	* src/broken_indicator.cc:

	  Oops, blank the indicator by making it an empty fragment, not by
	  making it NULL.

	* src/broken_indicator.cc, src/pkg_view.cc:

	  Hook up the broken indicator to the package-view class, and do
	  some awful hacking to make it sort of update.  Needs work, such
	  as actually getting the package_state_changed signal or
	  something similar hooked up.

	  Also, fix the guard against a NULL cache so we don't crash on
	  startup (doh).

	* src/Makefile.am, src/broken_indicator.cc, src/broken_indicator.h, src/generic/aptitude_resolver.h:

	  Write a first draft of the widget to display information about
	  the current proposed solution.  Also made some methods const
	  that ought to be.  sleepy.

	* src/generic/aptcache.cc:

	  Look up BrokenCount on "this", not on the global apt_cache_file
	  variable (which might not be initialized yet).

	* src/pkg_view.cc:

	  Ignore both horizontal and vertical size requests for main
	  widgets/descriptions (should make vertical-split themes work --
	  I believe they were broken otherwise..)

	* src/generic/aptcache.cc, src/generic/aptcache.h:

	  Write rudimentary code for maintaining a set of known solutions
	  to any extant problems (expanded on demand).

	* src/generic/problemresolver/problemresolver.h:

	  Add a function that returns "true" if the open queue has been
	  exhausted.

	* src/generic/problemresolver/problemresolver.h:

	  Once a resolver examines all possible solutions, it now returns
	  "no more solutions" permanently until you call a "reset" method
	  (which clears out all scores and empties the open and closed
	  queues).

	* src/generic/problemresolver/problemresolver.h:

	  Lift the "solution" class out of the generic_problem_resolver
	  class so I can forward-declare it (and hence declare pointers
	  and references to it in aptcache.h).

	* src/generic/aptitude_resolver.h:

	  Make the glue code functions static.

2005-04-20  Daniel Burrows  <dburrows@debian.org>

	* src/desc_parse.cc:

	  Make sure bullet whitespace-stripping includes the space that
	  separates the bullet from the following text; position the
	  initial parse location appropriately.  Paragraphs in lists get
	  flowed now!

	* src/desc_parse.cc:

	  Base the *output* indent level of bulleted text on the number of
	  bullet levels, not the input indent level.

	* src/desc_parse.cc:

	  Allow bulleted lists that are indented more than 2 spaces.
	  Don't mangle lists and literal lines that immediately follow a
	  paragraph.

	* src/desc_parse.cc:

	  Fix a silly thinko in the generation of bullets that was causing
	  bullets to appear twice in the output.

	* src/desc_parse.cc:

	  Add a missing "break".

	* src/desc_parse.cc:

	  Initial implementation of automagic bullet detection.
	  Buggy.

	* src/desc_parse.cc:

	  Rework make_desc_fragment to add theoretical support for
	  indentation levels in the input description.  No change should
	  occur in the resulting text as a result of this modification.

	* src/desc_parse.cc:

	  Include comments on how lists ought to be handled, and hardwrap
	  preformatted lines as per Policy.

	* src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/testvscreen.cc:

	  Add a "hardwrapbox" which wraps lines hard to the fragment's
	  width (rather than doing word-wrapping).

	* src/generic/problemresolver/model.tex:

	  Add some discussion of the theoretical basis for the new problem
	  resolver.

2005-04-10  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_do_action.cc, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Add and use a feature to easily apply heavy penalties to the
	  removal of Essential packages.

	* src/generic/problemresolver/problemresolver.h:

	  Add missing "const"s to some function prototypes, comment out
	  some non-generic debug code.

	* src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Rename add_scores -> add_actions_scores, and write
	  add_priority_scores (tweaks scores according to Priority).

	* src/generic/aptitude_resolver.h:

	  Always normalize solver_iterators.  This should fix the problem
	  where Conflicts would include the first version of the
	  conflicted package as a solver.

	* src/generic/aptitude_resolver.h:

	  Only iterate over critical revdeps (I was iterating over *all*
	  revdeps, which is what caused all the weirdness before).

	* src/generic/problemresolver/problemresolver.h:

	  Add more debugging, to make it easy to find out where
	  unresolvable deps are coming from.

	* src/generic/aptitude_resolver.h:

	  Add more accessors, the better to debug it with.

2005-04-09  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_do_action.cc:

	  Penalize, don't reward, broken packages and long solutions.

	* src/generic/problemresolver/problemresolver.h:

	  Fix a big thinko: always enqueue solvers for *both* sides of a
	  depends!

	* src/generic/aptitude_resolver.h:

	  Fix the version sent to the problem resolver (should be
	  pkg->ID+VersionCount, not pkg->ID+PackageCount).

	* src/generic/aptitude_resolver.h:

	  Report the correct adjusted version count to the problem
	  resolver.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Add asserts in order to try and track down where the IDs that
	  are too large for the version array are coming from.

	* src/generic/problemresolver/problemresolver.h:

	  Use map's operator< to order solutions rather than hacking my
	  own.  Has the benefit of fixing one known and at least one
	  unknown bug in the ordering of solutions.  Closed solutions
	  actually get dropped now.

	* src/cmdline/cmdline_do_action.cc:

	  Summarize the proposed solutions as debug output.

	* src/generic/aptitude_resolver.h:

	  Fix an extremely stupid bug (== vs !=) in
	  aptitude_resolver_version::operator!=.

	* src/generic/problemresolver/problemresolver.h:

	  Add some more guards against doubly-changing packages.

	* src/generic/aptitude_resolver.h:

	  Fix some backwards logic that was used when finding broken deps
	  (it only found *non*-broken deps).

	* src/generic/aptitude_resolver.h:

	  Fix an infinite loop in the revdep_iterator.

	* src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Add spacing between the components of a depends list.

	* src/generic/aptitude_resolver.h:

	  Don't spin forever looking for broken deps.

	* src/generic/aptitude_resolver.h:

	  Fix a silly segfault by initializing a dep as I meant to do in
	  the first place.

	* src/generic/aptitude_resolver.cc:

	  Fix the operator<< on deps to be more useful.

	* src/generic/aptitude_resolver.h:

	  Fix an infinite recursion bug in the broken-dep iterator.

	* src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Fix some multiply-defined functions by making them inline and/or
	  moving them to the .cc file.

	* src/cmdline/cmdline_do_action.cc:

	  On dist-upgrade, etc, run the new resolver.  Its output is
	  discarded -- this is just to see how it works on real problems.

	* src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Further fixes for constness, typing problems.

	* src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Fix various errors in the code that cropped up while trying to
	  assemble everything.

	* src/generic/aptitude_resolver.h:

	  Use public inheritance from generic_problem_resolver (d'oh).

	* src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h:

	  Add missing get_version_count(), fill in and fix the constructor
	  of aptitude_resolver.

	* src/cmdline/cmdline_dump_resolver.cc:

	  Update the #include of aptitude_resolver.h to point at the new
	  location.

	* src/generic/Makefile.am, src/generic/aptitude_resolver.cc, src/generic/aptitude_resolver.h, src/generic/problemresolver/problemresolver.h:

	  Write the body of add_scores(), fix some problems with the
	  generic resolver that came up in the process, and link it into
	  the Makefile.

	* src/generic/problemresolver/aptitude_resolver.h, src/generic/aptitude_resolver.h:

	  Move the aptitude_resolver file into generic/ so that
	  I can easily incorporate a .cc file into the main program.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Write up a prototype for a super-duper-scoring-function.

	* src/generic/problemresolver/problemresolver.h:

	  When dumping the universe, include the syntactic sugar arrows so
	  that we can parse it back in.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Make sure to never ever ever produce noncritical deps in a dump.

	* src/cmdline/cmdline_dump_resolver.cc:

	  Always return success after a dump.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Make sure to use the correct solver_iterator constructor variant
	  for each appropriate case.

	  In dep_iterator's ++, make sure to call normalize in *all*
	  cases, not just the case of advancing the dep ptr.  For
	  Conflicts, always advance by exactly one step.

	* src/generic/problemresolver/aptitude_resolver.h:

	  When normalizing solver-iterators, include the code to advance
	  the dependency inside the loop that runs till we run out of deps
	  (so the program doesn't go into an infinite loop..oops..).

	* src/generic/problemresolver/aptitude_resolver.h:

	  Add code to drop self-conflicts.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Drastically overhaul how Conflicts are handled.  Now each
	  Conflicts line generates a separate dependency for every listed
	  package *and* one dependency for each provider of every listed
	  package.  This is the only sensible way to handle Conflicts in
	  the presence of virtual deps.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Actually, no need to test dep_lst.end() -- just correct
	  the erroneous test of the OR bit (I hate C++).

	* src/generic/problemresolver/aptitude_resolver.h:

	  Assert that dep_lst is non-end BEFORE possibly pushing it off
	  the end, make dep_lst's end-ness part of the end() condition for
	  solver_iterators, and test against end() instead of finished.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Fix the dep_iterator to iterate over all dependencies instead of
	  none.

	* src/generic/problemresolver/test.cc:

	  Run dump_universe on input universes, both for diagnostics
	  and to test dump_universe.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Fix the dep_iterator to not blow up.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Make sure to include UNINST in version iteration (avoid
	  adding an extraneous bool by overloading pkg to track
	  end-ness).

	* src/generic/problemresolver/problemresolver.h:

	  Fix the dump output (again) to comply with the input spec.

	* src/main.cc, src/cmdline/Makefile.am, src/cmdline/cmdline_dump_resolver.cc, src/cmdline/cmdline_dump_resolver.h:

	  Add a debugging command to dump the resolver's state
	  (currently quite primitive).

	* src/generic/problemresolver/aptitude_resolver.h:

	  Fix some more missing stuff that turned up while trying to use
	  the aptitude resolver.

	* src/generic/problemresolver/aptitude_resolver.h:

	  Add a preliminary APT-based resolver universe (totally untested, but it
	  sort of compiles).

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Make changes necessary to support apt universes in a simple way.
	  In particular, the exported iterators now support end() methods
	  and their containers only provide a _begin() method (this allows
	  the iterators to be built on standard APT iterators).

2005-04-08  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Use operator<, not get_id(), to compare versions; use the
	  fact that version comparisons include package comparisons.

	* src/generic/problemresolver/problemresolver.h:

	  Enable the closed queue, and fix solution_contents_compare to
	  not treat all solutions as equal to one another.

	* src/generic/problemresolver/test.cc:

	  Overhaul the test code to make the test fully controlled
	  by its input file -- including support for specifying
	  tests to run on the universe and the expected results.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Make dump_universe generic, move it to problemresolver.h, and
	  output exactly the information expected by the test parser.

2005-04-07  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/problemresolver.h:

	  Remove a bunch of uninteresting debugging output, set up
	  indentation to make it clearer what's happening.

	* src/generic/problemresolver/test.cc, src/generic/problemresolver/test1.txt:

	  Properly support conflicts in test files, make the simple test
	  more interesting.

	* src/generic/problemresolver/test.cc, src/generic/problemresolver/test1.txt:

	  The current version must now be given after the list of versions
	  (makes it easier to change the current version, hopefully).

	* src/generic/problemresolver/test.cc:

	  Fix a rather silly mistake that caused dummy_dep::broken()
	  to return incorrect answers.

	* src/generic/problemresolver/test.cc:

	  Fix the broken_dep_iter -- it would always claim the
	  first thing in the list was broken.

	* src/generic/problemresolver/problemresolver.h:

	  Add yet more debugging code.

	* src/generic/problemresolver/test.cc:

	  Add more debugging code; make dump() dump all info by default.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Make the broken dependency list a unique set (ow, big runtime
	  hit, but otherwise solutions where a single broken dependency is
	  listed many times will be de-prioritized, which shouldn't always
	  happen).

	* src/generic/problemresolver/test.cc:

	  Print out the solution when we find one.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Fix the assertion failure: when trying to nullify the LHS of a
	  depends, install everything *but* the depending version.  Also
	  touched up the debug output.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Fix the segfault by adding the missing "&", and tweak the output
	  code a bit.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Add some debugging code to try to track down the current
	  segfault.

	* src/generic/problemresolver/test.cc:

	  Fix the broken_dep_iterator to actually increment

	* src/generic/problemresolver/problemresolver.h:

	  Actually decrement the max_steps counter, and make it
	  signed to avoid accidents with -1==INT_MAX.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Finish writing the final method of the resolver, and
	  make the changes (in both files) necessary to hook it
	  up to the toy package system and get it to run.

	* src/generic/problemresolver/problemresolver.h, src/generic/problemresolver/test.cc:

	  Complete and compile the resolver ...... theoretically.
	  Now it's time to watch it run reallllly sloowwwly
	  and produce stoopid answers.

	* src/generic/problemresolver/problemresolver.h:

	  Start work on a currently broken problem resolver.

2005-04-06  Daniel Burrows  <dburrows@debian.org>

	* src/generic/problemresolver/test.cc:

	  It seems numerical IDs will be needed, add support
	  for them.

	* configure.ac, src/generic/problemresolver/test.cc, src/generic/problemresolver/test1.txt:

	  Start adding code to try out some ideas about resolving
	  dependency problems.

2005-03-09  Daniel Burrows  <dburrows@debian.org>

	* src/download_list.cc:

	  Make sure to run the message regarding failed downloads
	  through fragf. (Closes: #298713)

2005-03-03  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_util.cc:

	  Fix a crashing bug caused by trying to cast a slotarg
	  instead of dereferencing it. (Closes: #293935)

2005-01-10  Daniel Burrows  <dburrows@debian.org>

	* doc/fr/Makefile.am:

	  Actually delete the generated manpage in the "clean" rule.

	* po/POTFILES.in:

	  Update with the current list of files in the source
	  distribution.

	* configure.ac, NEWS:

	  Bump version number to 0.3.1.

	* doc/en/aptitude.xml:

	  Update the version number to 0.3.1, and explicitly state which
	  version of libsigc++ is needed.

	* po/nl.po:

	  Merge up to r2879 (see entry below).

	* src/generic/apt.cc:

	  Whenever the cache is reloaded (with package states from the
	  global file), immediately try to write back changes to package
	  states (ie, dselect states).

	* src/generic/aptcache.cc:

	  Finally fix the notorious "aptitude removes stuff you installed
	  with other package managers" bug.  Maybe.  The problem is: when
	  dselect information was being read, aptitude would note changes
	  to the dselect state and record them...but it *would not flag
	  the cache as being dirty*.  As a result, when the user applied
	  the naive process to remove some files from the system:

	  (a) Mark the files for removal
	  (b) Execute the removal
	  (c) Quit aptitude

	  aptitude would quit thinking that dpkg still wanted to install
	  the files in question.  As a result, the next time aptitude
	  started, it would notice that the dselect state disagreed with
	  its own selection state -- but would then notice that the "old"
	  dselect state also called for the packages to be installed, and
	  assume that nothing changed.

	  The fix -- dirtying the cache -- isn't perfect: if the user ^Cs
	  aptitude after installing software but before aptitude saves the
	  new cache state, the bug will reappear.  However, at least the
	  common case works now.

	* src/ui.cc:

	  Make the About box fragment-based, and make its copyright notice
	  reflect the last 5 years.

	* src/ui.cc, src/pkg_item.cc, src/pkg_tree.cc, src/pkg_view.cc:

	  Lots of stuff to handle slot type conversions in appropriate
	  ways for sigc++ 2.0.  The program compiles and seems to work now.

	* src/vscreen/vs_menu.cc:

	  Apparently in sigc++ 2.0, you can cast a slot<bool> directly to
	  a slot<void> and vice versa (?!?!?!), so overloading a function
	  with both and hiding the slot<bool>'s return value is
	  unnecessary and leads to compiler errors.

	* src/vscreen/slotarg.h:

	  Use a conversion operator instead of a constructor to convert
	  between slotarg types.

	* src/pkg_item.cc:

	  Convert a use of slotarg.

	* src/edit_pkg_hier.cc:

	  Add missing include for bind.

	* src/download_list.cc:

	  Convert uses of slotarg, add dereferences.

	* src/vscreen/slotarg.h:

	  Also allow non-const dereferencing of slotarg.

2005-01-09  Daniel Burrows  <dburrows@debian.org>

	* src/mine/cmine.cc:

	  Really convert all explicit uses of Slot*Arg*.

	* src/download_bar.cc, src/download_list.cc, src/ui.cc, src/download_list.h, src/download.cc, src/ui.h, src/download_screen.cc:

	  Correct all explicit uses of Slot*Arg* to the new API.

	* src/vscreen/slotarg.h, src/vscreen/vs_util.h, src/vscreen/vs_menu.h, src/vscreen/testvscreen.cc, src/vscreen/vs_util.cc:

	  Overhaul the SlotArg system to (a) make the names fit in better
	  (no more StudlyCaps), and (b) make it easier to explicitly
	  create a slotarg (a simple overloaded "arg" routine does it)

	* src/download_list.cc, src/download_screen.cc:

	  More of the same.

	* src/download.cc, src/download_bar.cc:

	  Make some SlotArg instantiations explicit; fix a #include
	  directive for ptr_fun.

	* src/mine/cmine.cc:

	  Make two SlotArg instantiations explicit; fix an incorrect
	  argument order bug in a bind invocation.

	* src/apt_options.cc, src/cmdline/cmdline_progress.cc, src/pkg_view.cc, src/ui.cc:

	  Stop using sigc::ref here too.  Apparently it works on
	  references, not pointers, and changing the whole program to
	  references would be ridiculous.  When this causes a problem,
	  I'll worry about it.

	* src/vscreen/testvscreen.cc, src/vscreen/vs_bin.cc, src/vscreen/vs_menubar.cc, src/vscreen/vs_multiplex.cc, src/vscreen/vs_radiogroup.cc, src/vscreen/vs_stacked.cc, src/vscreen/vs_table.cc, src/vscreen/vs_util.cc:

	  Stop using sigc::ref, it causes weird problems that I don't
	  understand.  testvscreen compiles and starts now! (haven't
	  fully checked it out yet)

	* src/vscreen/testvscreen.cc:

	  Apparently Slot0Args have to be explicitly instantiated now :(.

	* src/vscreen/vs_tree.cc:

	  Correct a #include of ptr_fun.h.

	* src/vscreen/vs_util.cc:

	  Update to the explicit-dereference slotarg API.

	* src/vscreen/vs_size_box.cc:

	  Correct a #include of mem_fun.h.

	* src/vscreen/vs_radiogroup.h:

	  Add a missing #include of sigc++/connection.h.

	* src/vscreen/slotarg, src/vscreen/vs_menu.cc:

	  Require explicit dereferencing of slot-arguments, and convert
	  vs_menuto use it.

	* src/vscreen/vs_size_box.cc:

	  Correct the include of mem_fun.h

	* src/vscreen/vs_menu.cc:

	  #include retype_return.h, not hide.h, for the hide_return
	  adaptor.

	* aptcache.cc:

	  Explicitly type NULLs that are being bound so that the bind
	  adaptors is instantiated with the correct types.	  

	* src/generic/aptcache.cc, src/vscreen/vs_bin.h, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_stacked.h, src/vscreen/vs_table.h:

	  #include sigc++/connection.h to use sigc::connection.

	* src/vscren/bool_accumulate.h:

	  Use structs, not classes.

	* src/ui.cc, src/ui.h, src/vscreen/bool_marshal.h, src/vscreen/bool_accumulate.h, src/vscreen/vs_menu.h, src/vscreen/Makefile.am:

	  Move from the old Marshal API to the new accumulator API.

	* src/generic/config_signal.cc:

	  Correct #include of <sigc++/functors/mem_fun.h>

	* src/generic/aptcache.cc:

	  Add missing #include <sigc++/adaptors/bind.h>

	* src/generic/acqprogress.cc, src/generic/acqprogress.h:

	  Give acqtextstatus an explicit virtual destructor.

	* src/menu_redirect.h, src/generic/aptcache.cc, src/edit_pkg_hier.h, src/download_screen.cc, src/vscreen/vs_bin.h, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_radiogroup.h, src/vscreen/vs_stacked.cc, src/vscreen/vs_stacked.h, src/vscreen/vs_table.cc, src/vscreen/vs_table.h, src/vscreen/vs_menu.cc:

	  Remove various references to namespace SigC.

	* src/pkg_tree.cc:

	  Remove an unnecessary #include.

	* src/download_bar.cc, src/apt_options.cc, src/download_list.cc, src/mine/cmine.cc, src/ui.cc, src/main.cc, src/edit_pkg_hier.cc, src/download.cc, src/cmdline/cmdline_util.cc, src/cmdline/cmdline_progress.cc, src/generic/config_signal.h, src/generic/config_signal.cc, src/generic/aptcache.cc, src/pkg_tree.cc, src/view_changelog.cc, src/pkg_view.cc, src/pkg_grouppolicy.cc, src/apt_info_tree.cc, src/vscreen/vs_menubar.cc, src/vscreen/vs_editline.cc, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_togglebutton.h, src/vscreen/vs_center.cc, src/vscreen/vs_text_layout.cc, src/vscreen/vs_size_box.cc, src/vscreen/vs_passthrough.cc, src/vscreen/vs_button.cc, src/vscreen/vs_stacked.cc, src/vscreen/vs_frame.cc, src/vscreen/vs_tree.cc, src/vscreen/vs_multiplex.cc, src/vscreen/vs_table.cc, src/vscreen/testvscreen.cc, src/vscreen/vs_pager.cc, src/vscreen/vs_menu.cc, src/vscreen/vs_transient.cc, src/vscreen/vs_util.cc:

	  Replace calls to SigC::slot with calls to sigc::ptr_fun and
	  calls to sigc::mem_fun, as appropriate.

	* src/apt_options.cc, src/download_list.cc, src/mine/cmine.cc, src/ui.cc, src/edit_pkg_hier.cc, src/cmdline/cmdline_progress.cc, src/generic/config_signal.cc, src/generic/aptcache.cc, src/pkg_item.cc, src/pkg_tree.cc, src/pkg_view.cc, src/apt_info_tree.cc, src/vscreen/vs_menubar.cc, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_bin.cc, src/vscreen/vs_radiogroup.cc, src/vscreen/vs_stacked.cc, src/vscreen/vscreen_widget.cc, src/vscreen/vs_multiplex.cc, src/vscreen/vs_table.cc, src/vscreen/testvscreen.cc, src/vscreen/vs_menu.cc, src/vscreen/vs_util.cc

	  Replace uses of SigC::bind with sigc::bind, and start
	  converting slot creation.

2005-01-08  Daniel Burrows  <dburrows@debian.org>

	* src/download_list.cc, src/ui.cc, src/apt_info_tree.h, src/pkg_tree.h, src/download_manager.h, src/cmdline_parse.h, src/pkg_subtree.h, src/pkg_grouppolicy.h, src/pkg_item_with_subtree.h, src/generic/config_signal.h, src/generic/aptcache.h, src/generic/apt.h, src/generic/config_signal.cc, src/generic/aptcache.cc, src/generic/apt.cc, src/pkg_item.cc, src/pkg_item.h, src/ui.h, src/edit_pkg_hier.h, src/cmdline_parse.cc, src/pkg_grouppolicy.cc, src/vscreen/vscreen.cc, src/vscreen/vs_pager.h, src/vscreen/slotarg.h, src/vscreen/vs_togglebutton.h, src/vscreen/vscreen_widget.h, src/vscreen/vs_button.h, src/vscreen/vs_radiogroup.h, src/vscreen/vs_util.h, src/vscreen/vs_editline.h, src/vscreen/vscreen.h, src/vscreen/vscreen_widget.cc, src/vscreen/vs_statuschoice.h, src/vscreen/vs_menu.h, src/vscreen/vs_text_layout.h, src/vscreen/vs_scrollbar.h, src/vscreen/vs_menu.cc, src/vscreen/vs_util.cc:

	  Use sigc::signal* and sigc::slot* instead of SigC::Signal* and
	  SigC::Slot*.

	* src/apt_options.cc, src/cmdline_parse.h, src/edit_pkg_hier.cc, src/generic/acqprogress.h, src/generic/aptcache.h, src/generic/config_signal.h, src/menu_redirect.h, src/pkg_grouppolicy.cc, src/vscreen/vscreen_widget.h, src/vscreen/vs_radiogroup.h:

	  Use sigc::trackable instead of SigC::Object.

	* configure.ac:

	  Use sigc++-2.0, not sigc++-1.2.  This breaks EVERYTHING.

	* src/ui.cc:

	  Since fragments are now used to render messages, remove the
	  newlines.

	* src/ui.cc:

	  Work around what appears to be a compiler bug: if
	  my_cleaner::my_cleaner is implemented inline, it never gets
	  executed, but if I implement it outside the class definition, it
	  works fine.  (this makes the count of how much stuff was
	  autocleaned reliable again, hopefully)

	* src/ui.cc, src/ui.h:

	  Make show_message deal in fragments.

	* src/vscreen/vs_transient.cc:

	  Implement the vs_transient constructor.

	* src/vscreen/Makefile.am, src/vscreen/vs_transient.cc, src/vscreen/vs_transient.h:

	  Add a "transient" widget that wraps a real widget but disappears
	  at the press of a button.  This generalizes and obsoletes
	  vs_transientlabel.

	* src/cmdline/cmdline_clean.cc, src/ui.cc:

	  After cleaning obsolete files, display (approximately) how much
	  disk space was freed.

	* doc/en/manpage.xml:

	  Display segmented lists more clearly, clarify a few points in
	  the manpage, and remove a gripe that may be obsolete (not sure).

2004-12-22  Daniel Burrows  <dburrows@debian.org>

	* src/download_list.cc:

	  Fix some silly typos in the code that decides whether to show a
	  summary, so that it works as advertised.

	  When constructing the summary message, newlines go at the front
	  of the second chunk of text, not at the end of the first (avoids
	  unnecessary dialog expansion).

	  Mark the download as "failed" only when an error message would
	  be shown.

	* src/apt_config_widgets.cc, src/apt_config_widgets.h, src/apt_options.cc:

	  Add support for multiple-choice options (using radio buttons),
	  and use this support to fix the display of the "pause after
	  download" option.

	* src/vscreen/vs_radiogroup.cc, src/vscreen/vs_radiogroup.h:

	  Enhance the vs_radiogroup API so that I can use it in the main
	  program.

	* src/download_list.cc:

	  Use a fragment to display the success/failure dialog, and add a
	  comment indicating that some files couldn't be downloaded if an
	  item failed to be downloaded.

	* src/download_list.cc, src/download_list.h:

	  Make the pause-after-download option tristate; by default,
	  aptitude will now pause only if some part of the download
	  failed.

	* NEWS, configure.ac, doc/en/aptitude.xml:

	  Bump version to 0.3.0.  Obsolete documentation has not been
	  bumped, to indicate that it still documents the old version of
	  the program.

	* doc/en/aptitude.xml, doc/en/images/trust-snapshot.png:

	  Proofread, complete the security section.

2004-12-21  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_util.cc:

	  Destroy widgets before executing the commands in a slot, so they
	  aren't visible if a sub-main-loop is spawned.  (maybe it would
	  be better to just hide them to avoid the possibility of some
	  nasty memory bug?)

	* src/ui.cc:

	  Use more sensible labels for the "really screw your computer?"
	  prompt.

	* src/vscreen/vs_util.cc:

	  Make yes/no buttons X-shrinkable to avoid the table layout bug.

2004-12-06  Daniel Burrows  <dburrows@debian.org>

	* src/ui.cc:

	  Don't install/remove packages until the user answers the
	  "untrusted packages" warning.

	* src/pkg_view.cc:

	  Avoid crashing in pkg_description_widget: apparently ver.end()
	  crashes if pkg.end() is true, so check pkg.end() first.

	* src/vscreen/vs_util.cc:

	  Remove some (theoretically) unnecessary centering widgets.  The
	  correct button now receives focus when the dialog is created.

	* src/ui.cc:

	  Print a nasty warning if trust violations occur.

	* src/vscreen/fragment.cc:

	  Be more specific when generating errors about format codes.

	* src/vscreen/vs_frame.cc:

	  Make sure, when generating a height_request, to give the correct
	  width to the subwidget (subtract the width of our border).

	* src/vscreen/vs_table.cc:

	  Instrument the table code for debugging.

	* src/vscreen/testvscreen.cc, src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Add support for formatting yesno dialog box messages using
	  fragments.

2005-01-05  Christian Perrier <bubulle@debian.org>

	* Corrected Dutch translation. Closes: #288815

2004-12-05  Daniel Burrows  <dburrows@debian.org>

	* configure.ac, doc/fr/Makefile.am:

	  List doc/fr/Makefile and doc/fr/images/Makefile, and fix
	  doc/fr/Makefile.am so that builds no longer fail.

	* src/vscreen/vs_table.h:

	  Make widgets shrinkable by default.

	* src/vscreen/vs_util.cc:

	  Set the background of the layout widget and scrollbar when
	  creating a stock Ok dialog, and make sure that the main widget
	  is shrinkable (so the Ok button doesn't disappear).

	* src/pkg_view.cc:

	  Always ignore the vertical size of every main widget and package
	  description, to get about the same behavior as previous
	  versions.

	* src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	  Create another table flag that causes the widget's size request
	  to be ignored and (0,0) assumed.  This is useful (really!) to
	  force a widget to only take up as much space as it can be
	  expanded into.  (think about the aptitude main screen, for
	  instance..)

	* src/vscreen/vs_util.cc:

	  Use add_widget_opts to add the "cancel" button.  Using plain
	  add_widget was causing weird problems where Cancel got shoved to
	  the right of the dialog box.  [merge up to r2801]

	* src/vscreen/vs_table.cc:

	  When expanding columns, check for expandability in the X
	  direction, not the Y direction.

	* src/ui.cc:

	  Remove some old cruft.

	* src/pkg_view.cc, src/ui.cc:

	  Make all the widgets in the main view that are expandable also
	  shrinkable (arguably this is a bug in the table layout, but I
	  can work around it like this for now).  Now the scrollbars won't
	  randomly disappear...

	* src/pkg_view.cc:

	  Use more explicit table options for scrollbars.

	* src/vscreen/vs_util.cc:

	  Make sure that scrollbars in stock Ok dialogs expand vertically
	  but not horizontally.

	* src/ui.cc:

	  Use the new fragf to make apt_error_fragment() much more
	  legible.

	* src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/testvscreen.cc:

	  Add %A and %C escapes to fragf that directly set the attributes
	  of following text.  %A sets the attributes directly using the
	  next argument; %C takes the next argument to be a color name,
	  looks it up, and sets the attributes to the color that it finds.

	* src/ui.cc:

	  Make sure the apt error has the correct color.

	* src/download_list.cc, src/download_list.h:

	  Split download_list::size_request.

	* src/vs_progress.cc, src/vs_progress.h:

	  Split vs_progress::size_request.

	* src/mine/cmine.cc, src/mine/cmine.h:

	  Split cmine::size_request.

	* src/ui.cc:

	  Fix several compile errors.  In particular, use the
	  new vs_dialog_ok instead of apt_error_pager.

	* src/vscreen/vs_util.cc, src/vscreen_vs_util.h:

	  Add a parameter to vs_dialog_ok on fragments that causes a
	  scrollbar to be added.

	* src/vscreen/vs_util.cc, src/vscreen_vs_util.h:

	  Use labels by default to render OK dialog boxes based on text,
	  and add a variant of vs_dialog_ok that lets you pass in the main
	  widget of the dialog box.

	* src/vscreen/vs_table.cc:

	  Fix a stupid thinko that was causing table layout to be
	  seriously screwed up.

	* src/vscreen/vs_util.cc:

	  Word-wrap Ok dialog boxes, and make sure that the correct
	  background attributes are used for the layout widget.

	* src/vscreen/vs_table.cc:
	
	  Initialize num_rows and num_cols to 0 when the table is
	  constructed.

	* src/vscreen/fragment.cc, src/vscreen/vs_center.cc, src/vscreen/vs_label.cc, src/vscreen/vs_menubar.cc, src/vscreen/vs_menubar.h, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_size_box.cc, src/vscreen/vs_text_layout.cc:

	  Fix various other typos that prevented the vscreen layer from
	  compiling.

	* src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	  Fix a whole bunch of typos and compile errors.

	* src/vscreen/vs_tree.cc:

	  Split vs_tree::size_request.

	* src/vscreen/vs_table.cc, src/vscreen/vs_table.h:

	  Massively refactor the table layout algorithm.  It's now split
	  into about half a dozen shorter functions that are actually
	  almost readable.  Oh, and it supports two-shot layout.

2004-12-04  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_statuschoice.cc, src/vscreen/vs_statuschoice.h:

	  Convert the statuschoice widget to the new algorithm.

	* src/vscreen/vs_menubar.cc, src/vscreen/vs_minibuf_win.cc, src/vscreen/vs_minibuf_win.h, src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h, src/vscreen/vs_scrollbar.cc, src/vscreen/vs_scrollbar.h, src/vscreen/vs_size_box.cc, src/vscreen/vs_size_box.h, src/vscreen/vs_stacked.cc, src/vscreen/vs_stacked.h:

	  More widgets converted to the two-shot algorithm.


	* src/vscreen/fragment.cc, src/vscreen/fragment.h, src/vscreen/vs_frame.cc, src/vscreen/vs_frame.h, src/vscreen/vs_label.cc, src/vscreen/vs_label.h, src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h, src/vscreen/vs_text_layout.cc, src/vscreen/vs_text_layout.h:

	  More widgets converted to the new layout mechanism.

	* src/vscreen/vscreen_widget.h:

	  Clarify the assumptions that a widget can make about layout.

	* src/vscreen/vs_button.cc, src/vscreen/vs_button.h, src/vscreen/vs_center.cc, src/vscreen/vs_center.h, src/vscreen/vs_editline.h, src/vscreen/vs_editline.cc, src/vscreen/vs_multiplex.cc, src/vscreen/vs_multiplex.h:

	  Rewrite the layout mechanisms for a bunch of widgets to work
	  with the two-shot algorithm.

	* src/vscreen/vscreen_widget.h:

	  Make the changes to vscreen_widget that are necessary to
	  implement two-stage layout.  This breaks everything (fun!).

	* src/vscreen/vs_util.cc, src/vscreen/vs_util.h:

	  Overhaul the ok dialog to use text_layouts.

	* src/ui.cc:

	  Write a routine to check the trust state of packages and warn as
	  appropriate (unfinished).

	* src/generic/apt.cc:

	  It appears that packages with NULL index files are exactly those
	  which are already installed, so they should be trusted.  Now
	  aptitude doesn't mark every package on the system as
	  "untrusted"...

2004-12-03  Daniel Burrows  <dburrows@debian.org>

	* src/Makefile.am, src/desc_parse.cc, src/desc_parse.h, src/pkg_info_screen.cc, src/pkg_view.cc, src/trust.cc, src/trust.h:

	  Display the same big fat warning in the extended description
	  area of untrusted packages.  (yes, aptitude is now officially
	  paranoid)

	* doc/en/aptitude.xml:

	  Document the untrusted flag and write a brief section on apt's
	  trust model (may not quite be accurate; needs to be edited again
	  before release).

	* src/defaults.cc, src/pkg_info_screen.cc:

	  Add a very strongly worded warning message that is included in
	  the information screen for an untrusted package.

	* src/generic/apt.cc, src/pkg_columnizer.cc, src/pkg_columnizer.h, src/pkg_ver_item.cc:

	  Create an extra column, visible by default, that flags untrusted
	  packages.

	* po/pt_BR.po:

	  Automagic changes, don't look at me.

	* src/generic/apt.h, src/generic/matchers.cc, src/generic/tasks.cc, src/pkg_columnizer.cc, src/pkg_info_screen.cc, src/pkg_ver_item.cc, src/pkg_view.cc:
	  Remove some totally unnecessary #includes in apt.h.

	* src/generic/apt.h, src/generic/apt.cc:

	  Add a "package_trusted" function that checks a package version's
	  trust state.  In order to support this non-wastefully, a global
	  source-list variable is now available, updated whenever the
	  package lists are re-read.

	* src/download_item.cc:

	  Port to apt 0.6 by handling AuthError in addition to Error
	  status.

	* configure.ac:

	  Remove "he" from ALL_LINGUAS and add "sk" and "tr" so that
	  configure works again.

2004-12-01  Dennis Stampfer <seppy@debian.org>

	* Corrected German translation de.po. Closes: #283546

2004-11-16  Christian Perrier <bubulle@debian.org>

	* Added Romanian translation. Closes: #281531

2004-11-08  Christian Perrier <bubulle@debian.org>

	* Update Slovak translation. Really Closes: #279559

2004-11-07  Christian Perrier <bubulle@debian.org>

	* Added Turkish translation. Closes: #280009
	* Update Lithuanian translation. Closes: #280049

2004-11-05  Christian Perrier <bubulle@debian.org>

	* Updated Arabic translation from Arabeyes CVS
	* Added Slovak translation. Closes: #279559

2004-10-12  Christian Perrier <bubulle@debian.org>

	* Added french translation of the documentation
	  Sent directly my Olivier Trichet

2004-10-11  Christian Perrier <bubulle@debian.org>

	* Update Simplified Chinese translation
	* Update Finnish translation

2004-10-10  Christian Perrier <bubulle@debian.org>

	* Update Norwegian Bokmal translation.

2004-10-09  Christian Perrier <bubulle@debian.org>

	* Update Polish translation. Closes: #265481
	* Update Spanish translation.
	* Update Basque translation. Closes: #275704

2004-10-07  Christian Perrier <bubulle@debian.org>

	* Added preliminary Arabic translation from Arabeyes
	* Added preliminary Hebrew translation. Closes: #275266

2004-10-06  Dennis Stampfer <seppy@debian.org>

	* Update Brazilian Portuguese translation by Goedson Teixeira Paixao
	  Closes: #275220

2004-10-05  Christian Perrier <bubulle@debian.org>

	* Minor update to French translation (Y/N keys)
	  Closes: #274953

2004-10-03  Christian Perrier <bubulle@debian.org>

	* Update Danish translation

2004-10-02  Christian Perrier <bubulle@debian.org>

	* Update Czech translation and manual

2004-09-29  Christian Perrier <bubulle@debian.org>

	* Update Traditional Chinese translation and help file
	  Closes: #274268

2004-09-28  Daniel Burrows  <dburrows@debian.org>
	* NEWS, configure.ac, doc/cs/aptitude.xml, doc/de/aptitude.xml, doc/en/aptitude.xml, doc/fi/aptitude.xml:
	  Bump version to 0.2.15.8.

	* src/mine/board.cc, src/mine/board.h, src/mine/cmine.cc, src/mine/mine-help.txt:
	  Apply some trivial fixes (avoiding uninitialized values,
	  sanity-checks) to minesweeper.  (Closes: #179533)

2004-09-27  Christian Perrier <bubulle@debian.org>

	* Update Russian translation after IRC talk with Nikolai

2004-09-26  Daniel Burrows  <dburrows@debian.org>

	* src/main.cc:
	  Patch from Konstantinos Margaritis to revert the locale to C
	  if UTF-8 is detected.

2004-09-26  Christian Perrier <bubulle@debian.org>

	* Re-update Japanese translation. Closes: #272454
	* Fixes to French translation. Closes: #272824

2004-09-25  Daniel Burrows  <dburrows@debian.org>

	* src/generic/apt.cc:
	  Only include suggested packages in the "packages suggested by
	  other packages" tree.  (Closes: #270667)

2004-09-20  Christian Perrier <bubulle@debian.org>

	* Update Japanese translation. Closes: #272454

2004-09-18  Christian Perrier <bubulle@debian.org>

	* Update Italian translation. Closes: #265243

2004-09-17  Daniel Burrows  <dburrows@debian.org>

	* doc/fi/Makefile.am:
	  Add fixmans to EXTRA_DIST.

	* NEWS, configure.ac, doc/cs/aptitude.xml, doc/en/aptitude.xml:
	  Bump version to 0.2.15.7.

	* doc/en/aptitude.xml:
	  Add a credit for the Norwegian translation.

	* doc/en/manpage.xml:
	  Be a little clearer about what --visual-preview does.
	  (Closes: #269100)

	* doc/en/aptitude.xml:
	  Add an example to ~A documentation.

	* doc/en/manpage.xml:
	  Eh, mention where the package cache is by default.  (Closes: #269102)

	* NEWS:
	  Write years with 4 digits.

	* Update French manpage.  Closes: #270713.

2004-09-13  Christian Perrier <bubulle@debian.org>

	* Update Brazilian portuguese translation. Closes: #271411

2004-09-11  Christian Perrier <bubulle@debian.org>

	* Update all translations according to latest aptitude.pot
	* (few hours later) Revert aptitude.pot to r2712
	  and update PO files accordingly

2004-09-10  Christian Perrier <bubulle@debian.org>

	* po/fi.po and help-fi.txt updated. Closes: #263313
	* po/ca.po updated. Closes: #270917

2004-09-05  Daniel Burrows  <dburrows@debian.org>

	* src/pkg_columnizer.cc:
	  Fix crash when viewing virtual packages while using the
	  reverse-depends-count. (Closes: #270057)

	* src/vscreen/vs_table.cc:
	  Fix several places where "focus" was dereferenced without
	  checking whether it was valid.

2004-09-04  Christian Perrier <bubulle@debian.org>

	* Finnish updates:
	  - PO files completed
          - build the doc file in XML
	  - Finnish doc files
	  Closes: #263313
	
2004-09-04  Daniel Burrows  <dburrows@debian.org>

	* po/nn.po:
	  Updated Norwegian translation from
	  HĺśĄrd Korsvoll <korsvoll@skulelinux.no> (Closes: #269976).

2004-08-31  Daniel Burrows  <dburrows@debian.org>

	* po/es.po:
	  Fix Spanish l10n of yes/no shortcuts (Closes: #269311).

2004-08-27  Christian Perrier <bubulle@debian.org>

	* Update all translation according to aptitude.pot
	* Italian translation updated. Closes: #268263

2004-08-17  Christian Perrier <bubulle@debian.org>

	* Update Russian translation. Closes: #266294
	* Update Dutch translation

2004-08-15  Christian Perrier <bubulle@debian.org>

	* Update French translation.
	* Update Czech translation (seems that Dennis commit was wrong)

2004-08-11  Daniel Burrows  <dburrows@debian.org>

	* po/el.po:
	  Update Greek translation (Closes: #265006).

2004-08-10  Daniel Burrows  <dburrows@debian.org>

	* po/ja.po:
	  Update Japanese translation (Closes: #264867).

	* src/generic/matchers.cc, doc/en/aptitude.xml:
	  Do priority matching by priority type (based on the input string)
	  rather than by string.  This will make searches by priority
	  somewhat faster, as well as making them reliable regardless of
	  locale.

2004-08-09  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_action.cc (cmdline_applyaction):
	  Adjust which version is used to check for matches against patterns
	  on the command line: for "install", "hold", and "forbid-version"
	  actions, the candidate version is used; for "remove" and "purge"
	  actions, the current version is used; for other actions, the
	  install version is used.  This fix is needed for debian-boot in
	  sarge.

2004-08-06  Daniel Burrows  <dburrows@debian.org>

	* doc/cs/Makefile.am, doc/de/Makefile.am:
	  Argh, really fix installation of XML manpages.

	* NEWS, configure.ac, doc/cs/aptitude.xml, doc/en/aptitude.xml:
	  Bump version to 0.2.15.6.

	* doc/en/aptitude.xml:
	  Add some more language credits.

	* help-fi.txt, po/fi.po:
	  Update Finnish translation.  (Debian bug #263313)

	* doc/Makefile.am:
	  Alphabetize.

	* doc/cs/Makefile.am, doc/de/Makefile.am:
	  Really fix the installation of manpages (tested this time!).

	* Makefile.am, aptitude.de.8:
	  The German manpage doesn't belong here any more.  Remove it.

	* Makefile.am:
	  Make sure to actually install the non-XMLified manpages.

	* doc/cs/Makefile.am, doc/de/Makefile.am:
	  Adjust how manpages are built and installed: the makefiles for
	  localized manpages are more consistent now and actually install
	  the manpages.

	* configure.ac, doc/Makefile.am, doc/de/Makefile.am, doc/de/aptitude.xml, doc/de/manpage.xml, doc/de/fixquote, help-de.txt:
	  Apply the rest of the German translation from #262534.

2004-08-05  Daniel Burrows  <dburrows@debian.org>

	* src/pkg_ver_item.cc:
	  Unreverse the logic for displaying the size change due to a
	  particular version.

2004-08-01  Dennis Stampfer <seppy@debian.org>

	* Update German translation from Debian-Bug #262534
	  (This does *not* close #262534)
	* Update Czech translation by Miroslav Kure.
	  Closes Debian-Bug #262524
	* Update Danish translation by Morten Bo Johansen
	  Closes Debian-Bug #262129

2004-07-29  Dennis Stampfer <seppy@debian.org>

	* Update Dutch translation by Luk Claes
	  (Closes Debian Bug #262000)

2004-07-28  Dennis Stampfer <seppy@debian.org>

	* Update Italian program translation by Danilo Piazzalunga
	  (Closes Debian Bug #261819)

2004-07-24  Christian Perrier <bubulle@debian.org>

	* Update Portuguese translation.
	  (Closes Debian Bug #261502)

2004-07-25  Daniel Burrows  <dburrows@debian.org>

	* doc/en/aptitude.xml, src/ui.cc:
	  Added an option to disable the "nothing to be done" warning
	  when there are upgradable packages. (Debian bug #260590)

	* do/aptitude.xml, po/pt.po:
	  Updated Porugtuese translation. (Debian bug #261425)

	* doc/en/aptitude.xml, src/pkg_columnizer.cc, src/pkg_columnizer.h, src/pkg_ver_item.cc, src/vscreen/vscreen.cc:
	  Add a format code for policy information (Debian bug #240423).

2004-07-24  Dennis Stampfer <seppy@debian.org>

	* Update Brazilian translation.
	  (Closes Debian Bug #260953)

2004-07-24  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vscreen.cc:
	  Use portable pthreads code. (Debian bug #260259)

	* src/generic/apt.cc:
	  Check the whole surrounding dependency when looking at recommends
	  and suggests.

2004-07-21  Christian Perrier <bubulle@debian.org>

	* Update Dutch translation. Antwerp dialect joke removed
	  (Debian bug #260632)
	* Update Brazilian translation. 
	  (Debian bug #260953)
	* Update Italian translation. 
	  (Debian bug #261017)
	* Update Greek translation. 
	  (Debian bug #261029)
	* Update Catalan translation. 
	  (Debian bug #261095)
	* Update German translation. 

2004-07-21  Daniel Burrows  <dburrows@debian.org>

	* src/vscreen/vs_pager.cc:
	  Scroll by the screen height, not the screen width.  Thanks to
	  Neil Moore.  (Debian bug #260713)

2004-07-21  Christian Perrier <bubulle@debian.org>

	* Rebuild aptitude.pot      yet another time
	* Update French translation  "     "      "
	* Update Spanish translation  "     "      "

2004-07-20  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc:
	  Make it possible to undo a "forget new" command again.

	* src/cmdline/cmdline_changelog.cc, src/view_changelog.cc, po/:
	  Detect attempts at viewing changelogs for packages that trivially
	  have no changelogs available, and warn the user instead of blindly
	  trying to fetch the changelog.  (Debian bug #260477)

	* src/download.cc, doc/en/aptitude.xml: 
	  Support multiple log destinations. (Debian bug #259714)

2004-07-20  Christian Perrier <bubulle@debian.org>

	* Updated German translation

2004-07-19  Daniel Burrows  <dburrows@debian.org>

	* src/pkg_tree.cc:
	  Treat an empty limit string as "no limit". (Debian bug #260244)

2004-07-19  Christian Perrier <bubulle@debian.org>

	* Updated French translation
	* Updated Spanish translation

2004-07-18  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_moo.cc:
	  Don't insult the user.

2004-07-17  Daniel Burrows  <dburrows@debian.org>

	* doc/cs/aptitude.xml, doc/cs/images/*, help-cs.txt, po/cs.po:
	  Updated Czech translation from Miroslav Kure. (Debian bug #259966)

2004-07-15  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline/cmdline_download.cc:
	  Make the error message when a package is not downloadable a little
	  clearer.

	* src/cmdline/cmdline_changelog.cc, src/cmdline/cmdline_changelog.h, src/cmdline/cmdline_prompt.cc:
	  Support viewing changelogs from the command-line prompt.

	* src/generic/matches.cc, doc/en/aptitude.xml:
	  Enhance the "provides" matcher to support full subterms;
	  extend ~D to support any dependency class; change ~R to
	  implicitly check predepends with depends; close some memory
	  leaks; document the user-visible changes.

	* help.txt, src/defaults.cc, src/pkg_tree.cc, src/ui.cc, doc/en/aptitude.xml:
	  Bind the new command to 'b', document it, and fix some incorrect
	  entity references in the documentation.

	* src/menu_redirect.h, src/pkg_tree.cc, src/pkg_tree.h, src/pkg_view.cc, src/ui.cc, src/ui.h:
	  Add a very visible command to search for '~b' (the next broken
	  package).  (Debian bug #162474)

	* src/cmdline.cc:
	  Mention that a package is 'new' in "aptitude show"; don't show
	  information about whether it is automatically installed unless
	  it's installed.

	* doc/en/aptitude.xml:
	  Document the new menu commands.

	* src/vscreen/vs_menu.cc:
	  Don't disable bold after printing an explicitly bold character in
	  a menu label, in case the underlying color is also bolded.

	* src/menu_redirect.h, src/pkg_tree.cc, src/pkg_tree.h, src/pkg_view.cc, src/ui.cc, src/ui.h, src/vscreen/vs_menu.cc, src/vscreen/vs_menu.h:
	  Use bool as the return value for menu item signals, and use
	  OrMarshal to marshal them.  This means that a menu item's
	  emission will, presuming all goes well, stop as soon as
	  something handles it.  This avoids the infinite recursive
	  add_main_widget death that was occuring after the last commit.

2004-07-14  Daniel Burrows  <dburrows@debian.org>

	* src/menu_redirect.h, src/pkg_item.cc, src/pkg_item.h, src/pkg_tree.cc, src/pkg_tree.h, src/pkg_ver_item.cc, src/pkg_ver_item.h, src/pkg_view.cc, src/ui.cc, src/ui.h:
	  Add items to the package menu to examine some package information.
	  Currently buggy, will be fixed.


	* src/menu_redirect.h, src/pkg_node.h, src/pkg_tree.cc, src/pkg_view.cc, src/ui.cc, src/ui.h:
	  Add items to the package menu to adjust a package's state.

	* src/cmdline/cmdline_show.cc:
	  Fix upgrade/downgrade confusion.

	* src/main.cc:
	  Add a 'usage' string for -o.

	* doc/en/manpage.xml, src/cmdline/cmdline_download.cc:
	  Allow the user to select which version of a package should be
	  downloaded; print an error message if the package can't be
	  downloaded.

	  (Debian bug #160145)

	* doc/en/manpage.xml, src/main.cc, src/cmdline/Makefile.am, src/cmdline/cmdline_changelog.cc, src/cmdline/cmdline_changelog.h:
	  Add support for downloading changelogs from the command-line.

	* src/cmdline/cmdline_util.cc:
	  Fix the common function to initialize all its out parameters and
	  to not fall off the end of the function.

	* src/cmdline/cmdline_util.cc:
	  Complain loudly in cmdline_find_ver if there's no candidate
	  version available.  (Closes: #213106)

	* src/cmdline/cmdline_progress.cc:
	  Delete the progress bar when we're done with it.

	* src/cmdline/cmdline_action.cc, src/cmdline/cmdline_action.h, src/cmdline/cmdline_util.cc, src/cmdline/cmdline_util.h:
	  Split the source/archive parsing code into a small common function;
	  modified applyaction and find_ver to adjust for the new interface.

	* po/POTFILES.in:
	  Update POTFILES.in.

	* src/cmdline/cmdline_show.cc:
	  Display information about the package's aptitude state.

	* src/generic/apt.cc:
	  When testing if a package is suggested/recommeded, only
	  return true if the suggestion/recommendation is unfulfilled.

	* src/generic/aptcache.cc, doc/en/aptitude.xml:
	  Reinstate Suggests-Important for the purpose of finding unused
	  packages, so people don't get rudely surprised by the new behavior.
	  (Debian bug #259387)

2004-07-13  Daniel Burrows  <dburrows@debian.org>

	* configure.ac, src/Makefile.am, src/cmdline.h, src/cmdline.cc, src/download.cc, src/main.cc, src/cmdline/*:
	  Finally bite the bullet and split cmdline.cc into a gajillion
	  tractably-sized modules.

	* src/generic/infer_reason.cc:
	  Filter out all Conflicts in which the only *to-be-installed*
	  package providing the Conflicted name is the package containing
	  the Conflict.

	* src/reason_fragment.cc:
	  Remove the no-longer-necessary display of the size change
	  due to a package.

	* src/cmdline.cc, src/pkg_grouppolicy.cc:
	  Display recommended packages in both the command-line preview
	  and the visual preview.

	* src/generic/apt.cc, src/generic/apt.h:
	  Add a "pkg_recommended" function -- similar to "pkg_suggested",
	  but triggers if the suggester is going to be installed OR upgraded.

	* src/generic/rev_dep_iterator.h:
	  Make it compile *oops*.

	* src/generic/rev_dep_iterator.h:
	  When iterating a package's reverse dependencies, include
	  dependencies through a virtual package.

	* Makefile.am:
	  Add basic support for disabling compilation and/or documentation.

	* src/ui.cc:
	  Fix stupid thinko when handling fallback for translated docs.

	* doc/cs/Makefile.am:
	  Don't build the text version of the Czech manual, as it's
	  currently useless.

	* doc/en/Makefile.am:
	  Force automake, kicking and screaming, to not dump the generated
	  README in the distributed tarball.

	* src/cmdline.cc:
	  Doh, actually make sure it compiles.

	* src/cmdline.cc:
	  Only display annoying "not doing anything because it was already
	  done" messages if verbose>0. (Debian bug #258913)

	* README:
	  automake wants a README; add one that explains how to generate
	  the real README.

	* Makefile.am, README, aptitude.8, aptitude.cs.8:
	  Purge autogenerated files.

	* doc/Makefile.am, doc/cs/Makefile.am, doc/en/Makefile.am:
	  Move the distribution command for the stylesheets to doc/ from
	  doc/{en,cs}.

	* doc/cs/Makefile.am:
	  Build the Czech manual page under the right name (aptitude.cs.8)
	  but don't install it automatically, since automake does the
	  Wrong Thing here.

	* configure.ac, doc/en/aptitude.xml, doc/cs/aptitude.xml, NEWS:
	  Bump version to 0.2.15.3.

	* doc/en/Makefile.am, doc/en/manpage.xml:
	  Fix some formatting issues, fix the dependencies for generating
	  the documentation (all forms should depend on manpage.xml).

	* doc/en/Makefile.am, doc/en/aptitude.xml, doc/en/manpage.xml:
	  Split the English manpage into a separate XML file.
	  (Debian bug #259089)

	* po/fr.po:
	  Correct what I believe is an accidental error in the French
	  translation: "yes" and "no" were being bound to upper-case
	  keys by default.

	* po/cs.po:
	  Localize README in the Czech variant.

	* src/ui.cc:
	  When documentation is translated, fall back to the
	  English-language version if the translated docs are missing.

	* doc/en/Makefile.am, doc/cs/Makefile.am:
	  Install the HTML documentation in localized directories.
	  Install the resulting READMEs under README and README.cs.

	* doc/Makefile.am:
	  Still build the en documentation (it was carelessly removed).

	* configure.ac, doc/Makefile.am, doc/cs/Makefile.am, doc/cs/aptitude.xml, doc/cs/images:
	  Add Miroslav's Czech translation to the source tree.

	* doc/aptitude-txt.style, doc/en/Makefile.am, doc/en/aptitude-txt.style:
	  Move the text stylesheet to the common directory.

	* doc/en/Makefile.am:
	  Fix the "clean" rule.

	* doc/en/Makefile.am, doc/en/, doc/:
	  Move the XSL and CSS stylesheets from doc/en/ to doc/.

	* doc/en/*, doc/*, configure.ac:
	  Add the beginnings of support for localization of the full
	  manual.

	* po/cs.po:
	  Translation updates from Miroslav Kure.

	* doc/aptitude.xml:
	  Fixes from Miroslav Kure.

	* README.i18n:
	  Describe how key translations work.

2004-07-12  Daniel Burrows  <dburrows@debian.org>

	* src/reason_fragment.cc:
	  Further adjust the display of brokenness reasons for
	  self-conflicts: only really pointless self-conflicts (where
	  the only thing providing the conflicted name is the package
	  itself) are dropped; when displaying provided packages,
	  the package which is the source of the dependency is excluded
	  from the list of packages providing the target.

	* src/ui.cc:
	  Really make the menubar properly hide on startup.

	* src/generic/aptcache.cc:

	  Make the automatic package tracking smarter about versions: if
	  upgrading a package causes it to become unused, it will be held
	  (eg, upgrading foo-data without foo); if a package will be
	  removed because it is unused, it will be restored to the
	  candidate version or the current version (whichever satisfies
	  the dep).

	* src/generic/apt_undo_group.cc, src/generic/apt_undo_group.h, src/generic/aptcache.cc, src/generic/Makefile.am, src/pkg_item.cc, src/pkg_node.cc, src/pkg_node.h, src/pkg_tree.cc, src/pkg_ver_item.cc, src/ui.cc:
	  Overhaul how upgrades, garbage collection, and undos are handled.
	  This fixes the problems with undoing an "upgrade" command, and
	  probably several other unreported but obnoxious bugs.

	  The major change is that upgrades are handled as an action group
	  and that mark_and_sweep uses an internal action group (to avoid
	  calling cleanup_after_change too many times).

2004-07-12  Christian Perrier <bubulle@debian.org>

	* Regenerate aptitude.pot and update po files
	* Updated French and Brazilian translations
	* Updated Greek translation. #258805

2004-07-11  Daniel Burrows  <dburrows@debian.org>

	* src/generic/infer_reason.cc:
	  Filter self-conflicts when walking in the forward direction
	  as well.  (Debian bug #258533)

	* src/ui.cc, src/vscreen/vscreen.cc:
	  Make the default for the Yes and No keys the first character
	  of the translation of "yes_key" and "no_key".  This will give
	  more flexibility to translators (the first characters of Yes
	  and No are not always appropriate..)

	* src/ui.cc:
	  Er, make it compile again by fixing the translation tweak (oops).

	* src/tasks.cc:
	  Change the handling of keys so that tasks without keys
	  won't be hidden.

	* src/ui.cc:
	  Make sure that the menu bar is properly hidden on startup if the
	  user requested it (Debian bug #258688).

2004-07-11  Christian Perrier <bubulle@debian.org>

	* Updated Brazilian translation. #258667
	* Updated Greek translation. #258805

2004-07-09  Daniel Burrows  <dburrows@debian.org>

	* src/ui.cc: 
	  Make another yes/no prompt (when minibuf prompting is on)
	  translated.

	* src/vscreen/vscreen.cc, doc/aptitude.xml:
	  Make the Yes and No keybindings translatable, and document their
	  existence.  (Debian bug #258409)

	* src/pkg_item.cc:
	  Make the visible version more stable and useful (now that
	  packages are often not upgraded): return the candidate
	  version if there is one; return the current version if
	  possible; otherwise return the to-be-installed version.

2004-07-07  Christian Perrier <bubulle@debian.org>

	* Regenerate aptitude.pot and update po files
	* Updated French translation

2004-07-08  Daniel Burrows  <dburrows@debian.org>

	* src/dep_item.cc, src/reason_fragment.cc:
	  When displaying reasons, flag unavailable packages.

	* po/es.po:
	  Spanish translation update from Ruben Porras.
	  (Debian bug #258243)

2004-07-07  Daniel Burrows  <dburrows@debian.org>

	* NEWS, configure.ac, doc/aptitude.xml:
	  Bump version to 0.2.15.2.

2004-07-07  Christian Perrier <bubulle@debian.org>

	* Regenerate aptitude.pot and update po files
	* Updated French translation

2004-07-07  Daniel Burrows  <dburrows@debian.org>

	* aptitude-defaults:
	  Hide version numbers in the Vertical-Split theme.

2004-07-06  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc, src/generic/config_signal.cc, src/generic/config_signal.h, src/load_pkgview.cc, src/pkg_tree.cc, src/pkg_tree.h, src/pkg_view.cc, src/pkg_view.h, src/ui.cc:
	  Don't pass the "current value" into configuration signals.  This
	  is somewhat less convenient...but doesn't present false information
	  when a value is unset (ie, it forces the user to supply a correct
	  default value :-/ ).  Actually, more bindings were discarding
	  the current value than using it, so this is only a minor problem.

	  Among other things, this manages to fix reverting some settings,
	  such as menubar-autohide.

	* src/generic/apt.cc, src/generic/config_signal.cc, src/generic/config_signal.h:
	  Make sure that reverting the options returns to the initial
	  options.  Signal emission is still messed up.

	* src/apt_config_widgets.cc, src/apt_config_widgets.h, src/cmdline.cc, src/generic/apt.cc, src/generic/config_signal.cc, src/generic/config_signal.h, src/main.cc:
	  First steps towards a (slightly hacky) separation between user and

	  system configuration.  In an apparently working system, the
	  user's configuration is only saved to ~/.aptitude/config if
	  it was changed at some point from the system default.  Reversion
	  is not handled quite right, but apparently it wasn't handled quite
	  right anyway.  (Debian bug #175409)

	* src/generic/aptcache.cc, src/generic/aptcache.h, doc/aptitude.xml:
	  Apparently some people were using Suggests-Important for its
	  side-effect of keeping automatically installed packages on the
	  system as long as something Suggested them.  The new
	  configuration option Keep-Suggests does just that, without
	  causing Suggested packages to be installed.  Also, the gc
	  code has been slightly optimized by lifting configuration Find
	  commands out of loops.

	* doc/aptitude.xml:
	  Fix the synopsis of forbid-version (it was forbid-upgrade).
	  (Debian bug #257901)

2004-07-04  Christian Perrier  <bubulle@debian.org>

	* Updated Finnish translations. Closes: #257902
	* Updated Italian translations. Closes: #257710

2004-07-04  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  Remove an accidental accent from mine-snapshot5.png.

	* doc/images/Makefile.am:
	  Fix the list of stuff to distribute.

	* NEWS, configure.ac, doc/aptitude.xml:
	  Bump version to 0.2.15.1.

	* doc/images/Makefile.am:
	  Doh, actually distribute the screenshot images!

2004-07-03  Daniel Burrows  <dburrows@debian.org>

	* src/generic/aptcache.cc:
	  Systematically use *this to access *this, not *apt_cache_file.
	One stray case of the latter was left, and that code path seems
	to trigger in unknown circumstances when *apt_cache_file is
	invalid. (Debian bug #257420)

2004-07-01  Daniel Burrows  <dburrows@debian.org>

	* NEWS:
	  More missing Debian bugs.

	* src/main.cc, NEWS:
	  Make -r and -R work.  (Debian bug #243289)

	* NEWS:
	  Add missing notes about Debian bugs. (oops)

	* doc/Makefile.am:
	  Add the documentation to EXTRA_DIST so it gets distributed too
	  (double oops).

	* src/vscreen/Makefile.am:
	  Add bool_marshal.h to SOURCES so it gets distributed (oops).

	* configure.ac:
	  Bumped the version to 0.2.15.

	* doc/aptitude.xml:
	  Add a "see also" section.

	* doc/Makefile.am:
	  Really install the manual page.

	* Makefile.am, aptitude.1, aptitude.cs.1, aptitude.de.1, aptitude.fi.1, aptitude.fr.1, aptitude.gl.1, aptitude.it.1, aptitude.pl.1, aptitude.8, aptitude.cs.8, aptitude.de.8, aptitude.fi.8, aptitude.fr.8, aptitude.gl.8, aptitude.it.8, aptitude.pl.8:
	  Move the manual pages to section 8.

	* src/view_changelog.cc, src/vscreen/testvscreen.cc, src/vscreen/vs_pager.cc, src/vscreen/vs_pager.h, src/vscreen/vs_util.cc:
	  Fix a bug in the pager by completely rewriting it; it no longer
	  tries to be ridiculously efficient, which means the code is
	  much cleaner and less buggy.  (for instance, the mmap is only
	  used when reading a file off the disk; once it's in memory it's
	  stored as a vector of strings)

	* doc/aptitude.xml:
	  Add a missing question to the FAQ.

	* Makefile.am, doc/Makefile.am:
	  Don't install the old README; install the new README and manpage.

	* doc/aptitude.xml:
	  Rip an overused platitude to head up the tutorial.

	* src/generic/matchers.cc:
	  Fix the virtual matcher: previously it matched anything that
	  happened to pass in an "end" version; now it matches only true
	  pure virtual packages.

	* doc/Makefile.am, doc/aptitude-txt.xsl:
	  Use both hooks and crooks to eliminate entities from the
	  generated README.

	* Makefile.am, doc/Makefile.am:
	  Install the README, and make sure installation succeeds even if
	  /var/lib doesn't exist.

	* NEWS:
	  Update for 0.2.15.

	* doc/aptitude.xml:
	  Document --visual-preview.

	* doc/aptitude.xml:
	  Write the beginnings of a Credits chapter -- maybe enough for
	  the time being?

	* doc/aptitude.xml:
	  Correct the documentation of #.

2004-06-30  Daniel Burrows  <dburrows@debian.org>

	* doc/Makefile.am, doc/aptitude.xml, doc/aptitude-man.xsl:
	  Finish up the reference section of the documentation, and
	  generate a manpage from it.

	* src/cmdline.cc:
	  Fix the "show" command.

	* src/pkg_columnizer.cc, src/pkg_columnizer.h, src/pkg_ver_item.cc, doc/aptitude.xml, doc/images/install-snapshot.png, doc/broken-snapshot.png, doc/preview-snapshot.png:
	  Add support for a %Z escape that shows the size change between
	  versions, make it part of the default theme, and update the
	  documentation accordingly.

	* doc/aptitude.xml:
	  Fix the name of a Minesweeper screenshot: s/shapshot/snapshot/.

	* doc/aptitude.xml:
	  Add a quotation for the FAQ.

	* doc/aptitude.xml:
	  Document how to play Minesweeper.

	* doc/Makefile.am:
	  Copy, don't link, the CSS file into place (avoids problems
	  caused by accidentally cloning the link).

	* doc/aptitude.xml:
	  Eliminate dangling references and other errors by fixing element
	  ids, removing references to sections that won't be written before
	  the next release, and changing xrefs to links where appropriate.

	* doc/aptitude.xml:
	  Document the configuration file.

	* src/ui.cc:
	  When the user reverts their options to the defaults, save
	  immediately (so the reversion takes effect next time they
	  run aptitude).

	* src/generic/aptcache.cc:
	  Correct a place where the value of Auto-Install was read instead
	  of the value of Aptitude::Auto-Install.

2004-06-29  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml, doc/images/colors-snapshot.png:
	  Add a slightly eye-watering display of how you can customize
	  aptitude's colors.

	* doc/Makefile.am, doc/aptitude-txt.style, doc/aptitude-txt.xsl, doc/aptitude.xml:
	  Use textobjects as the primary content of screenshots when generating
	  text output, don't indent <PRE> tags in the text output, and
	  wrap at 80 columns in the text output.

	* doc/aptitude.xml:
	  Fix a number of dangling cross-references; s/"/'/g.

	* doc/aptitude.xml, doc/images/dselect-theme.png, doc/images/vertical-split-theme.png:
	  Document how themes work.

	* doc/aptitude.xml:
	  Document how to customize the display layout.

2004-06-29  Christian Perrier <bubulle@debian.org>

	* Updated Japanese translation
	* Update Japanese help file

2004-06-29  Daniel Burrows  <dburrows@debian.org>

	* src/load_pkgview.cc:
	  Use "top" and "bottom" for vertical alignment, not "left"
	  and "right".

	* doc/aptitude.xml, doc/images/become-root-snapshot.png, doc/images/broken-snapshot.png, doc/images/expand-once-snapshot.png, doc/images/expand-thrice-snapshot.png, doc/images/expand-twice-snapshot.png, doc/images/info-snapshot.png, doc/images/install-snapshot.png, doc/images/limit-result-snapshot.png, doc/images/limit-snapshot.png, doc/images/menu-snapshot.png, doc/images/preview-snapshot.png, doc/images/search-snapshot.png, doc/images/start-snapshot.png, doc/images/update-snapshot.png:
	  Update the screenshots to reflect the new appearance of aptitude;
	  made some minor editorial changes at the same time.

	* src/pkg_columnizer.cc:
	  Add a space between the two versions in the package display
	  format.

	* doc/aptitude.xml:
	  Quote rationalization: changed all double-quotes in the text
	  to <quote>...</quote>, and changed all double-quotes in tags
	  to single-quotes (except where doing so was impossible).

2004-06-25  Christian Perrier <bubulle@debian.org>

	* Regenerate aptitude.pot and update po files
	* Updated French translation
	* Updated Dutch translation
	* Updated Czech translation. Closes: #256326

2004-06-24  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.css:
	  Shade <cmdsynopsis> elements.

	* doc/aptitude.xml:
	  Document how to customize the program's colors.

	* src/mine/cmine.cc, src/vscreen/vscreen.cc, src/vscreen/vs_minibuf_win.h:
	  Expunge remaining references to ScreenBackgroundColor.

	* doc/aptitude.xml:
	  Document a few more useful command-line actions in the tutorial
	  section.

	* doc/aptitude.xml:
	  Make sure that all sections and chapters (that are written) have
	  introductory text, so we don't have bare tables of contents sitting
	  around.  Changed the enumeration of basic aptitude command-line
	  actions from an ordered list to a variable list.

	* doc/aptitude-html.xsl:
	  Chunk even more aggressively, and generate more local
	  tables of contents.

	* doc/aptitude-common.xsl, doc/aptitude-html.xsl:
	  Chunk the documentation more aggressively, so the individual
	  pages don't get so huge.

	* doc/aptitude.xml:
	  Add entries for a number of missing keys; editorially change
	  a preposition in the description of grouping policies; move
	  the Minesweeper seection to the toplevel and give it an ID;
	  add a section to document display layout customization.

	* src/mine/cmine.cc:
	  Change the default load/save bindings to S and L (so they
	  don't collide with the directional bindings).

	* src/download_bar.cc:
	  Expunge references to ExitScreen.

	* src/download_screen.cc, src/vscreen/vscreen.cc:
	  Expunge references to AbortScreen.

2004-06-23  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  Exhaustively document menu commands.

	* doc/aptitude.xml:
	  Add cross-references from the list of bindings to the list
	  of package commands.  Add Purge to the list of bindings.

	* doc/aptitude.xml:
	  Add a <thead> to the list of package commands.

	* doc/aptitude.css:
	  Add some subtle background shading to admonitions.

	* doc/aptitude.xml:
	  Document how to configure keybindings.

	* src/vscreen/config/keybindings.cc:
	  Add a hack for binding to commas, since the frontend parsing
	  doesn't handle them cleanly and I can't easily fix it.

	* src/ui.cc, src/pkg_node.cc, src/vscreen/vscreen.cc, src/vscreen/config/keybindings.h, src/vscreen/vs_text_layout.cc, src/vscreen/vs_table.cc, src/vscreen/vs_menubar.cc:
	  Fix a number of incorrect initializations of keybindings objects
	  (they were using "new keybindings(global_bindings)" instead of
	   "new keybindings(&global_bindings)"), make the copy constructor
	  of keybindings private so it doesn't accidentally get invoked,
	  and make sure that *all* the keybinding domains get loaded.

	* src/vscreen.cc, src/vscreen/vs_text_layout.cc, src/vscreen/vs_text_layout.h:
	  Add a keybinding domain for the vs_text_layout widget.

2004-06-16  Christian Perrier <bubulle@debian.org>

	* Updated Italian translation
	* Updated Basque translation #244858
		  
2004-06-21  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  Use <keycombo> for the Control-u "undo" shortcut.

	* doc/aptitude.xml:
	  Document sorting policies.

	* doc/Makefile.am, doc/aptitude-txt.sed:
	  sed is the wrong way to handle "bad" entities; don't use it
	  for now.

	* doc/Makefile.am, doc/aptitude-txt.style, doc/aptitude-txt.sed:
	  Use html2text, not links, to generate the text output.

2004-06-16  Christian Perrier <bubulle@debian.org>

	* Updated German translation. #255396
		  
2004-06-20  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.css, doc/aptitude-html.xsl, doc/Makefile.am:
	  Added a basic CSS stylesheet (the initial values are partly
	  borrowed from Subversion).  The current stylesheet just puts
	  borders around "tip" et al, and stripes alternate rows of
	  tables.

	* doc/aptitude-txt.xsl, doc/Makefile.am:
	  Added some basic magick to output a text version of the
	  documentation.  Unfortunately, the DocBook people seem to
	  believe that it should be as difficult as possible to get
	  a sensible text version of your document. :-(

	* doc/aptitude.xsl, doc/aptitude-html.xsl, doc/Makefile.am:
	  Rename aptitude.xsl to aptitude-html.xsl.

	* doc/aptitude.xsl, doc/aptitude-common.xsl:
	  Add a common stylesheet, holding variables for all stylesheets.

	* doc/aptitude.xml:
	  Add a legalnotice with the GPL boilerplate text after
	  s/program/manual/.

	* doc/aptitude.xml:
	  Clarify that %n outputs the version of the program, not just
	  0.2.15.

	* doc/aptitude.xml:
	  Add a link to a tutorial on regular expressions.

	* doc/aptitude.xsl:
	  Display segmentedlists as tables.

	* doc/aptitude.xml:
	  Document the display formatting system, change the version
	  of the vprogram as given in the internal subset, add a basic
	  copyright notice, and move some lists of stuff into figures
	  for cross-referencing.

	* src/pkg_columnizer.cc:
	  Remove an unnecessary, and probably harmful, # in the default
	  format string.

	* src/ui.cc:
	  Menus in aptitude are now exactly the minimum size.

	* src/vscreen/vs_menu.cc:
	  Really fix the calculation of minimum menu size.

	* src/vscreen/testvscreen.cc:
	  Menus in the test program are now exactly as large as necessary.

	* src/vscreen/vs_menubar.cc:
	  Handle placing menus in narrow screens more gracefully.

	* src/vscreen/vs_menu.cc:
	  Make sure that menus are always wide enough to display shortcuts.

	* doc/aptitude.xml:
	  Write the section on search patterns, start an FAQ, and add some
	  missing cross-references.

	* po/zh_TW.po:
	  Fix two msgstrs that didn't match the formatting of the
	  corresponding msgid (Taiwanese people are probably very
	  confused about why their aptitudes are going to use or
	  free huge amounts of disk space, and why it's always
	  given in bytes...)

	* po/fi.po:
	  Somehow this didn't have a Language-Team header, which caused
	  'make' to fail (but not until after the last commit?!).
	  Added one.

	* doc/Makefile.am:
	  Fix installation of documentation.

	* intl/ m4/ po/remove-potcdate.sin po/quot.sed po/Rules-quot po/insert-header.sin po/Makevars po/en@quot.header po/en@boldquot.header po/boldquot.sed src/mine/Makefile.am src/generic/Makefile.am src/vscreen/config/Makefile.am src/vscreen/Makefile.am src/Makefile.am configure.ac ABOUT-NLS:
	  Re-run gettextize, largely to fix the fact that 'make install'
	  is broken.

2004-06-19  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  First crack at documentation of how automatically installed
	  packages work.

2004-06-18  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  More documentation work...getting closer...

	* src/reason_fragment.cc:
	  Be more aggressive about showing Providing packages: for a
	  Conflicts, show any package that is currently installed or will be
	  installed; for a Depends, show all packages.

2004-06-16  Christian Perrier <bubulle@debian.org>

	* Re-Updated Lithuanian translation
	* Updated Japanese translation
		  
2004-06-16  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  And it's <guimenuitem>, not <menuitem> (why didn't nxml catch these?)

	* doc/aptitude.xml:
	  Whoops, it's <replaceable>, not <replacable>.

	* doc/aptitude.xml:
	  Document that you can create a view with the "categorical browser"
	  option, and only say that aptitude explains why brokenness
	  occurs (not that it suggests a solution).

	* src/ui.cc:
	  Just disable use of the non-hierarchical view for now; it's too
	  broken. (Debian bugs #120978, #144079, #144083, #151437, #242397)

	* doc/aptitude.xml:
	  Write more sections.

	* src/cmdline.cc:
`	  Show ORed dependencies properly in "aptitude show"
	  (Debian bug #254740).

	* doc/aptitude.xml:
	  Editing, and write another section.

2004-06-16  Christian Perrier <bubulle@debian.org>

	* Updated Simplified Chinese translation
	* Updated Lithuanian translation
		  
2004-06-15  Daniel Burrows  <dburrows@debian.org>

	* doc/aptitude.xml:
	  Write an introduction for the Reference Guide.

	* doc/aptitude.xsl:
	  Really chunk sections separately.

	* doc/Makefile.am, doc/aptitude.xsl:
	  Really enable the navigation images.

	* doc/aptitude.xml:
	  Make sure that <screen> and </screen> tags are flush against
	  the verbatim stuff, so that stray newlines don't creep into
	  the documentation.

	* doc/Makefile.am, doc/aptitude.xsl:
	  Add an XSL stylesheet for the documentation.

2004-06-15  Christian Perrier <bubulle@debian.org>

	* Regenerate aptitude.pot and update po files
	* Updated french translation
	* Updated spanish translation
	* Updated dutch translation
		  
2004-06-14  Daniel Burrows  <dburrows@debian.org>

	* src/aptitude.h, src/pkg_grouppolicy.cc, src/generic/tasks.cc:
	  Apply (with small modifications) patch from Denis Barbier to
	  translate task descriptions.  It doesn't seem to cause
	  regressions for English; I can't test the translation, but I
	  assume it works.  (Debian bug #203725)

	* configure.ac:
	  Tell configure about bs so aptitude compiles.

	* src/cmdline.cc, src/cmdline.h, src/main.cc:
	  Add a --visual-preview option, which pops into the visual
	  interface in the preview step. (Debian bug #253335)

	* src/cmdline.cc:
	  Don't display the Essential warning/prompt if the user cancelled
	  the removal. (Debian bug #254422)

2004-06-14  Christian Perrier <bubulle@debian.org>

	* Dutch translation update
	* Basque translation update
		  
2004-06-13  Christian Perrier <bubulle@debian.org>

	* Polish translation update
	* Brazilian Portuguese translation update
	* Partial Bosnian translation added
	* Updated German translation, help page and man page
	* Updated Makefile to install German translations
	* Italiann translation updated
		  
2004-06-10  Christian Perrier <bubulle@debian.org>

	* Czech translation update
		  
2004-06-09  Christian Perrier <bubulle@debian.org>

	* Regenerate aptitude.pot and update po files
	* Updated french translation
		  
2004-06-11  Daniel Burrows  <dburrows@debian.org>

	* src/cmdline.cc:
	  When mentioning packages that contain a string, don't show pure
	  virtual packages unless something Provides them.

	* src/ui.cc:
	  Disable the Next/Previous View commands if no other views
	  are visible.  Disable Close if no view is visible.

	* src/ui.cc:
	  Disable the Undo command if no undos are available.

	* src/ui.cc:
	  Move the Undo menu left several slots.

2004-06-09  Daniel Burrows  <dburrows@debian.org>

	* src/ui.cc:
	  Disable the "become root" menu item if the user is already root.

	* src/vscreen/vs_menu.cc:
	  Don't crash if the first item in the menu is disabled.

	* src/ui.cc:
	  Disable the update/install menu items if an update or install
	  is already taking place.

	* src/ui.cc:
	  Disable the "forget new packages" menu item if no packages are new.

	* src/generic/aptcache.cc:
	  Don't count pure virtual packages as "new".

	* src/generic/aptcache.cc, src/generic/aptcache.h:
	  Add support for counting the number of "new" packages.

	* src/vscreen/vs_menu.cc:
	  Only respond to mouse presses when a selectable (enabled) menu
	  item is clicked on.

	* src/pkg_tree.cc, src/pkg_tree.h:
	  In package lists, allow the user to limit the display.

	* src/vscreen/vs_menu.cc:
	  Fix the movement commands in a menu to more correctly handle
	  menus that mix enabled and non-enabled items.

	* src/menu_redirect.h, src/pkg_tree.cc, src/pkg_tree.h, src/pkg_view.cc, src/ui.cc, src/ui.h:
